<?php
    require_once KCONFIG . '/classes/classKGatewayUtil.php';

    $AjaxFunctions['showRoutesGW'] = 'showRoutesGW';
    $AjaxFunctions['newRouteGW'] = 'newRouteGW';
    $AjaxFunctions['saveRouteGW'] = 'saveRouteGW';
    $AjaxFunctions['removeRouteGW'] = 'removeRouteGW';
    $AjaxFunctions['routesOrder'] = 'routesOrder';

    function showRoutesGW( $_REQUEST )
    {
        $app = KSystem::getInstance( );

        $buffer = '';

        $kyaml = new KYaml( GatewayUtil::getGatewayConfigPath( ) );
        $yaml = $kyaml->getYaml( );

        $buffer .= "<fieldset><legend>{$app->translate( 'Routes' )}</legend><div id='RoutesDivTable'>";
        $buffer .= "<input type='button' value='{$app->translate( 'newRoute' )}' onClick='newRoute();' /><br /><br />";

        if( count( array_values( $yaml['Routes'] ) ) > 0 )
        {
            $buffer .= '<div id=\'gateway-route-list\'>';
            $buffer .= "<table id='RoutesTable' class='gateway-table'>";
            $buffer .= "<caption align='bottom'>{$app->translate( 'routesOrder' )}</caption>";
            $buffer .= "<thead><tr><th>{$app->translate( 'name' )}</th>";
            $buffer .= "<th>{$app->translate( 'OriginNAP' )}</th>";
            $buffer .= "<th>{$app->translate( 'numberB' )}</th>";
            $buffer .= "<th>{$app->translate( 'DestinationNAP' )}</th>";
            $buffer .= "<th>{$app->translate( 'changingNumberB' )}</th>";
            $buffer .= "<th class='gateway-table-options'>{$app->translate( 'Options' )}</th>";
            $buffer .= '</tr></thead><tbody>';
            foreach( $yaml['Routes'] as &$route )
            {
                $origin = $route['OriginNAP'] == '<ANY>' ? $app->translate( 'gateway-route-any' ) : $route['OriginNAP'];
                $destination = $route['DestinationNAP'] == '<ANY>' ? $app->translate( 'gateway-route-any' ) : $route['DestinationNAP'];
                $buffer .= "<tr><td>{$route['Name']}</td><td>{$origin}</td><td>{$route['Called']}</td><td>{$destination}</td><td>{$route['RemapCalled']}</td>";
                $buffer .= "<td class='gateway-table-options'><a href='#' onClick='editRouteGW(\"{$route['Name']}\");'><img border='0' src='/imagens/editark.gif' /></a><a href='#' onClick='removeRouteGW(\"{$route['Name']}\");'><img border='0' src='/imagens/lixeira.gif'/></td>";
                $buffer .= '</tr>';
            }
            $buffer .= '</tbody></table><br />';

            $buffer .= '</div>';
        }
        else
        {
            $buffer .= $app->translate( 'noRoutes' );
        }
        $buffer .= '</div></fieldset>';
        return $buffer;
    }

    function saveRouteGW( $_REQUEST )
    {
        Global $sistema;

        $id = isset( $_REQUEST['id'] ) ? $_REQUEST['id'] : NULL;
        $pos = isset( $_REQUEST['RoutePos'] ) ? $_REQUEST['RoutePos'] : NULL;
        $data = isset( $_REQUEST['data'] ) ? $_REQUEST['data'] : NULL;

        if( isset( $data ) )
        {
            $routeTMP = array( );
            $arrData = explode( '|', $data );

            foreach( $arrData as $campoValor )
            {
                $arrCV = explode( '=', $campoValor );
                $arrCV[1] == 'any' ? $arrCV[1] = '<ANY>' : $x++;
                $arrCV[1] == 'none' ? $arrCV[1] = '!' : $x++;
                $routeTMP[$arrCV[0]] = $arrCV[1];
            }
            $kyaml = getConfigGW( );
            $yaml = $kyaml->getYaml( );

            $newRoute = $id == '' ? true : false;

            if( $newRoute )
            {
                for( $i = 0; $i < sizeof( $yaml['Routes'] ); $i++ )
                {
                    if( $yaml['Routes'][$i]['Name'] == $routeTMP['Name'] )
                        return 'nok|' . $sistema->retTranslate( 'NameAlreadyUsed' );
                }
                $qtdeRoutes = $yaml['Routes'] == '' ? 0 : sizeof( $yaml['Routes'] );
                $kyaml->createAddValue( $qtdeRoutes, "Routes", $routeTMP );
            }
            else
                $kyaml->changeVarValue( $pos, $routeTMP, 'Routes' );

            $kyaml->saveYaml( );
            return "ok|" . $sistema->retTranslate( 'RouteSuccessfully' );
        }
    }

    function searchRouteByName( $value )
    {
        $kyaml = getConfigGW( );
        $yaml = $kyaml->getYaml( );
        for( $i = 0; $i < sizeof( $yaml['Routes'] ); $i++ )
        {
            if( $yaml['Routes'][$i]['Name'] == $value )
                return $r = array( 'pos' => $i, 'route' => $yaml['Routes'][$i] );
        }
        return '';
    }

    function newRouteGW( $_REQUEST )
    {
        global $sistema;
        $app = KSystem::getInstance( );

        $name = isset( $_REQUEST['name'] ) ? $_REQUEST['name'] : NULL;
        $kyaml = getConfigGW( );
        $yaml = $kyaml->getYaml( );

        if( isset( $name ) || $name != '' )
        {
            $ret = searchRouteByName( $name );
            $route = $ret['route'];
            $pos = $ret['pos'];
        }
        else
        {
            $route = array( 'Name' => '', 'OriginNAP' => '', 'Called' => '', 'Caller' => '', 'RemapCalled' => '', 'RemapCaller' => '', 'DestinationNAP' => '', 'Time' => '', 'CodecProfile' => '' );
            $pos = '';
        }

        $buffer = '';
        $buffer .= '<table>';
        $buffer .= '<tr>';
        $buffer .= "<td style='text-align: left;'>" . $sistema->retTranslate( 'name' ) . ": </td>";
        $buffer .= "<td><input style='width: 155px;' id='routeName' type='text' value='" . $route['Name'] . "' /></td>";
        $buffer .= '</tr>';

        $buffer .= '<tr>';
        $buffer .= "<td style='text-align: left;'>" . $sistema->retTranslate( 'OriginNAP' ) . ': ';
        $buffer .= "<img border='0' onmouseout='hideKhompChanToolTip();' onmouseover=\"showKhompChanToolTip(event, '" . $sistema->retTranslate( 'tooltip-OriginNAP' ) . "');\" src='../imagens/tooltip.png'>";
        $buffer .= "</td>";

        $naps = &$yaml['NAPs'];

        $opts = '';

        $buffer .= "<td><select id='originNAP' style='width: 155px;'>";

        if( !isset( $name ) || $name == '' )
            $buffer .= "<option value='Selecione'>" . $sistema->retTranslate( 'Select' ) . "</option>";
        foreach( $naps as $nap )
        {
            $selected = $nap['Name'] == ($route['OriginNAP']) ? ' selected' : '';
            $opts .= "<option value='{$nap['Type']}:{$nap['Name']}'{$selected}>{$nap['Name']}</option>";
        }
        $buffer .= $opts;

        $anySel = ($route['OriginNAP']) == '<ANY>' ? 'selected' : '';
        $buffer .= "<option $anySel value='any'>&lt;" . $sistema->retTranslate( 'any' ) . "&gt;</option>";
        $buffer .= '</select></td>';
        $buffer .= '</tr>';

        $buffer .= '<tr>';
        $buffer .= "<td style='text-align: left;'>" . $sistema->retTranslate( 'numberB' ) . ': ';
        $buffer .= "<img border='0' onmouseout='hideKhompChanToolTip();' onmouseover=\"showKhompChanToolTip(event, '" . $sistema->retTranslate( 'tooltip-numberB' ) . "');\" src='../imagens/tooltip.png'>";
        $buffer .= "</td>";
        $buffer .= "<td><input style='width: 155px;' id='called' type='text' value='" . ($route['Called']) . "' /></td>";
        $buffer .= '</tr>';

        $buffer .= '<tr>';
        $buffer .= "<td style='text-align: left;'>" . $sistema->retTranslate( 'numberA' ) . ": ";
        $buffer .= "<img border='0' onmouseout='hideKhompChanToolTip();' onmouseover=\"showKhompChanToolTip(event, '" . $sistema->retTranslate( 'tooltip-numberA' ) . "');\" src='../imagens/tooltip.png'>";
        $buffer .= "</td>";
        $buffer .= "<td><input style='width: 155px;' id='caller' type='text' value='" . ($route['Caller']) . "' /></td>";
        $buffer .= '</tr>';

        $buffer .= '<tr>';
        $buffer .= "<td style='text-align: left;'>" . $sistema->retTranslate( 'DestinationNAP' ) . ": ";
        $buffer .= "<img border='0' onmouseout='hideKhompChanToolTip();' onmouseover=\"showKhompChanToolTip(event, '" . $sistema->retTranslate( 'tooltip-destinationNAP' ) . "');\" src='../imagens/tooltip.png'>";
        $buffer .= "<td><select id='destinationNAP' style='width: 155px;'>";

        if( !isset( $name ) || $name == '' )
            $buffer .= "<option value='Selecione'>" . $sistema->retTranslate( 'Select' ) . "</option>";
        $opts = '';
        foreach( $naps as $nap )
        {
            $selected = $nap['Name'] == ($route['DestinationNAP']) ? ' selected' : '';
            $opts .= "<option value='{$nap['Type']}:{$nap['Name']}'{$selected}>{$nap['Name']}</option>";
        }
        $buffer .= $opts;
        $buffer .= '</select></td>';
        $buffer .= '</tr>';

        $buffer .= '<tr>';
        $buffer .= "<td style='text-align: left;'>" . $sistema->retTranslate( 'changingNumberB' ) . ": ";
        $buffer .= "<img border='0' onmouseout='hideKhompChanToolTip();' onmouseover=\"showKhompChanToolTip(event, '" . $sistema->retTranslate( 'tooltip-changingNumberB' ) . "');\" src='../imagens/tooltip.png'>";
        $buffer .= "</td>";
        $buffer .= "<td><input style='width: 155px;' id='remapCalled' type='text' value='" . ($route['RemapCalled']) . "' /></td>";
        $buffer .= '</tr>';

        $buffer .= '<tr>';
        $buffer .= "<td style='text-align: left;'>" . $sistema->retTranslate( 'changingNumberA' ) . ": ";
        $buffer .= "<img border='0' onmouseout='hideKhompChanToolTip();' onmouseover=\"showKhompChanToolTip(event, '" . $sistema->retTranslate( 'tooltip-changingNumberA' ) . "');\" src='../imagens/tooltip.png'>";
        $buffer .= "</td>";
        $buffer .= "<td><input style='width: 155px;' id='remapCaller' type='text' value='" . ($route['RemapCaller']) . "' /></td>";
        $buffer .= '</tr>';

        $buffer .= '<tr>';
        $buffer .= "<td style='text-align: left;'>" . $sistema->retTranslate( 'TimeRestraints' ) . ": ";
        $buffer .= "<img border='0' onmouseout='hideKhompChanToolTip();' onmouseover=\"showKhompChanToolTip(event, '" . $sistema->retTranslate( 'tooltip-timeRestraints' ) . "');\" src='../imagens/tooltip.png'>";
        $buffer .= "<td><select id='time' style='width: 155px;'>";

        $noneSel = ($route['Time']) == '<NONE>' ? 'selected' : '';
        $buffer .= "<option $noneSel value='none'>&lt;" . $sistema->retTranslate( 'none' ) . "&gt;</option>";

        $timeRestraints = &$yaml['TimeRestraints'];
        $opts = '';

        foreach( $timeRestraints as $TR )
        {
            $selected = $route['Time'] == $TR['Name'] ? ' selected' : '';
            $opts .= "<option value='{$TR['Name']}' {$selected}>{$TR['Name']}</option>";
        }
        $buffer .= $opts;

        $buffer .= '</select></td>';
        $buffer .= '</tr>';

        // Per route codec profile
        $buffer .= "<tr id='gateway-routes-codec-profile-list' style='display: none;'><td style='text-align: left;'>{$app->translate( 'gateway-route-codec-profile' )}:</td><td>";
        $buffer .= '<select id=\'gateway-routes-codec-profile\' style=\'width: 155px;\'>';
        if( !array_key_exists( 'CodecProfile', $route ) || $route['CodecProfile'] == '' )
        {
            $buffer .= "<option value='<SELECT>'>{$app->translate( 'Select' )}</option>";
        }

        foreach( $yaml['CodecProfiles'] as $profile )
        {
            $codecs = implode( ',', $profile['CodecList'] );
            $selected = $route['CodecProfile'] == $profile['Name'] ? ' selected=\'selected\'' : '';
            $buffer .= "<option value='{$profile['Name']}'{$selected}>{$profile['Name']} ({$codecs})</option>";
        }
        $buffer .= '</select></td></tr>';

        $buffer .= '</table>';
        $buffer .= "<input type='hidden' id='RouteId' value='{$route['Name']}' />";
        $buffer .= "<input type='hidden' id='RoutePos' value='{$pos}' /><br />";
        $buffer .= "<input type='button' onclick='saveRouteGW();' value='{$app->translate( 'save' )}' />";
        $buffer .= "<input type='button' onclick='backRoutesGW();' value='{$app->translate( 'back' )}' />";

        return $buffer;
    }

    function removeRouteGW( $_REQUEST )
    {
        Global $Sistema;

        $name = isset( $_REQUEST['name'] ) ? $_REQUEST['name'] : NULL;

        if( isset( $name ) )
        {
            $kyaml = getConfigGW( );
            $yaml = $kyaml->getYaml( );

            for( $i = 0; $i < sizeof( $yaml['Routes'] ); $i++ )
            {
                if( $yaml['Routes'][$i]['Name'] == $name )
                    unset( $yaml['Routes'][$i] );
            }
            //reorder
            $tmpArr = array( );
            foreach( $yaml['Routes'] as $route )
                $tmpArr[] = $route;
            $kyaml->yaml['Routes'] = $tmpArr;

            $kyaml->saveYaml( );
        }
    }

    function routesOrder( )
    {
        $order = isset( $_POST['order'] ) ? $_POST['order'] : null;
        if( !is_null( $order ) )
        {
            $kyaml = getConfigGW( );
            $yaml = $kyaml->getYaml( );
            $newOrder = array( );
            foreach( $order as $routeName )
            {
                foreach( $yaml['Routes'] as $route )
                {
                    if( $route['Name'] == $routeName )
                    {
                        $newOrder[] = $route;
                        break;
                    }
                }
            }
            $kyaml->yaml['Routes'] = $newOrder;
            $kyaml->saveYaml( );
            return true;
        }
        return false;
    }
