<?php
    require_once KCONFIG . '/classes/classKCadences.php';

    $AjaxFunctions['showProfiles'] = 'showProfiles';
    $AjaxFunctions['copyProfile'] = 'copyProfile';
    $AjaxFunctions['resetProfile'] = 'resetProfile';
    $AjaxFunctions['editProfile'] = 'editProfile';
    $AjaxFunctions['removeProfile'] = 'removeProfile';
    $AjaxFunctions['createProfile'] = 'createProfile';
    $AjaxFunctions['showLinksE1'] = 'showLinksE1';
    $AjaxFunctions['showCallProgressOptions'] = 'showCallProgressOptions';
    $AjaxFunctions['showCadence'] = 'showCadence';

    $AjaxFunctions['saveLinksE1'] = 'saveLinksE1';
    $AjaxFunctions['saveCallProgressOptions'] = 'saveCallProgressOptions';
    $AjaxFunctions['saveCadences'] = 'saveCadences';

    $AjaxFunctions['getTimeSlot'] = 'getTimeSlot';
    $AjaxFunctions['showGeneral'] = 'showGeneral';
    $AjaxFunctions['saveGeneral'] = 'saveGeneral';

    function showProfiles( $_REQUEST )
    {
        global $sistema;
        $app = KSystem::getInstance( );

        $configDir = $sistema->getConfigDir( );
        $buff = '';

        $buff .= "<div id='Profiles'>";
        $buff .= "<fieldset>";
        $buff .= "<legend>{$app->translate( 'Profiles' )}</legend>";

        $defaultProfiles = array( 'R2', 'OpenR2', 'ISDN', 'ISUP', 'ISUPPassive', 'ISDNNetwork', 'ISDNPassive', 'GSM', 'FXS', 'LineSide', 'CASEL7', 'E1LC', 'FXO' );
        $profilesYAML = new KYaml( $configDir . "/profiles.yaml" );
        $profiles = $profilesYAML->getYaml( );
        $CGProfilesSize = sizeof( $profiles['ChannelGroupProfiles'] );

        $buff .= "<span id='CGProfiles'>";
        $buff .= "<table border='1'>";
        $buff .= "<th width='40%'>" . $sistema->retTranslate( 'name' ) . "</th>";
        $buff .= "<th width='40%'>" . $sistema->retTranslate( 'type' ) . "</th>";
        $buff .= "<th width='20%'>" . $sistema->retTranslate( 'operation' ) . "</th>";

        for( $x = 0; $x < $CGProfilesSize; $x++ )
        {
            $class = (fmod( $x, 2 ) == 0) ? "class='green'" : "class='lgreen'";
            $ProfileKeys = array_keys( $profiles['ChannelGroupProfiles'][$x] );

            $buff .= "<tr $class>";
            $buff .= "<td style='border: 1px solid #DDDDDD;'>" . $ProfileKeys[0] . "</td>";
            $buff .= "<td style='border: 1px solid #DDDDDD;'>" . $profiles['ChannelGroupProfiles'][$x][$ProfileKeys[0]]['Type'];
            $buff .= "</td>";

            $buff .= "<td>";
            if( $ProfileKeys[0] != "ISUP" && $ProfileKeys[0] != "ISUPPassive" )
            {
                $buff .= "<a href='#' onclick=\"javascript:editProfile('$ProfileKeys[0]')\">" . $sistema->retTranslate( 'edit' ) . "</a>";
                $buff .= " - <a href='#' onclick=\"javascript:copyProfile('$ProfileKeys[0]')\">" . $sistema->retTranslate( 'copy' ) . "</a>";
                if( !in_array( $ProfileKeys[0], $defaultProfiles ) )
                    $buff .= " - <a href='#' onclick=\"javascript:removeProfile('$ProfileKeys[0]')\">" . $sistema->retTranslate( 'remove' ) . "</a>";
            }
            else
                $buff .= ' - ';

            $buff .= "</td>";
            $buff .= "</tr>";
        }
        $buff .= "</table>";
        $buff .= "</span>";

        $buff .= "</fieldset>";
        $buff .= "<br>";
        $buff .= "<input id='bResetProfiles' type='button' onclick='javascript: resetProfiles();' value='Restaurar os profiles default'>";
        $buff .= "</div>";

        return $buff;
    }

    function removeProfile( $_REQUEST )
    {
        Global $sistema;
        $name = isset( $_REQUEST['name'] ) ? $_REQUEST['name'] : NULL;

        if( isset( $name ) )
        {
            $Profiles = new KProfiles( );
            $position = $Profiles->getProfilePosition( $name );
            $Profiles->profilesYaml->deleteVar( $position, "ChannelGroupProfiles" );
            $profilesData = $Profiles->profilesYaml->getYaml( );
            $keys = array_keys( $profilesData['ChannelGroupProfiles'] );

            for( $i = 0; $i < sizeof( $keys ); $i++ )
                $profiles['ChannelGroupProfiles'][] = $profilesData['ChannelGroupProfiles'][$keys[$i]];

            $Profiles->profilesYaml->yaml = $profiles;
            $Profiles->saveProfiles( );

            removeDeletedProfileFromLinks( $name );

            return $sistema->retTranslate( 'ConfiguracaoSalva' );
        }
    }

    function copyProfile( $_REQUEST )
    {
        $name = isset( $_REQUEST['name'] ) ? $_REQUEST['name'] : NULL;
        if( isset( $name ) )
        {
            $Profiles = new KProfiles( );
            $profile = $Profiles->getProfile( $name );
            $type = $profile[$name]['Type'];
            $subType = $profile[$name]['SubType'];
            $return = printProfile( $profile, $type, $name, $subType );

            return $return;
        }
    }

    function resetProfile( $_REQUEST )
    {
        Global $sistema;

        $Profiles = new KProfiles( );
        $Profiles->resetDefaultProfiles( );
        return $sistema->retTranslate( 'ProfileReseted' );
    }

    function editProfile( $_REQUEST )
    {
        $app = KSystem::getInstance( );
        $name = isset( $_REQUEST['name'] ) ? $_REQUEST['name'] : NULL;
        if( isset( $name ) )
        {
            $Profiles = new KProfiles( );
            $profile = $Profiles->getProfile( $name );
            $type = $profile[$name]['Type'];
            $subType = isset( $profile[$name]['SubType'] ) ? $profile[$name]['SubType'] : '';
            $buff = '';
            $buff .= "<fieldset>";
            $buff .= "<legend>{$app->translate( 'Profiles' )}</legend>";
            $buff .= printProfile( $profile, $type, $name, $subType, $name );
            $buff .= "</fieldset>";

            return $buff;
        }
    }

    function createProfile( $_REQUEST )
    {
        Global $sistema;

        $data = isset( $_REQUEST['data'] ) ? $_REQUEST['data'] : NULL;
        $type = isset( $_REQUEST['type'] ) ? $_REQUEST['type'] : NULL;
        $action = isset( $_REQUEST['action'] ) ? $_REQUEST['action'] : NULL;

        if( isset( $data ) && isset( $type ) && isset( $action ) )
        {
            $data = explode( ',', $data );
            $variables = array( );

            foreach( $data as $d )
            {
                $tmp = array( );
                $tmp = explode( ':', $d );
                $variables[$tmp[0]] = $tmp[1];
            }

            $newProfile = $action == 'copy' ? true : false;
            switch($type)
            {
                case 'R2':
                    $return = createR2( $variables, $newProfile );
                    break;

                case 'ISDN':
                    $return = createIsdn( $variables, $newProfile );
                    break;

                case 'GSM':
                    $return = createGSM( $variables, $newProfile );
                    break;

                case 'FXS':
                    $return = createFXS( $variables, $newProfile );
                    break;

                case 'LineSide':
                    $return = createLineSide( $variables, $newProfile );
                    break;

                case 'FXO':
                    $return = createFXO( $variables, $newProfile );
                    break;

                default:
                    return 'No action.';
                    break;
            }
        }
        if( $return )
            return '1|' . $sistema->retTranslate( 'ConfiguracaoSalva' );
        else
            return '0|' . $sistema->retTranslate( 'nameAlreadyUsed' );
    }

    function showLinksE1( $_REQUEST )
    {
        Global $sistema;
        $configDir = $sistema->getConfigDir( );

        $buff = '';

        $E1Links = $sistema->getE1Links( );
        $E1LinksSize = sizeof( $E1Links );

        $buff .= "<div id='ConfigE1'>";
        if( $E1LinksSize > 0 )
        {
            $advancedTable = isset( $_REQUEST['advancedTable'] ) ? true : false;

            if( !$advancedTable )
            {
                $buff .= "<fieldset>";
                $buff .= "<legend>Links E1</legend>";
                $buff .= "<div id='ConfigE1Data'>";
                $buff .= "<table id='nadvanced'>";
                $buff .= "<tr class='first'>";
                $buff .= "<th id='first-serial'>Serial</td>";
                $buff .= "<th id='first-apelido'>" . $sistema->retTranslate( 'apelido' ) . "</th>";
                $buff .= "<th id='first-profile'>" . $sistema->retTranslate( 'Profile' ) . "</th>";
                $buff .= "<th id='first-clockValido'>" . $sistema->retTranslate( 'SynchronismClock' ) . "</th>";
                $buff .= "<th id='first-prefixo'>" . $sistema->retTranslate( 'Prefixo' ) . "</th>";
                $buff .= "<th id='first-prefixoOnIncoming'>" . $sistema->retTranslate( 'UseCentralOfficePrefixOnIncomingCalls' ) . "</th>";
                $buff .= "<th id='first-digitosEntrada'>" . $sistema->retTranslate( 'digitosEntrada' ) . "</th>";
                $buff .= "<th id='first-crc4'>" . $sistema->retTranslate( 'crc4' ) . "</th>";
                $buff .= "</tr>";
            }
            else
            {
                $buff .= "<fieldset style='width:112%; !important'>";
                $buff .= "<legend>Links E1</legend>";
                $buff .= "<div id='ConfigE1Data'>";
                $buff .= "<table id='advanced'>";
                $buff .= "<tr>";
                $buff .= "<th rowspan='2' id='first-serial'>Serial</td>";
                $buff .= "<th rowspan='2' id='first-apelido'>" . $sistema->retTranslate( 'apelido' ) . "</th>";
                $buff .= "<th rowspan='2' id='first-profile'>" . $sistema->retTranslate( 'Profile' ) . "</th>";
                $buff .= "<th rowspan='2' id='first-clockValido'>" . $sistema->retTranslate( 'SynchronismClock' ) . "</th>";
                $buff .= "<th rowspan='2' id='first-prefixo'>" . $sistema->retTranslate( 'Prefixo' ) . "</th>";
                $buff .= "<th rowspan='2' id='first-prefixoOnIncoming'>" . $sistema->retTranslate( 'UseCentralOfficePrefixOnIncomingCalls' ) . "</th>";
                $buff .= "<th rowspan='2' id='first-digitosEntrada'>" . $sistema->retTranslate( 'digitosEntrada' ) . "</th>";
                $buff .= "<th rowspan='2' id='first-crc4'>" . $sistema->retTranslate( 'crc4' ) . "</th>";
                $buff .= "<th rowspan='2'>" . $sistema->retTranslate( 'K3lR' ) . "</th>";
                $buff .= "<th rowspan='2'>" . $sistema->retTranslate( 'sensibilidadeCAS' ) . "</th>";
                $buff .= "<th colspan='3'>" . $sistema->retTranslate( 'sensibilidadeFalhas' ) . "</th>";
                $buff .= "</tr>";
                $buff .= "<tr>";
                $buff .= "<th>" . $sistema->retTranslate( 'Partida' ) . "</th>";
                $buff .= "<th>" . $sistema->retTranslate( 'Queda' ) . "</th>";
                $buff .= "<th>" . $sistema->retTranslate( 'Alarme' ) . "</th>";
                $buff .= "</tr>";
            }

            $seriais = '';

            for( $x = 0; $x < $E1LinksSize; $x++ )
            {

                $seriais .= $E1Links[$x] . ',';

                $class = (fmod( $x, 2 ) == 0) ? "class='green'" : "class='lgreen'";

                $deviceYaml = new KYaml( $configDir . "/devices.yaml" );
                $profilesYAML = new KYaml( $configDir . "/profiles.yaml" );
                $systemYAML = new KYaml( $configDir . "/system.yaml" );

                $buff .= "<tr $class>";
                $buff .= "<td >" . $E1Links[$x] . "</td>";

                $buff .= "<td >";
                $realLink = explode( '.', $E1Links[$x] );
                $way = $deviceYaml->getWay( "", $realLink[0] ) . "|" . $realLink[0];
                $multipart = $way . "|Links|" . $realLink[1] . "|" . $realLink[1];
                $default = $deviceYaml->getValue( 'Name', $multipart );
                if( $default == "!" )
                    $default = '';

                $buff .= "<input name='Name' id='Name-$E1Links[$x]' value='$default' type='text' class='nick'>";
                $buff .= "</td>";

                $buff .= "<td >";

                $profile = getProfile( $E1Links[$x], $profilesYAML );

                $parts = explode( ".", $E1Links[$x] );
                $fway = $deviceYaml->getWay( "", $parts[0] ) . "|" . $parts[0];
                $multipart = $fway . "|Links|" . $parts[1] . "|" . $parts[1];

                $default = $deviceYaml->getValue( 'Profile', $multipart );

                $buff .= "<select class='selector4' name='Profile-$E1Links[$x]' id='Profile-$E1Links[$x]'>";

                for( $i = 0; $i < sizeof( $profile ); $i++ )
                {
                    $selected = $profile[$i] == $default ? "selected" : "";
                    $buff .= "<option value='" . $profile[$i] . "' $selected>" . $profile[$i] . "</option>";
                }
                $buff .= "</select>";
                $buff .= "</td>";

                $buff .= "<td >";
                $value = $systemYAML->getValue( 'EnableLinkAsReference', 'System' );
                $buff .= "<select id='Clock-$E1Links[$x]' class='selector3' name='Clock-$E1Links[$x]'>";
                if( @ereg( $E1Links[$x], $value ) )
                {
                    $receive = "selected=''";
                    $generate = "";
                }
                else
                {
                    $generate = "selected=''";
                    $receive = "";
                }

                $subName = explode( '.', $E1Links[$x] );

                if( isPassive( $subName[0] ) )
                {
                    $buff .= "<option value='receive' $receive>" . $sistema->retTranslate( 'receive' ) . "</option>";
                }
                else
                {
                    $buff .= "<option value='receive' $receive>" . $sistema->retTranslate( 'receive' ) . "</option>";
                    $buff .= "<option value='generate' $generate >" . $sistema->retTranslate( 'generate' ) . "</option>";
                }

                $buff .= "</select>";
                $buff .= "</td>";

                $buff .= "<td >";
                $value = $systemYAML->getValue( $E1Links[$x], 'System|CentralOfficePrefix' );
                $buff .= "<input name='CentralOfficePrefix-$E1Links[$x]' id='CentralOfficePrefix-$E1Links[$x]' value='$value' type='text' class='selector'>";
                $buff .= "</td>";

                $buff .= "<td>";
                $value = $systemYAML->getValue( 'UseCentralOfficePrefixOnIncomingCalls', 'System' );
                $checked = @ereg( $E1Links[$x], $value ) ? "checked" : '';
                $buff .= "<input class='check' id='UseCentralOfficePrefixOnIncomingCalls-$E1Links[$x]' value='$E1Links[$x]' type='checkbox' $checked>";
                $buff .= "</td>";

                $buff .= "<td >";
                $value = $systemYAML->getValue( $E1Links[$x], 'System|IncomingDigitsCount' );
                $value = $value == "" ? 4 : $value;
                $buff .= "<select name='IncomingDigitsCount-$E1Links[$x]' id='IncomingDigitsCount-$E1Links[$x]' value='$value' type='text' class='selector'>";
                for( $i = 0; $i <= 20; $i++ )
                {
                    $selected = $i == $value ? "selected" : '';
                    $buff .= "<option value='$i' $selected>" . $i . "</option>";
                }
                $buff .= "</select>";
                $buff .= "</td>";

                $buff .= "<td >";
                $value = $systemYAML->getValue( 'CRC4', 'System' );
                $checked = @ereg( $E1Links[$x], $value ) ? "checked" : '';

                $buff .= "<input class='check' name='CRC4-$E1Links[$x]' id='CRC4-$E1Links[$x]' value='$E1Links[$x]' type='checkbox' $checked>";
                $buff .= "</td>";

                if( $advancedTable )
                {
                    $buff .= getK3Lr( $E1Links[$x], $x, $systemYAML );
                    $buff .= casLineValidateTime( $E1Links[$x], $x, $systemYAML );
                    $buff .= linkTimers( $E1Links[$x], $x, $systemYAML );
                    $buff .= "</tr>";
                }
                else
                    $buff .= "</tr>";
            }
            $seriais = substr( $seriais, 0, -1 );
            $buff .= "<input type='hidden' id='SeriaisE1Links' name='SeriaisE1Links' value='$seriais'/>";

            $buff .= "</table>";
            $buff .= "</div>";
            $buff .= "</fieldset>";
            $buff .= "<br>";

            if( $advancedTable )
                $buff .= "<input type='button' onclick=\"javascript:advancedConfig(false);\" value='" . $sistema->retTranslate( 'advancedConfig' ) . "'>";
            else
                $buff .= "<input type='button' onclick=\"javascript:advancedConfig(true);\" value='" . $sistema->retTranslate( 'advancedConfig' ) . "'>";

            $buff .= "<input id='saveLinksE1B' type='button' onclick=\"javascript:saveLinksE1();\" value='" . $sistema->retTranslate( 'save' ) . "'>";
        }
        else
        {
            $buff .= "<fieldset>";
            $buff .= "<legend>Links E1</legend>";
            $buff .= "<span id='ConfigE1Data'>";
            $buff .= "<input type='hidden' id='E1LinksTotal' name='E1LinksTotal' value='$E1LinksSize'/>";
            $buff .= "<table>";
            $buff .= "<tr>";
            $buff .= "<td>" . $sistema->retTranslate( 'NDeviceE1' ) . "</td>";
            $buff .= "</tr>";
            $buff .= "</table>";
            $buff .= "</span>";
        }

        return $buff;
    }

    function showCallProgressOptions( $_REQUEST )
    {
        Global $sistema;

        $buff = '';
        $configDir = $sistema->getConfigDir( );
        $sysYAML = new KYaml( $configDir . "/system.yaml" );

        $buff .= "<div id='CallProgressOption'>";
        $buff .= "<fieldset>";
        $buff .= "<legend>Call progress</legend>";

        $buff .= "<table>";
        $buff .= "<tr class='green'>";
        $buff .= "<td align='left'>" . $sistema->retTranslate( 'SilenceTimeToDisconnect' ) . "</td>";
        $buff .= "<td align='right'>";
        $SilenceTimeToDisconnect = $sysYAML->getValue( 'SilenceTimeToDisconnect' );
        $buff .= "<select id='SilenceTimeToDisconnect' name='SilenceTimeToDisconnect'>";
        for( $x = 0; $x <= 90000; $x = $x + 1000 )
        {
            $selected = "";
            if( $x == $SilenceTimeToDisconnect )
                $selected = "selected";
            $buff .= "<option value='$x' $selected>$x</option>";
        }
        $buff .= "</select>";
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr class='lgreen'>";
        $buff .= "<td align='left'>" . $sistema->retTranslate( 'AnswerTimeout' ) . "</td>";
        $buff .= "<td align='right'>";
        $AnswerTimeout = $sysYAML->getValue( 'AnswerTimeout' );
        $buff .= "<select id='AnswerTimeout' name='AnswerTimeout'>";
        for( $x = 0; $x <= 90000; $x = $x + 1000 )
        {
            $selected = "";
            if( $x == $AnswerTimeout )
                $selected = "selected";
            $buff .= "<option value='$x' $selected>$x</option>";
        }
        $buff .= "</select>";
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr class='green'>";
        $buff .= "<td align='left'>" . $sistema->retTranslate( 'VoiceAnswerThreshold' ) . "</td>";
        $buff .= "<td align='right'>";
        $VoiceAnswerThreshold = $sysYAML->getValue( 'VoiceAnswerThreshold' );
        $buff .= "<select id='VoiceAnswerThreshold' name='VoiceAnswerThreshold'>";
        for( $x = 100; $x <= 200; $x = $x + 10 )
        {
            $selected = "";
            if( $x == $VoiceAnswerThreshold )
                $selected = "selected";
            $buff .= "<option value='$x' $selected>$x</option>";
        }
        $buff .= "</select>";
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr class='lgreen'>";
        $buff .= "<td align='left'>" . $sistema->retTranslate( 'TimeForAutomaticSeizeSuccess' ) . "</td>";
        $buff .= "<td align='right'>";
        $TimeForAutomaticSeizeSuccess = $sysYAML->getValue( 'TimeForAutomaticSeizeSuccess' );
        $buff .= "<select id='TimeForAutomaticSeizeSuccess' name='TimeForAutomaticSeizeSuccess'>";
        for( $x = 0; $x <= 5000; $x = $x + 1000 )
        {
            $selected = "";
            if( $x == $TimeForAutomaticSeizeSuccess )
                $selected = "selected";
            $buff .= "<option value='$x' $selected>$x</option>";
        }
        $buff .= "</select>";
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr class='green'>";
        $buff .= "<td align='left'>" . $sistema->retTranslate( 'DedicatedLine' ) . "</td>";
        $buff .= "<td style='width:15%;' align='center'>";

        $DedicatedLine = $sysYAML->yaml['CallProgress']['DedicatedLine'] ? "checked=''" : '';
        $buff .= "<input id='DedicatedLine' $DedicatedLine class='check' type='checkbox' value='DedicatedLine' name='DedicatedLine'>";
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr class='lgreen'>";
        $buff .= "<td align='left'>" . $sistema->retTranslate( 'DetectSilenceAsAnswer' ) . "</td>";
        $buff .= "<td style='width:15%;' align='center'>";
        $DetectSilenceAsAnswer = $sysYAML->getValue( 'DetectSilenceAsAnswer' );
        $DetectSilenceAsAnswer = $sysYAML->yaml['CallProgress']['DetectSilenceAsAnswer'] ? "checked=''" : '';
        $buff .= "<input id='DetectSilenceAsAnswer' $DetectSilenceAsAnswer class='check' type='checkbox' value='DetectSilenceAsAnswer' name='DetectSilenceAsAnswer'>";
        $buff .= "</td>";
        $buff .= "</tr>";
        $buff .= "</table>";
        $buff .= "</fieldset>";
        $buff .= "</br>";
        
        $buff .= "<input id='saveCallProgressOptionsB' type='button' onclick='saveCallProgressOptions();' style='float:right;' value='" . $sistema->retTranslate( 'save' ) . "'/>";

        $buff .= "<br>";
        $buff .= "</div>";

        return $buff;
    }

    function showCadence( $_REQUEST )
    {
        Global $sistema, $image_dir;

        $buff = '';

        $buff .= "<div id='Cadences' >";
        $buff .= "<fieldset id='CPCadences'>";
        $buff .= "<legend>" . $sistema->retTranslate( 'Cadences' ) . "</legend>";

        $KCadencesObject = new KCadences( );
        $arrCadences = $KCadencesObject->getCadences( );
        $style = '';

        if( sizeof( $arrCadences ) == 0 )
        {
            $buff .= "<div id='warningCadence' style='color:red;'><p>" . $sistema->retTranslate( 'needToAddCadence' ) . "<p></div>";
            $style = "style='display:none;'";
        }

        $buff .= "<div id='warningCadence' style='color:red;display:none'><p>" . $sistema->retTranslate( 'needToAddCadence' ) . "<p></div>";

        $buff .= "<table $style id='cadenceTable'>";
        $buff .= '<tr>';
        $buff .= '<th></th>';
        $buff .= '<th>' . $sistema->retTranslate( 'type' ) . '</th>';
        $buff .= '<th>' . $sistema->retTranslate( 'name' ) . '</th>';
        $buff .= '<th>' . $sistema->retTranslate( 'Repetitions' ) . '</th>';
        $buff .= '<th>' . $sistema->retTranslate( 'Tolerance' ) . '</th>';
        $buff .= '<th>' . $sistema->retTranslate( 'Cadence' ) . '</th>';
        $buff .= '<th></th>';
        $buff .= '</tr>';

        $arrTypes = array( 0 => "Dial Tone", 1 => "Ring Back", 2 => "Busy", 3 => "Fast Busy" );

        $lastCandece = '@';
        $lastCSSClass = '';
        $qtd = 0;

        foreach( $arrCadences as $key1 => $val1 )
        {
            foreach( $val1 as $key2 => $val2 )
            {
                if( fmod( $key1, 2 ) == 0 )
                    $class = "class='green'";
                else
                    $class = "class='lgreen'";

                $lastCSSClass = 'lgreen';

                $buff .= "<tr $class id='trId_$key1'>";
                $buff .= "<td id='tdId_$key1' >";
                $buff .= "<select name='Id-$key1' id='Id-$key1' size='1' style='width:40px'>";
                foreach( range('A','Z') as $value )
                {
                    if( $value == $key2 )
                        $buff .= "<option value='$value' selected='selected'>$value</option>";
                    else
                        $buff .= "<option value='$value'>$value</option>";
                }
                $buff .= '</select>';
                $buff .= '</td>';

                $buff .= '<td>';
                $buff .= "<select name='Type-$key1' id='Type-$key1'>";
                foreach( $arrTypes as $key => $value )
                {
                    if( $key == $val2['Type'] )
                        $buff .= "<option value='$key' selected='selected'>$value</option>";
                    else
                        $buff .= "<option value='$key'>$value</option>";
                }
                $buff .= "</select>";
                $buff .= "</td>";
                $buff .= "<td>";
                $buff .= "<input class='inputText' type='text' size='20' name='Name-$key1' id='Name-$key1' value='" . $val2['Name'] . "' /></td>";
                $buff .= '<td>';
                $buff .= "<select name='Repetitions-$key1' id='Repetitions-$key1' >";
                foreach( range(1,8) as $value )
                {
                    if( $value == $val2['Repetitions'] )
                        $buff .= "<option value='$value' selected='selected'>$value</option>";
                    else
                        $buff .= "<option value='$value'>$value</option>";
                }
                $buff .= "</select>";
                $buff .= "</td>";

                $buff .= "<td>";
                $buff .= "<select name='Tolerance:-$key1' id='Tolerance-$key1' >";
                foreach( range(5,250,5) as $value )
                {
                    if( $value == $val2['Tolerance'] )
                        $buff .= "<option value='$value' selected='selected'>$value</option>";
                    else
                        $buff .= "<option value='$value'>$value</option>";
                }
                $buff .= "</select>";
                $buff .= "</td>";
                $buff .= "<td>";
                $buff .= "<input type='text' size='10' name='Cadence-$key1' id='Cadence-$key1' value='" . implode( $val2['Cadence'], "," ) . "' />";
                $buff .= "</td>";
                $buff .= "<td>";
                $buff .= "<a onClick=\"javascript:deleteCadence('$key1');\">";
                $buff .= "<img style='cursor:pointer;' src='$image_dir/imagens/lixeira.gif'/></a>";
                $buff .= "</td>";
                $buff .= "</tr>";
                $lastCandece = $key2;
            }
            $qtd++;
        }
        $buff .= "</table></br>";
        $buff .= "<input type='hidden' value='$qtd' name='cadencesQtd' id='cadencesQtd' />";
        $buff .= "<input type='hidden' value='$qtd' name='lastIndex' id='lastIndex' />";
        $buff .= "<input type='hidden' value='$lastCandece' name='lastCadence' id='lastCadence' />";
        $buff .= "<input type='hidden' value='$lastCSSClass' name='lastCSSClass' id='lastCSSClass' />";

        $buff .= "<input type='button' value='" . $sistema->retTranslate( 'addNCandece' ) . "' onClick=\"javascript:newCadenceRow(document.getElementById('cadenceTable'));\" />";
        $buff .= "<input id='saveCadencesB' type='button' style='float:right;' onclick='javascript:saveCadences();' value='" . $sistema->retTranslate( 'save' ) . "'>";
        $buff .= "</br>";

        $buff .= "</fieldset>";
        $buff .= "<br>";
        $buff .= "<input type='button' onclick='javascript:InitCadenceAssistant();' value='" . $sistema->retTranslate( 'InitCadenceAssistant' ) . "'>";

        $buff .= "<div id='dialog-modal' title='" . $sistema->retTranslate( 'CadencesAssistant' ) . "'></div>";
        $buff .= "</div>";

        return $buff;
    }

    function showGeneral( $_REQUEST )
    {
        Global $sistema;

        $buff = '';

        $buff .= "<div id='geral'>";
        $buff .= "<a class='collapsePara' onclick=\"javascript:changeArrow(this);\" href='#'>- " . $sistema->retTranslate( 'general' ) . "</a>";
        $buff .= "<fieldset>";
        $buff .= "<span id='divMfcPatternCountry'>";
        $buff .= "<table>";
        $buff .= "<tr>";
        $buff .= "<td align='left'>" . $sistema->retTranslate( 'PaisPadraoMFC' ) . "</td>";
        $buff .= "<td align='right'>";

        $buff .= "<select id='MfcPatternCountry' name='MfcPatternCountry'>";
        $arr = array( '0 - Brasil', '1 - Mexico', '2 - Argentina', '3 - Chile', '4 - Uruguai', '5 - Venezuela' );
        $configDir = $sistema->getConfigDir( );
        $sysYAML = new KYaml( $configDir . "/system.yaml" );
        $MfcPatternCountry = $sysYAML->getValue( 'MfcPatternCountry', 'System' );
        foreach( $arr as $country )
            $buff .= $MfcPatternCountry == $country ? "<option selected='' value='$country'>$country</option>" : "<option value='$country'>$country</option>";

        $buff .= "</select>";
        $buff .= "</td>";
        $buff .= "</tr>";
        $buff .= "</table>";
        $buff .= "</span>";
        $buff .= "</fieldset>";

        $buff .= "<br>";
        $buff .= "<a class='collapsePara' onclick=\"javascript:changeArrow(this);\" href='#'>- " . $sistema->retTranslate( 'FXOLineSensibility' ) . "</a>";
        $buff .= "<fieldset>";

        $FXOChannels = $sistema->getFXOChannels( );
        $FXOChannelsSize = sizeof( $FXOChannels );

        $buff .= "<span id='FXOData'>";
        $buff .= "<input type='hidden' id='FXOChannelsTotal' name='FXOChannelsTotal' value='$FXOChannelsSize'/>";
        $buff .= "<table>";

        if( $FXOChannelsSize > 0 )
        {
            $buff .= "<tr><th>" . $sistema->retTranslate( 'Device' ) . "</th>";
            $buff .= "<th>" . $sistema->retTranslate( 'Sensibility' ) . "</th></tr>";

            for( $x = 0; $x < $FXOChannelsSize; $x++ )
            {
                $class = fmod( $x, 2 ) == 0 ? "class='green'" : "class='lgreen'";

                $buff .= "<tr $class>";
                $buff .= "<td>";

                $subFXOChannels = explode( '.', $FXOChannels[$x] );
                $buff .= $subFXOChannels[0];

                $buff .= "</td>";
                $buff .= "<td>";

                $value = $sysYAML->getValue( $FXOChannels[$x], 'System|FXOLineSensibility' );

                if( $value == "yamlError" || $value == "" )
                    $value = "48";

                $buff .= printFXO( $FXOChannels[$x], $x, $subFXOChannels[0], $value );
                $buff .= "</td>";
                $buff .= "</tr>";
            }
        }
        else
            $buff .= "<tr><td>" . $sistema->retTranslate( 'NFXO' ) . "</td></tr>";

        $buff .= "</table>";
        $buff .= "</span>";
        $buff .= "</fieldset>";

        $buff .= "<br>";
        $buff .= "<a class='collapsePara' onclick=\"javascript:changeArrow(this);\" href='#'>- GSMPin</a>";
        $buff .= "<fieldset>";

        $GSMPins = $sistema->getGSMPins( );
        $GSMPinsSize = sizeof( $GSMPins );

        $buff .= "<span id='GSMPinData'>";
        $buff .= "<input type='hidden' id='GSMPinsTotal' name='GSMPinsTotal' value='$GSMPinsSize'/>";
        $buff .= "<table>";

        if( $GSMPinsSize > 0 )
        {
            $buff .= "<tr>";
            $buff .= "<th>" . $sistema->retTranslate( 'Device' ) . "</th>";
            $buff .= "<th>" . $sistema->retTranslate( 'Channel' ) . "</th>";
            $buff .= "<th>" . $sistema->retTranslate( 'Pin' ) . "</th>";
            $buff .= "</tr>";

            for( $x = 0; $x < $GSMPinsSize; $x++ )
            {
                $class = fmod( $x, 2 ) == 0 ? "class='green'" : "class='lgreen'";
                $buff .= "<tr $class>";
                $buff .= "<td>";

                $subGSMPins = explode( '.', $GSMPins[$x] );

                $buff .= $subGSMPins[0];
                $buff .= "</td>";
                $buff .= "<td>" . $subGSMPins[1] . "</td>";
                $buff .= "<td>";

                $value = $sysYAML->getValue( $GSMPins[$x], 'System|GSMPin' );

                if( $value == "yamlError" )
                    $value = "";

                $buff .= GSMPin( $GSMPins[$x], $x, $value );
                $buff .= "</td>";
                $buff .= "</tr>";
            }

        }
        else
            $buff .= "<tr><td>" . $sistema->retTranslate( 'NGSMPin' ) . "</td></tr>";

        $buff .= "</table>";
        $buff .= "</span>";

        $buff .= "</fieldset>";
        $buff .= "<br>";

        $buff .= "<input id='saveGeneralB' type='button' style='float:right' onclick='saveGeneral();' value='" . $sistema->retTranslate( 'save' ) . "' />";
        $buff .= "</div>";

        return $buff;

    }

    function saveGeneral( $_REQUEST )
    {
        Global $sistema;

        $FXOLineSensibility = isset( $_REQUEST['FXOLineSensibility'] ) ? $_REQUEST['FXOLineSensibility'] : NULL;
        $GSMPin = isset( $_REQUEST['GSMPin'] ) ? $_REQUEST['GSMPin'] : NULL;
        $MfcPatternCountry = isset( $_REQUEST['MfcPatternCountry'] ) ? $_REQUEST['MfcPatternCountry'] : NULL;

        $configDir = $sistema->getConfigDir( );
        $sysYaml = new KYaml( $configDir . "/system.yaml" );
        $yaml = $sysYaml->getYaml( );

        if( trim( $FXOLineSensibility ) != '' )
        {
            $FXOLineSensibility = explode( ',', $FXOLineSensibility );
            foreach( $FXOLineSensibility as $FXO )
            {
                $tmp = explode( ':', $FXO );
                $yaml['System']['FXOLineSensibility'][$tmp[0]] = $tmp[1];
            }
        }

        if( trim( $GSMPin ) != '' )
        {
            $GSMPin = explode( ',', $GSMPin );
            foreach( $GSMPin as $GSM )
            {
                $temp = explode( ':', $GSM );
                $yaml['System']['GSMPin'][$temp[0]] = $temp[1];
            }
        }

        if( trim( $MfcPatternCountry ) != '' )
            $yaml['System']['MfcPatternCountry'] = $MfcPatternCountry;

        $sysYaml->setYaml( $yaml );
        $sysYaml->saveYaml( );

        return $sistema->retTranslate( 'ConfiguracaoSalva' );

    }

    function GSMPin( $DeviceChannel, $number, $value = "" )
    {
        $return = '';
        $return .= "<input type='hidden' id='GSMPinA$number' name='GSMPinA$number' value='$DeviceChannel'/>";
        $return .= "<input name='GSMPinB$number' id='GSMPinB$number' value='$value' type='text' class='selector'>";
        return $return;
    }

    function saveLinksE1( $_REQUEST )
    {
        Global $sistema;
        $devices = isset( $_REQUEST['devices'] ) ? $_REQUEST['devices'] : NULL;
        $system = isset( $_REQUEST['system'] ) ? $_REQUEST['system'] : NULL;

        if( isset( $devices ) && isset( $system ) )
        {
            $configDir = $sistema->getConfigDir( );
            $deviceYaml = new KYaml( $configDir . "/devices.yaml" );
            $devices = explode( '|', $devices );
            foreach( $devices as $d )
            {
                $tmp = explode( ':', $d );
                $serial = explode( '.', $tmp[0] );
                $link = $serial[1];
                $serial = $serial[0];
                $name = $tmp[1];
                $profile = $tmp[2];
                $dev = $deviceYaml->getValue( $serial );
                $dev['Links'][$link][$link]['Name'] = $name;
                $dev['Links'][$link][$link]['Profile'] = $profile;
                $deviceYaml->changeVarValue( $serial, $dev );
            }
            $deviceYaml->saveYaml( true );
            $s = explode( '@', $system );

            foreach( $s as $sys )
            {
                $tmp = explode( "-", $sys );
                $x = explode( '.', $tmp[0] );
                $serial = $x[0];
                $link = $x[1];

                $data = $tmp[1];
                $data = explode( ',', $data );

                $configDir = $sistema->getConfigDir( );
                $systemYaml = new KYaml( $configDir . "/system.yaml" );

                foreach( $data as $d )
                {
                    $cv = explode( ':', $d );
                    switch ($cv[0])
                    {
                        case 'EnableLinkAsReference':
                            $yaml = $systemYaml->getYaml( );
                            if( $yaml['System']['EnableLinkAsReference'] != '!' && $yaml['System']['EnableLinkAsReference'] != '' )
                                $refs = explode( ',', $yaml['System']['EnableLinkAsReference'] );
                            else
                                $refs = array( );

                            $l = "{$serial}.{$link}";

                            if( $cv[1] == 'receive' )
                            {
                                if( !in_array( $l, $refs ) )
                                    $refs[] = $l;
                            }
                            else
                            {
                                if( in_array( $l, $refs ) )
                                {
                                    $key = array_search( $l, $refs );
                                    unset( $refs[$key] );
                                }
                            }
                            $arr_tmp = array( );
                            foreach( $refs as $r )
                                $arr_tmp[] = $r;

                            $size = sizeof( $arr_tmp );
                            if( $size == 0 )
                                $yaml['System']['EnableLinkAsReference'] = '!';
                            elseif( $size == 1 )
                                $yaml['System']['EnableLinkAsReference'] = $arr_tmp[0];
                            else
                                $yaml['System']['EnableLinkAsReference'] = implode( ',', $arr_tmp );

                            $systemYaml->setYaml( $yaml );

                            break;

                        case 'CentralOfficePrefix':
                            $value = $systemYaml->getValue( 'CentralOfficePrefix' );
                            if( trim( $cv[1] ) != '' )
                            {
                                $value["$serial.$link"] = $cv[1];
                                $systemYaml->changeVarValue( 'CentralOfficePrefix', $value );
                            }
                            else
                            {
                                if( isset( $value["$serial.$link"] ) )
                                    unset( $value["$serial.$link"] );
                                $systemYaml->changeVarValue( 'CentralOfficePrefix', $value );
                            }
                            break;

                        case 'IncomingDigitsCount':
                            $value = $systemYaml->getValue( 'IncomingDigitsCount' );
                            if( trim( $cv[1] ) != '' )
                            {
                                $value["$serial.$link"] = $cv[1];
                                $systemYaml->changeVarValue( 'IncomingDigitsCount', $value );
                            }
                            else
                            {
                                if( isset( $value["$serial.$link"] ) )
                                    unset( $value["$serial.$link"] );
                                $systemYaml->changeVarValue( 'IncomingDigitsCount', $value );
                            }
                            break;

                        case 'UseCentralOfficePrefixOnIncomingCalls':
                            $value = $systemYaml->getValue( 'UseCentralOfficePrefixOnIncomingCalls' );
                            if( $cv[1] == 'true' )
                            {
                                $val_arr = $value != '' ? explode( ',', $value ) : array( );
                                if( !in_array( "$serial.$link", $val_arr ) )
                                    $val_arr[] = "$serial.$link";
                                $value = implode( ',', $val_arr );
                            }
                            else
                            {
                                if( @ereg( "$serial.$link", $value ) )
                                {
                                    $v_arr = explode( ',', $value );
                                    for( $i = 0; $i < sizeof( $v_arr ); $i++ )
                                        if( $v_arr[$i] == "$serial.$link" )
                                            unset( $v_arr[$i] );
                                    $value = implode( ',', $v_arr );
                                }
                            }
                            $value = trim( $value ) == '' ? '!' : trim( $value );
                            $systemYaml->changeVarValue( 'UseCentralOfficePrefixOnIncomingCalls', $value );
                            break;

                        case 'CRC4':
                            $value = $systemYaml->getValue( 'CRC4' );
                            if( $cv[1] == 'true' )
                            {
                                $val_arr = $value != '' ? explode( ',', $value ) : array( );
                                if( !in_array( "$serial.$link", $val_arr ) )
                                    $val_arr[] = "$serial.$link";
                                $value = implode( ',', $val_arr );
                            }
                            else
                            {
                                if( @ereg( "$serial.$link", $value ) )
                                {
                                    $v_arr = explode( ',', $value );
                                    for( $i = 0; $i < sizeof( $v_arr ); $i++ )
                                        if( $v_arr[$i] == "$serial.$link" )
                                            unset( $v_arr[$i] );
                                    $value = implode( ',', $v_arr );
                                }
                            }
                            $value = trim( $value ) == '' ? '!' : trim( $value );
                            $systemYaml->changeVarValue( 'CRC4', $value );
                            break;

                        case 'k3lr':
                            $value = $systemYaml->getValue( 'Links' );
                            if( $cv[1] != '' )
                            {
                                for( $i = 0; $i < sizeof( $value ); $i++ )
                                {
                                    if( $value[$i]['Device'] == $serial && $value[$i]['Link'] == $link )
                                        $value[$i]['ServerAddress'] = $cv[1];
                                }
                            }
                            else
                            {
                                for( $i = 0; $i < sizeof( $value ); $i++ )
                                {
                                    if( $value[$i]['Device'] == $serial && $value[$i]['Link'] == $link )
                                        unset( $value[$i] );
                                }
                            }
                            $systemYaml->changeVarValue( 'Links', $value );
                            break;

                        case 'CasLineValidateTime':
                            $value = $systemYaml->getValue( 'CasLineValidateTime' );
                            if( trim( $cv[1] ) != '' )
                            {
                                $value["$serial.$link"] = $cv[1];
                                $systemYaml->changeVarValue( 'CasLineValidateTime', $value );
                            }
                            else
                            {
                                if( isset( $value["$serial.$link"] ) )
                                    unset( $value["$serial.$link"] );
                                $systemYaml->changeVarValue( 'CasLineValidateTime', $value );
                            }
                            break;

                        case 'StartTime':
                            $value = $systemYaml->getValue( 'LinkTimers' );
                            $value["$serial.$link"]['StartTime'] = $cv[1];
                            $systemYaml->changeVarValue( 'LinkTimers', $value );
                            break;

                        case 'ReleaseTime':
                            $value = $systemYaml->getValue( 'LinkTimers' );
                            $value["$serial.$link"]['ReleaseTime'] = $cv[1];
                            $systemYaml->changeVarValue( 'LinkTimers', $value );
                            break;

                        case 'AlarmTime':
                            $value = $systemYaml->getValue( 'LinkTimers' );
                            $value["$serial.$link"]['AlarmTime'] = $cv[1];
                            $systemYaml->changeVarValue( 'LinkTimers', $value );
                            break;
                    }
                }
                $systemYaml->saveYaml( );
            }
            return $sistema->retTranslate( 'ConfiguracaoSalva' );
        }
    }

    function saveCallProgressOptions( $_REQUEST )
    {
        Global $sistema;
        $data = isset( $_REQUEST['data'] ) ? $_REQUEST['data'] : '';

        if( isset( $_REQUEST['data'] ) )
        {
            $configDir = $sistema->getConfigDir( );
            $sysYaml = new KYaml( $configDir . "/system.yaml" );

            $data = explode( '|', $data );

            foreach( $data as $d )
            {
                $cv = explode( ':', $d );
                $sysYaml->changeVarValue( $cv[0], $cv[1] );
            }
            $sysYaml->saveYaml( );
            return $sistema->retTranslate( 'ConfiguracaoSalva' );
        }
    }

    function saveCadences( $_REQUEST )
    {
        Global $sistema;
        $data = isset( $_REQUEST['data'] ) ? $_REQUEST['data'] : NULL;

        if( isset( $data ) )
        {
            $configDir = $sistema->getConfigDir( );
            $sysYaml = new KYaml( $configDir . "/system.yaml" );

            $new_cad = array( );
            if( $data != '' )
            {
                $data = explode( '|', $data );
                foreach( $data as $d )
                {
                    $index = explode( '_', $d );
                    $id = $index[0];
                    $values = explode( ';', $index[1] );

                    $new = array( );
                    foreach( $values as $v )
                    {
                        $cv = explode( ':', $v );

                        if( $cv[0] == "Cadence" )
                            $cv[1] = explode( ',', $cv[1] );

                        $new[$id][$cv[0]] = $cv[1];
                    }
                    $new_cad[] = $new;
                }
            }
            $sysYaml->changeVarValue( 'Cadences', $new_cad );
            $sysYaml->saveYaml( false );
            return $sistema->retTranslate( 'ConfiguracaoSalva' );
        }
    }

    /******** aux functions *********/

    function printFXO( $DeviceChannel, $number, $serial, $value = "" )
    {
        $return = '';
        // $return .= "<input type='hidden' id='FXOLineSensibilityA$number'
        // name='FXOLineSensibilityA$number' value='$DeviceChannel'/>";
        $possibleValues = array( 24, 48 );
        $return .= "<select name='FXOLineSensibility$number' id='FXOLineSensibility$number' >";
        for( $x = 0; $x < sizeof( $possibleValues ); $x++ )
        {
            $selected = $value == $possibleValues[$x] ? "selected" : '';
            $return .= "<option value='$serial:$possibleValues[$x]' $selected>$possibleValues[$x]</option>";
        }
        $return .= "</select>";
        return $return;
    }

    function getTotalFreeMtp3Mtp2Links( $ss7 )
    {
        if( isset( $ss7['ss7']['Mtp2'] ) )
            $freeMtp2Links = sizeof( $ss7['ss7']['Mtp2'] );
        else
            $freeMtp2Links = 0;

        if( isset( $ss7['ss7']['Mtp3']['LinkSets'] ) )
        {
            $chaves = array_keys( $ss7['ss7']['Mtp3']['LinkSets'] );
            for( $x = 0; $x < sizeof( $chaves ); $x++ )
            {
                $getKeys = array_keys( $ss7['ss7']['Mtp3']['LinkSets'][$chaves[$x]] );
                $freeMtp2Links = $freeMtp2Links - sizeof( $ss7['ss7']['Mtp3']['LinkSets'][$chaves[$x]][$getKeys[0]]['Links'] );
            }
        }
        return $freeMtp2Links;
    }

    function zeroFill( $var, $size )
    {
        $aux = "";
        if( strlen( $var ) >= $size )
            return $var;
        for( $x = strlen( $var ); $x < $size; $x++ )
            $aux .= '0';
        return $aux . $var;
    }

    function getProfile( $link, $profilesYaml )
    {
        $Profiles = new KProfiles( );
        $defaultE1Types = array( 'R2', 'ISDN', 'ISUP', 'CAS PBX' );
        $profiles = $profilesYaml->yaml["ChannelGroupProfiles"];

        $newProfile = array( );
        $newProfile[] = 'Deactivated';
        $subName = explode( '.', $link );
        $passiveType = false;

        if( isPassive( $subName[0] ) )
            $passiveType = true;

        for( $x = 0; $x < sizeof( $profiles ); $x++ )
        {
            $keys = array_keys( $profiles[$x] );
            $profile = $Profiles->getProfile( $keys[0] );
            $type = $profile[$keys[0]]['Type'];

            $profileSubType = isset( $profile[$keys[0]]["SubType"] ) ? $profile[$keys[0]]["SubType"] : '';

            if( $passiveType && $profileSubType == 'Passive' )
                $newProfile[] = $keys[0];
            elseif( $profileSubType != 'Passive' && (in_array( $type, $defaultE1Types )) && !$passiveType )
                $newProfile[] = $keys[0];
        }

        return $newProfile;
    }

    function isPassive( $serial )
    {
        Global $sistema;

        $configDir = $sistema->getConfigDir( );
        $deviceYaml = new KYaml( $configDir . "/devices.yaml" );
        $dev = $deviceYaml->getValue( $serial );
        if( @ereg( "HI", $dev['Type'] ) || @ereg( "KPR", $dev['Type'] ) )
            return true;
        return false;
    }

    function getK3Lr( $link, $number, $yamlData )
    {
        $deviceData = explode( ".", $link );
        $k3lrLinks = $yamlData->getValue( 'Links', 'K3Lr' );

        $k3lrLink = $k3lrLinks[$number];
        $value = $k3lrLink['ServerAddress'];
        $return = "<td><input onkeyup='validateIP(this)' onkeydown='return maskIP(event, this);' name='k3lr-$link' id='k3lr-$link' value='$value' type='text' class='selector4'></td>";

        return $return;
    }

    function casLineValidateTime( $link, $number, $yamlData )
    {
        $value = $yamlData->getValue( $link, 'System|CasLineValidateTime' );

        $value = ($value == "" || $value == "yamlError") ? 20 : $value;

        $return = "<td>";
        $return .= "<select name='CasLineValidateTime-$link' id='CasLineValidateTime-$link' value='$value' type='text' class='selector'>";
        for( $i = 5; $i <= 500; $i = $i + 5 )
        {
            $selected = ($i == $value) ? "selected" : '';
            $return .= "<option value='$i' $selected>" . $i . "</option>";
        }
        $return .= "</select>";
        $return .= "</td>";
        return $return;
    }

    function linkTimers( $link, $number, $yamlData )
    {
        Global $sistema;
        $return = '';

        $startTime = $yamlData->getValue( 'StartTime', "System|LinkTimers|$link" );
        $startValue = ($startTime == '' || $startTime == "yamlError") ? 150 : $startTime;

        $return .= "<td>";
        $return .= "<select name='StartTime-$link' id='StartTime-$link' class='selector'>";
        for( $st = 0; $st < 2000; $st = $st + 50 )
        {
            $selected = ($st == $startValue) ? "selected" : '';
            $return .= "<option value='$st' $selected>$st</option>";
        }
        $return .= "</select>";
        $return .= "</td>";

        $releaseTime = $yamlData->getValue( 'ReleaseTime', "System|LinkTimers|$link" );
        $releaseValue = $releaseTime == '' || $releaseTime == "yamlError" ? 150 : $releaseTime;

        $return .= "<td>";
        $return .= "<select name='ReleaseTime-$link' id='ReleaseTime-$link' class='selector'>";

        for( $st = 0; $st < 2000; $st = $st + 50 )
        {
            $selected = $st == $releaseValue ? "selected" : '';
            $return .= "<option value='$st' $selected>$st</option>";
        }
        $return .= "</select>";
        $return .= "</td>";

        $AlarmTime = $yamlData->getValue( 'AlarmTime', "System|LinkTimers|$link" );
        $AlarmValue = ($AlarmTime == '' || $AlarmTime == "yamlError") ? 150 : $AlarmTime;

        $return .= "<td valign='top' align='right'>";
        $return .= "<select name='AlarmTime-$link' id='AlarmTime-$link' class='selector'>";

        for( $st = 0; $st < 2000; $st = $st + 50 )
        {
            $selected = ($st == $AlarmValue) ? 'selected' : '';
            $return .= "<option value='$st' $selected>$st</option>";
        }
        $return .= "</select>";
        $return .= "</td>";

        return $return;
    }

    function removeDeletedProfileFromLinks( $profileName )
    {
        Global $sistema;

        $configDir = $sistema->getConfigDir( );
        $deviceYaml = new KYaml( $configDir . '/devices.yaml' );
        $devicesYaml = $deviceYaml->getYaml( );
        $devices = $devicesYaml['Devices'];
        $dKeys = array_keys( $devices );

        foreach( $dKeys as $key )
        {
            $dev = $devices[$key];
            $devKeys = array_keys( $dev );
            $devLinks = $dev[$devKeys[0]]['Links'];
            $linkKeys = array_keys( $devLinks );
            foreach( $linkKeys as $k )
            {
                $keys = array_keys( $devLinks[$k] );
                foreach( $keys as $x )
                {
                    if( $devLinks[$k][$x]['Profile'] == $profileName )
                    {
                        $dev[$devKeys[0]]['Links'][$k][$x]['Profile'] = 'Deactivated';
                        $devFinal = $dev[$devKeys[0]];
                        $deviceYaml->changeVarValue( $devKeys[0], $devFinal );
                    }
                }
            }
        }
        $deviceYaml->saveYaml( true );
        return;
    }
