<?php
    require_once KCONFIG . '/classes/classKGatewayUtil.php';

    $AjaxFunctions['showTimeRestraintsGW'] = 'showTimeRestraintsGW';
    $AjaxFunctions['newTimeRestraintsGW'] = 'newTimeRestraintsGW';
    $AjaxFunctions['saveTimeRestraints'] = 'saveTimeRestraints';
    $AjaxFunctions['removeTimeRestraints'] = 'removeTimeRestraints';

    function showTimeRestraintsGW( $_REQUEST )
    {
        Global $sistema;

        $buffer = '';
        $path = GatewayUtil::getGatewayConfigPath( );
        $kyaml = new KYaml( $path );

        $yaml = $kyaml->getYaml( );

        $buffer .= "<fieldset><legend>" . $sistema->retTranslate( 'TimeRestraints' ) . '</legend>';
        $buffer .= "<div id='TimeRestraintsDivTable'>";
        $buffer .= "<input type='button' value='" . $sistema->retTranslate( 'newTimeRestraints' ) . "' onClick='newTimeRestraints();' /></br></br>";

        if( sizeof((array_values( $yaml['TimeRestraints'] ))) > 0 )
        {

            $buffer .= "<table id='TimeRestraintsTable' class='gateway-table'><thead><tr>";
            $buffer .= "<th>" . $sistema->retTranslate( 'name' ) . "</th>";
            $buffer .= "<th class='gateway-table-options'>" . $sistema->retTranslate( 'options' ) . "</th></tr></thead><tbody>";
            $columnCount = 0;

            $index = 0;
            foreach( $yaml['TimeRestraints'] as $time )
            {
                $buffer .= "<tr>";
                $timeName = ($time['Name']);
                $buffer .= "<td>{$time['Name']}</td>";
                $buffer .= "<td class='gateway-table-options'><a href='#' onClick=\"editTimeRestraints('{$time['Name']}');\"><img border='0' src='/imagens/editark.gif'/></a>";
                $buffer .= "<a href='#' onClick=\"removeTimeRestraints('{$time['Name']}');\"><img border='0' src='/imagens/lixeira.gif'/></a></td>";
                $buffer .= "</tr>";
                $columnCount++;
                $index++;
            }
            $buffer .= "</tbody></table>";

        }
        else
            $buffer .= $sistema->retTranslate( 'noTimeRestraints' );

        $buffer .= "</div>";
        $buffer .= '<div id="TimeRestraintsDivForm" style="display: none;"></div></fieldset>';

        return $buffer;

    }

    function newTimeRestraintsGW( $_REQUEST )
    {
        Global $sistema;

        $name = isset( $_REQUEST['name'] ) ? $_REQUEST['name'] : '';

        if( $name != '' )
        {
            $kyaml = getConfigGW( );
            $ret = searchTimeRestraintsByName( $name );
            $time = $ret['time'];
            $pos = $ret['pos'];
        }
        else
        {
            $time = array( 'Name' => '', 'Hour' => '', 'WDay' => '', 'Day' => '', 'Month' => '' );
            $pos = '';
        }

        if( $time['Hour'] != '' )
        {
            $checkedHour = 'checked';
            $displayHour = 'block';
        }
        else
        {
            $checkedHour = '';
            $displayHour = 'none';
        }

        $tmp = explode( '-', $time['Hour'] );
        if( sizeof( $tmp ) > 1 )
        {
            $from = explode( ':', $tmp[0] );
            $to = explode( ':', $tmp[1] );
        }
        else
        {
            $from = array( 0 => '00', 1 => '00' );
            $to = array( 0 => '00', 1 => '00' );
        }

        $buffer .= $sistema->retTranslate( 'name' ) . ": <input id='timeRestraintsName'type='text' value='" . $time['Name'] . "'/></br></br>";
        $buffer .= "<table border='0' style='width:550px; margin-left:10%;'>";
        $buffer .= "<tr class='green' style='height:28px;'>";
        $buffer .= "<td style='width:25px;'>";
        $buffer .= "<input type='checkbox' $checkedHour id='checkHour' onclick='showHourTable();' value=''></input>";
        $buffer .= '</td>';
        $buffer .= "<td >";
        $buffer .= $sistema->retTranslate( 'hour' );
        $buffer .= "</br></br><table id='hourTable' style='width:275px; display:$displayHour; margin-left: 25%'>";
        $buffer .= "<td style='width:95px;'>";
        $buffer .= $sistema->retTranslate( 'start' ) . ':';
        $buffer .= "<input style='width:20px;' maxlength='2' onkeydown='return onlyIntegerNumbers(event);' onclick='setPosition(\"hour\",\"from\");' type='text' id='fromHour' value='$from[0]'/>:";
        $buffer .= "<input style='width:20px;' maxlength='2' onkeydown='return onlyIntegerNumbers(event);' onclick='setPosition(\"minutes\",\"from\");' type='text' id='fromMinutes' value='$from[1]'/>";
        $buffer .= '</td>';
        $buffer .= '<td style="width:15px;">';
        $buffer .= "<a href='#' onclick='up(\"from\");'><img src='/imagens/up.png' border='0'></a></br>";
        $buffer .= "<a href='#' onclick='down(\"from\");'><img src='/imagens/down.png' border='0'></a>";
        $buffer .= '</td>';

        $buffer .= '<td style="width:50px;">';
        $buffer .= '</td>';

        $buffer .= '<td style="width:95px;">';
        $buffer .= $sistema->retTranslate( 'end' ) . ':';
        $buffer .= "<input style='width:20px;' maxlength='2' onkeydown='return onlyIntegerNumbers(event);' onclick='setPosition(\"hour\",\"to\");' type='text' id='toHour' value='$to[0]'/>:";
        $buffer .= "<input style='width:20px;' maxlength='2' onkeydown='return onlyIntegerNumbers(event);' onclick='setPosition(\"minutes\",\"to\");' type='text' id='toMinutes' value='$to[1]'/>";
        $buffer .= '</td>';
        $buffer .= '<td style="width:15px;">';
        $buffer .= "<a href='#' onclick='up(\"to\");'><img src='/imagens/up.png' border='0'></a></br>";
        $buffer .= "<a href='#' onclick='down(\"to\");'><img src='/imagens/down.png' border='0'></a>";
        $buffer .= '</td>';
        $buffer .= '</tr>';
        $buffer .= '</table>';
        $buffer .= "<input type='hidden' id='fromPosition'  value='hour'/>";
        $buffer .= "<input type='hidden' id='toPosition'  value='hour'/>";
        $buffer .= '</td>';
        $buffer .= '</tr>';

        if( $time['WDay'] != '' )
            $days = explode( ',', $time['WDay'] );
        else
            $days = array( );

        $displayWeekDay = sizeof( $days ) > 0 ? 'block' : 'none';
        $checkWeekDay = sizeof( $days ) > 0 ? 'checked' : '';

        $buffer .= "<tr class='lgreen' style='height:28px;'>";
        $buffer .= "<td style='width:25px;'>";
        $buffer .= "<input type='checkbox' id='checkWeekDay' $checkWeekDay onclick='showWeekDaysTable();' value=''></input>";
        $buffer .= '</td>';
        $buffer .= '<td>';

        $buffer .= $sistema->retTranslate( 'weekDays' );
        $checkDom = in_array( 1, $days ) ? 'selected' : '';
        $checkSeg = in_array( 2, $days ) ? 'selected' : '';
        $checkTer = in_array( 3, $days ) ? 'selected' : '';
        $checkQua = in_array( 4, $days ) ? 'selected' : '';
        $checkQui = in_array( 5, $days ) ? 'selected' : '';
        $checkSex = in_array( 6, $days ) ? 'selected' : '';
        $checkSab = in_array( 7, $days ) ? 'selected' : '';

        $buffer .= "<br><br><select id='weekDay-combo' multiple='multiple'>";
        $buffer .= "<option $checkDom value='1'>" . $sistema->retTranslate( 'Dom' ) . "</option>";
        $buffer .= "<option $checkSeg value='2'>" . $sistema->retTranslate( 'Seg' ) . "</option>";
        $buffer .= "<option $checkTer value='3'>" . $sistema->retTranslate( 'Ter' ) . "</option>";
        $buffer .= "<option $checkQua value='4'>" . $sistema->retTranslate( 'Qua' ) . "</option>";
        $buffer .= "<option $checkQui value='5'>" . $sistema->retTranslate( 'Qui' ) . "</option>";
        $buffer .= "<option $checkSex value='6'>" . $sistema->retTranslate( 'Sex' ) . "</option>";
        $buffer .= "<option $checkSab value='7'>" . $sistema->retTranslate( 'Sab' ) . "</option>";
        $buffer .= "</select>";

        $buffer .= '</td>';
        $buffer .= '</tr>';
        $buffer .= "<tr class='green' style='height:28px;'>";

        if( $time['Day'] != '' )
            $days = explode( ',', $time['Day'] );
        else
            $days = array( );
        $displayDay = sizeof( $days ) > 0 ? '' : 'display:none;';
        $checkDay = sizeof( $days ) > 0 ? 'checked' : '';

        $buffer .= "<td style='width:25px;'>";
        $buffer .= "<input type='checkbox' id='checkMonthDay' $checkDay onclick='showMonthDayTable();' value=''></input>";
        $buffer .= '</td>';
        $buffer .= '<td>';
        $buffer .= $sistema->retTranslate( 'monthDays' );
        $buffer .= "<br></br><table id='monthDayTable' style='width:500px;$displayDay' border='0' >";
        $buffer .= '<tr>';
        for( $i = 1; $i < 32; $i++ )
        {
            $check = in_array( $i, $days ) ? 'checked' : '';
            $buffer .= '<td>';
            if( $i < 10 )
                $buffer .= "<input type='checkbox' id='day$i' $check value='$i'><label for='day$i'>&nbsp;&nbsp;$i</label></input>";
            else
                $buffer .= "<input type='checkbox' id='day$i' $check value='$i'><label for='day$i'>$i</label></input>";

            $buffer .= '</td>';
            $buffer .= $i % 7 == 0 ? '</tr><tr>' : '';
        }
        $buffer .= '</tr>';
        $buffer .= '</table>';
        $buffer .= '</td>';
        $buffer .= '</tr>';

        if( $time['Month'] != '' )
            $meses = explode( ',', $time['Month'] );
        else
            $meses = array( );
        $displayMonth = sizeof( $meses ) > 0 ? '' : 'display:none;';
        $checkMonth = sizeof( $meses ) > 0 ? 'checked' : '';

        $buffer .= "<tr class='lgreen' style='height:28px;' >";
        $buffer .= "<td style='width:25px;'>";
        $buffer .= "<input type='checkbox' $checkMonth id='checkMonth' onclick='showMonthTable();' value=''></input>";
        $buffer .= '</td>';
        $buffer .= '<td>';
        $buffer .= $sistema->retTranslate( 'months' );
        $meses = explode( ',', $time['Month'] );

        $checkJan = in_array( 1, $meses ) ? 'selected' : '';
        $checkFev = in_array( 2, $meses ) ? 'selected' : '';
        $checkMar = in_array( 3, $meses ) ? 'selected' : '';
        $checkAbr = in_array( 4, $meses ) ? 'selected' : '';
        $checkMai = in_array( 5, $meses ) ? 'selected' : '';
        $checkJun = in_array( 6, $meses ) ? 'selected' : '';
        $checkJul = in_array( 7, $meses ) ? 'selected' : '';
        $checkAgo = in_array( 8, $meses ) ? 'selected' : '';
        $checkSet = in_array( 9, $meses ) ? 'selected' : '';
        $checkOut = in_array( 10, $meses ) ? 'selected' : '';
        $checkNov = in_array( 11, $meses ) ? 'selected' : '';
        $checkDez = in_array( 12, $meses ) ? 'selected' : '';

        $buffer .= "<br><br><select id='month-combo' multiple='multiple'>";
        $buffer .= "<option $checkJan value='1'>" . $sistema->retTranslate( 'Jan' ) . "</option>";
        $buffer .= "<option $checkFev value='2'>" . $sistema->retTranslate( 'Fev' ) . "</option>";
        $buffer .= "<option $checkMar value='3'>" . $sistema->retTranslate( 'Mar' ) . "</option>";
        $buffer .= "<option $checkAbr value='4'>" . $sistema->retTranslate( 'Abr' ) . "</option>";
        $buffer .= "<option $checkMai value='5'>" . $sistema->retTranslate( 'Mai' ) . "</option>";
        $buffer .= "<option $checkJun value='6'>" . $sistema->retTranslate( 'Jun' ) . "</option>";
        $buffer .= "<option $checkJul value='7'>" . $sistema->retTranslate( 'Jul' ) . "</option>";
        $buffer .= "<option $checkAgo value='8'>" . $sistema->retTranslate( 'Ago' ) . "</option>";
        $buffer .= "<option $checkSet value='9'>" . $sistema->retTranslate( 'Set' ) . "</option>";
        $buffer .= "<option $checkOut value='10'>" . $sistema->retTranslate( 'Out' ) . "</option>";
        $buffer .= "<option $checkNov value='11'>" . $sistema->retTranslate( 'Nov' ) . "</option>";
        $buffer .= "<option $checkDez value='12'>" . $sistema->retTranslate( 'Dez' ) . "</option>";
        $buffer .= "</select>";

        $buffer .= '</td>';
        $buffer .= '</tr>';
        $buffer .= "</table>";

        $buffer .= "<input type='hidden' id='TimeRestraintsId' value='" . $time['Name'] . "' />";
        $buffer .= "<input type='hidden' id='TimeRestraintsPos' value='" . $pos . "' />";
        $buffer .= "</br><input type='button' onclick='saveTimeRestraints();' value='" . $sistema->retTranslate( 'save' ) . "' />";
        $buffer .= "<input type='button' onclick='backTimeRestraints();' value='" . $sistema->retTranslate( 'back' ) . "' />";

        return $buffer;
    }

    function saveTimeRestraints( $_REQUEST )
    {
        Global $sistema;

        $id = isset( $_REQUEST['id'] ) ? $_REQUEST['id'] : NULL;
        $pos = isset( $_REQUEST['TimeRestraintsPos'] ) ? $_REQUEST['TimeRestraintsPos'] : NULL;
        $data = isset( $_REQUEST['data'] ) ? $_REQUEST['data'] : NULL;

        if( isset( $data ) )
        {
            $timeTMP = array( );
            $arrData = explode( '|', $data );

            foreach( $arrData as $campoValor )
            {
                $arrCV = explode( '=', $campoValor );
                $timeTMP[$arrCV[0]] = $arrCV[1];
            }

            $kyaml = getConfigGW( );
            $yaml = $kyaml->getYaml( );
            $newTimeRestraints = $id == '' ? true : false;

            if( $newTimeRestraints )
            {
                for( $i = 0; $i < sizeof( $yaml['TimeRestraints'] ); $i++ )
                {
                    if( $yaml['TimeRestraints'][$i]['Name'] == $timeTMP['Name'] )
                        return 'nok|' . $sistema->retTranslate( 'NameAlreadyUsed' );
                }
                $qtdeTimeRestraints = $yaml['TimeRestraints'] == '' ? 0 : sizeof( $yaml['TimeRestraints'] );
                $kyaml->createAddValue( $qtdeTimeRestraints, "TimeRestraints", $timeTMP );
            }
            else
                $kyaml->changeVarValue( $pos, $timeTMP, 'TimeRestraints' );
            $kyaml->saveYaml( );

            return "ok|" . $sistema->retTranslate( 'TimeRestraintSaved' );
        }
    }

    function removeTimeRestraints( )
    {
        $name = isset( $_POST['name'] ) ? $_POST['name'] : null;

        require_once KROOT . '/json_util.php';
        $app = KSystem::getInstance( );

        $reply = array( 'success' => false, 'message' => $app->translate( 'gateway-time-restraints-delete-error' ) );

        if( !is_null( $name ) )
        {
            $kyaml = getConfigGW( );
            $yaml = $kyaml->getYaml( );
            foreach( $yaml['TimeRestraints'] as $time )
            {
                if( $time['Name'] == $name )
                {
                    $inUse = false;
                    foreach( $yaml['Routes'] as $route )
                    {
                        if( $route['Time'] == $time['Name'] )
                        {
                            $inUse = true;
                            break;
                        }
                    }
                    if( $inUse )
                    {
                        $reply['message'] = $app->translate( 'gateway-time-restraints-delete-error-inuse' );
                    }
                    else
                    {
                        unset( $yaml['TimeRestraints'][$pos] );
                        $kyaml->setYaml( $yaml );
                        $kyaml->saveYaml( );
                        $reply = array( 'success' => true, 'message' => $app->translate( 'gateway-time-restraints-deleted' ) );
                    }
                    break;
                }
            }
        }
        return JSONencode( $reply );
    }

    function searchTimeRestraintsByName( $name )
    {
        $kyaml = getConfigGW( );
        $yaml = $kyaml->getYaml( );
        for( $i = 0; $i < sizeof( $yaml['TimeRestraints'] ); $i++ )
        {
            if( $yaml['TimeRestraints'][$i]['Name'] == $name )
                return $r = array( 'pos' => $i, 'time' => $yaml['TimeRestraints'][$i] );
        }
        return '';
    }
