<?
    require_once (dirname( __FILE__ ) . "/spyc.php");

    class KYaml
    {
        var $yaml, $file;

        function __construct( $file )
        {
            $this->file = $file;
            $this->yaml = Spyc::YAMLLoad( $file );
        }

        function saveYaml( $FormatIndexes = false )
        {
            $fp = fopen( $this->file, "w+b" );
            $text = "#Khomp configuration file" . PHP_EOL;
            $text .= "#Please note that indentation denotes scope but TABs are not permitted" . PHP_EOL;
            $text .= "#All fields are case sensitive" . PHP_EOL . PHP_EOL;
            $text .= $this->fileFormatYamlData( );

            fwrite( $fp, $text );
            fclose( $fp );
            $fileData = file( $this->file );
            $dataSize = sizeof( $fileData );
            for( $i = 0; $i < $dataSize; $i++ )
                $fileData[$i] = rtrim( $fileData[$i] );
            $text = '';
            $text = implode( PHP_EOL, $fileData );
            $fp = fopen( $this->file, "w+b" );
            fwrite( $fp, $text );
            fclose( $fp );

            $this->keyParser( );
            if( $FormatIndexes )
                $this->extraParser( );
        }

        function keyParser( )
        {
            $yamlContent = file( $this->file );
            $fileSize = sizeof( $yamlContent );
            for( $x = 0; $x < $fileSize; $x++ )
            {
                if( @ereg( ":", $yamlContent[$x] ) )
                {
                    $tmp = explode( ":", $yamlContent[$x] );
                    if( trim( $tmp[1] ) == "" )
                    {
                        $tmp[0] = $this->rebuildLine( $tmp[0] );
                        $yamlContent[$x] = $tmp[0] . ":" . $tmp[1];
                    }
                }
            }
            $fp = fopen( $this->file, "w+b" );
            fwrite( $fp, implode( "", $yamlContent ) );
            fclose( $fp );
        }

        function rebuildLine( $piece )
        {
            $pieceLength = strlen( $piece );
            $first = true;
            $newStr = '';
            if( $piece[$pieceLength - 1] == "\"" )
                return $piece;
            for( $i = 0; $i < $pieceLength; $i++ )
            {
                if( $piece[$i] == " " )
                    $newStr .= $piece[$i];
                else
                {
                    if( $first )
                    {
                        $first = false;
                        $newStr .= "\"" . $piece[$i];
                    }
                    else
                        $newStr .= $piece[$i];
                }
            }
            return $newStr . "\"";
        }

        function extraParser( )
        {
            $yamlContent = file( $this->file );
            $fileSize = sizeof( $yamlContent );
            $structureStart = false;
            for( $x = 0; $x < $fileSize; $x++ )
            {
                if( $structureStart == true && @ereg( " -", $yamlContent[$x] ) )
                {
                    $yamlContent[$x] = @ereg_replace( "-", "\"0\":", $yamlContent[$x] );
                    $structureStart = false;
                }
                elseif( @ereg( " -", $yamlContent[$x] ) )
                    $structureStart = true;
                else
                    $structureStart = false;
            }
            $fp = fopen( $this->file, "w+b" );
            fwrite( $fp, implode( "", $yamlContent ) );
            fclose( $fp );
        }

        function getYaml( )
        {
            return $this->yaml;
        }

        function setYaml( $arr )
        {
            $this->yaml = $arr;
        }

        function fileFormatYamlData( )
        {
            return Spyc::YAMLDump( $this->yaml );
        }

        function fileFormatFromYamlData( $yamlData )
        {
            return Spyc::YAMLDump( $yamlData );
        }

        function getWay( $yaml = "", $varName, $way = "" )
        {
            if( $yaml == "" )
                $yaml = $this->yaml;
            $x = 0;
            $keys = array_keys( $yaml );

            foreach( $yaml as $obj )
            {
                if( is_array( $obj ) )
                {
                    $tempWay = $way;
                    if( $way == "" )
                        $way = $keys[$x];
                    else
                        $way .= "|" . $keys[$x];
                    if( array_key_exists( $varName, $obj ) )
                        return $way;
                    else
                    {
                        if( $this->getWay( $obj, $varName, $way ) )
                            return $this->getWay( $obj, $varName, $way );
                    }
                    $way = $tempWay;
                }
                $x++;
            }
            return false;
        }

        function createVar( $varName, $way, $value )
        {
            if( $way )
                $this->createData( $this->yaml, $way . "|" . $varName, $value );
        }

        function createData( &$data, $keySequence, $value )
        {
            $keys = explode( "|", $keySequence );
            $ckey = $keys[0];
            array_shift( $keys );
            if( sizeof( $keys ) == 0 )
            {
                if( is_array( $data ) )
                    $data[$ckey] = $value;
                else
                    $data = array( $ckey => $value );
            }
            else
            {
                $keys = implode( "|", $keys );
                $this->createData( $data[$ckey], $keys, $value );
            }
        }

        function createSubVar( $varName, $subVarName, $way, $value )
        {
            if( $way )
                $this->createData( $this->yaml, $way . "|" . $varName . "|" . $subVarName, $value );
        }

        function createAddValue( $varName, $way, $value )
        {
            if( $way )
                $this->createData( $this->yaml, $way . "|" . $varName, $value );
        }

        function deleteVar( $varName, $way = '' )
        {
            if( $way == '' )
                $way = $this->getWay( $this->yaml, $varName );
            if( $way )
                $this->deleteData( $this->yaml, $way . "|" . $varName );
        }

        function deleteSubVar( $varName, $subVarName, $way = '' )
        {
            if( $way == '' )
                $way = $this->getWay( $this->yaml, $varName );

            if( $way )
                $this->deleteData( $this->yaml, $way . "|" . $varName . "|" . $subVarName );
        }

        function sortKeys( $piece )
        {
            if( $piece != "" )
                $yamlSize = sizeof( $this->yaml[$piece] );
            else
                $yamlSize = sizeof( $this->yaml );
            $newYaml = array( );

            foreach( $this->yaml[$piece] as $slice )
                $newYaml[] = $slice;

            $this->yaml[$piece] = $newYaml;
        }

        function getValue( $varName, $way = "" )
        {
            if( $way == "" )
                $way = $this->getWay( $this->yaml, $varName );

            if( $way )
                return $this->getData( $this->yaml, $way . "|" . $varName ) != '!' ? $this->getData( $this->yaml, $way . "|" . $varName ) : '';
            return "yamlError";
        }

        function changeVarValue( $varName, $value, $way = "" )
        {
            if( $way == "" )
                $way = $this->getWay( $this->yaml, $varName );

            if( $way )
                $this->changeData( $this->yaml, $way . "|" . $varName, $value );
            return;
        }

        function changeData( &$data, $keySequence, $value )
        {
            $keys = explode( "|", $keySequence );
            $ckey = $keys[0];
            array_shift( $keys );
            if( sizeof( $keys ) == 0 )
                $data[$ckey] = $value;
            else
            {
                $keys = implode( "|", $keys );
                $this->changeData( $data[$ckey], $keys, $value );
            }
        }

        function deleteData( &$data, $keySequence )
        {
            $keys = explode( "|", $keySequence );
            $ckey = $keys[0];
            array_shift( $keys );
            if( sizeof( $keys ) == 0 )
                unset( $data[$ckey] );
            else
            {
                $keys = implode( "|", $keys );
                $this->deleteData( $data[$ckey], $keys );
            }
        }

        function getData( &$data, $keySequence )
        {
            $keys = explode( "|", $keySequence );
            $ckey = $keys[0];
            array_shift( $keys );
            if( sizeof( $keys ) == 0 )
                return isset( $data[$ckey] ) ? $data[$ckey] : '';
            else
            {
                $keys = implode( "|", $keys );
                return $this->getData( $data[$ckey], $keys );
            }
        }

    }
?>
