<?php
    require_once '../constants.php';
    require_once KROOT . '/classes/KSystem.php';
    $app = KSystem::getInstance( );
    $app->redirectIfNotLogged( );

    require_once KROOT . '/smarty-libs/Smarty.class.php';
    require_once KROOT . '/topo.php';
    require_once KROOT . '/rodape.php';
    require_once KCONFIG . '/classes/classKSistema.php';
    require_once KCONFIG . '/classes/classKService.php';
    require_once KDIAGNOSTIC . '/languages/dictionary.php';
    require_once KDIAGNOSTIC . '/menu.php';
    require_once KDIAGNOSTIC . '/classes/classKLogs.php';
    require_once KDIAGNOSTIC . '/logUtil.php';

    global $sistema, $module_dir;

    if( !isset( $_SESSION['sis'] ) )
    {
        $sistema = new KSistema( $app->getLanguage( ) );
        $_SESSION['sis'] = serialize( $sistema );
    }
    else
    {
        $sistema = unserialize( $_SESSION['sis'] );
        $sistema->setLanguage( $app->getLanguage( ) );
    }

    $smarty = new Smarty( );
    $module_dir = ".";

    if( $_SESSION['loginAccess']['diagnostic'] == 'full' )
    {
        $ajaxTo = isset( $_REQUEST['ajaxTo'] ) ? $_REQUEST['ajaxTo'] : NULL;
        if( isset( $ajaxTo ) )
        {
            require_once KROOT . '/json_util.php';
            require_once KDIAGNOSTIC . '/ajax/includeAjaxFiles.php';
            if( function_exists( $AjaxFunctions[$ajaxTo] ) )
            {
                echo call_user_func_array( $AjaxFunctions[$ajaxTo], array( $_REQUEST ) );
            }
            else
            {
                echo "Undefined function {$ajaxTo}";
            }
            exit ;
        }
    }
    else
        $smarty->assign( 'CONTEUDO', $app->translate( 'noPermissionToThisPage' ) );

    $css_conflict = '<link rel="stylesheet" href="/js/jquery/css/ui-lightness/jquery-ui-1.8.10.custom.css" />';
    $smarty->assign( 'CSS_CONFLICT', $css_conflict );

    $js_conflict = '<script src="/js/jquery/jquery.js" type="text/javascript" ></script>';
    $js_conflict .= '<script src="/js/jquery/jquery.min.js" type="text/javascript"></script>';
    $js_conflict .= '<script src="/js/jquery/jquery-ui-1.8.14.custom.min.js" type="text/javascript"></script>';
    $smarty->assign( 'JS_CONFLICT', $js_conflict );

    $smarty->assign( "MODULO_PAI", ".." );
    $smarty->assign( "MODULO", "." );

    $topo = Topo::printTopo( 'diagnostic', $_SESSION['loginAccess']['configuration'], $_SESSION['loginAccess']['monitoring'], $_SESSION['loginAccess']['diagnostic'], $_SESSION['loginAccess']['administration'], '..' );
    $smarty->assign( "TOP", $topo );

    $smarty->assign( "MENU", showDirTree( ) );
    $smarty->assign( "waitForDownload", $sistema->retTranslate( 'waitForDownload' ) );

    $rodape = Rodape::printRodape( );
    $smarty->assign( "RODAPE", $rodape );

    $smarty->display( 'themes/default/default.tpl' );
