function setRefreshDelay( delay )
{
    if( delay > 0 )
    {
        $( '#delayRefresh' ).val( delay );
        $( '#refreshing' ).show( );
    }
    else
    {
        $( '#delayRefresh' ).val( delay );
        $( '#refreshing' ).hide( );
    }
    startMonitoringMessageLog( );
}

function startMonitoringMessageLog( )
{
    jQuery.ajax(
    {
        data : "ajaxTo=monitoringMessageLog",
        url : GLOBALAjaxURL,
        dataType : "json",
        success : function( ln )
        {
            countLines = countElements( ln );
            if( countLines > 0 )
            {
                var newLines = new Array( );
                for( var i = 0; i < countElements( ln ); i++ )
                    newLines[i] = ln[i];
                refreshTable( newLines );
                
                setScrollAtBottom( );
            }
        }
    } );
    var bool = $( "#delayRefresh" ).val( ) > 0;
    if( bool )
        setTimeout( "startMonitoringMessageLog()", getRefreshDelay( ) * 1000 );
}

function getRefreshDelay( )
{
    return $( '#delayRefresh' ).val( );
}

function countElements( obj )
{
    var prop;
    var propCount = 0;
    for( prop in obj )
    propCount++;
    return propCount;
}

function refreshTable( array )
{
    var table = document.getElementById('tabelaMessages').getElementsByTagName("TBODY")[0];

    for( var j = 0; j < array.length; j++ )
    {
        if( array[j] != null )
        {
            if( isValidLine( array[j] ) )
            {
                var newLine = array[j];
                var row = document.createElement( "tr" );
                var name = getNameLine( newLine );
                row.setAttribute( 'name', name );
                var td = document.createElement( "td" );
                td.className = name;
                td.appendChild( document.createTextNode( newLine ) )
                row.appendChild( td );
                table.appendChild( row );
                highlightMe( getNameLine( newLine ) );
                scrollAtBottom( );
            }
        }
    }
    var l = parent.document.getElementById( 'loadingTable' );
    l.style.display = 'none';
}

function isValidLine( line )
{
    line = line.substring( 0, 2 );
    if( line == "W|" || line == "I|" || line == "E|" )
        return true;
    else
        return false;
}

function getNameLine( charLine )
{
    switch (charLine[0])
    {
        case 'W':
            return "warning";
        case 'I':
            return 'info';
        case 'E':
            return 'error';
    }
}

function highlightMe( name )
{
    switch (name)
    {
        case 'error':
            color = 'red';
            var comps = document.getElementsByName( 'error' );
            break;

        case 'warning':
            color = "orange";
            var comps = document.getElementsByName( 'warning' );
            break;

        case 'info':
            color = "white";
            var comps = document.getElementsByName( 'info' );
            break;
    }

    for( var i = 0; i < comps.length; i++ )
        comps[i].style.background = color;
}

function scrollAtBottom( )
{
    var objDiv = document.getElementById( "right" );
    objDiv.scrollTop = objDiv.scrollHeight;
}

function showMoreMessages( oper, file )
{
    var paginator = $( '#paginator' ).val( );
    $( '#refreshing' ).show( );

    jQuery.ajax(
    {
        type : "POST",
        data : "ajaxTo=showMoreLogs&file=" + file + "&oper=" + oper + "&paginator=" + paginator,
        url : GLOBALAjaxURL,
        dataType : "json",
        success : function( json )
        {
            var countLines = countElements( json['lines'] );

            if( countLines > 0 )
            {
                printNewTable( countLines, json['lines'] );

                // top of the file
                if( json['first'] <= 0 )
                {
                    $( '#forward' ).css( 'background', '#339966' );
                    $( '#last' ).css( 'background', '#339966' );
                    $( '#back' ).css( 'background', 'grey' );
                    $( '#first' ).css( 'background', 'grey' );
                    $( '#first' ).attr( 'disabled', 'true' );
                    $( '#back' ).attr( 'disabled', 'true' );
                    $( '#last' ).removeAttr( 'disabled' );
                    $( '#forward' ).removeAttr( 'disabled' );
                }
                else
                {
                    //middle of file
                    if( json['last'] < json['fileSize'] && json['first'] > 0 )
                    {
                        $( '#back' ).css( 'background', '#339966' );
                        $( '#forward' ).css( 'background', '#339966' );
                        $( '#first' ).css( 'background', '#339966' );
                        $( '#last' ).css( 'background', '#339966' );
                        $( '#back' ).removeAttr( 'disabled' );
                        $( '#forward' ).removeAttr( 'disabled' );
                        $( '#first' ).removeAttr( 'disabled' );
                        $( '#last' ).removeAttr( 'disabled' );
                    }
                    //end of file
                    else
                    {
                        $( '#back' ).css( 'background', '#339966' );
                        $( '#first' ).css( 'background', '#339966' );
                        $( '#forward' ).css( 'background', 'grey' );
                        $( '#last' ).css( 'background', 'grey' );
                        $( '#forward' ).attr( 'disabled', 'true' );
                        $( '#last' ).attr( 'disabled', 'true' );
                        $( '#back' ).removeAttr( 'disabled' );
                        $( '#first' ).removeAttr( 'disabled' );
                    }
                }
            }
            $( '#refreshing' ).hide( );
        }
    } );
}

function printNewTable( countLines, lines )
{
    var div = document.getElementById( 'showMessages' );
    var table = document.getElementById( 'tabelaMessages' );
    div.removeChild( table );

    tab = document.createElement( 'table' );
    tab.setAttribute( 'id', 'tabelaMessages' );
    tab.setAttribute( 'border', '1' );
    tbody = document.createElement( 'tbody' )
    tab.appendChild( tbody );
    div.appendChild( tab );
    li = new Array( );

    for( i = 0; i < countLines; i++ )
    {
        if( lines[i] != null )
        {
            nameLine = getNameLine( lines[i] );
            li[i] = document.createElement( 'tr' );
            li[i].setAttribute( 'class', nameLine );
            td = document.createElement( 'td' );
            td.setAttribute( 'class', nameLine );
            text = document.createTextNode( lines[i] )
            td.appendChild( text );
            li[i].appendChild( td );
            tbody.appendChild( li[i] );
            highlightMe( getNameLine( lines[i] ) );
        }
    }
    $( '#loadingTable' ).hide( );
}

//#############################
// old stuffs but need to keep
//#############################
function setLogOptions( value )
{
    switch(value)
    {
        case 'top':
            document.getElementById( 'divSearch' ).style.display = 'none';
            document.getElementById( 'calendar' ).style.display = 'none';
            document.getElementById( 'buttonBottom' ).style.display = 'none';
            document.getElementById( 'buttonSearch' ).style.display = 'none';
            document.getElementById( 'buttonTop' ).style.display = 'block';
            document.getElementById( 'divQtdeLines' ).style.display = 'block';
            break;

        case 'bottom':
            document.getElementById( 'divSearch' ).style.display = 'none';
            document.getElementById( 'calendar' ).style.display = 'none';
            document.getElementById( 'divQtdeLines' ).style.display = 'block';
            document.getElementById( 'buttonBottom' ).style.display = 'block';
            document.getElementById( 'buttonSearch' ).style.display = 'none';
            document.getElementById( 'buttonTop' ).style.display = 'none';
            break;

        case 'search':
            document.getElementById( 'divSearch' ).style.display = 'block';
            document.getElementById( 'calendar' ).style.display = 'none';
            document.getElementById( 'divQtdeLines' ).style.display = 'none';
            document.getElementById( 'buttonSearch' ).style.display = 'block';
            document.getElementById( 'buttonBottom' ).style.display = 'none';
            document.getElementById( 'buttonTop' ).style.display = 'none';
            break;
        default:
            document.getElementById( 'divSearch' ).style.display = 'none';
            document.getElementById( 'calendar' ).style.display = 'none';
            document.getElementById( 'divQtdeLines' ).style.display = 'none';
            document.getElementById( 'buttonSearch' ).style.display = 'none';
            document.getElementById( 'buttonBottom' ).style.display = 'none';
            document.getElementById( 'buttonTop' ).style.display = 'none';
            break;
    }
}

function showCalendar( )
{
    var cal = document.getElementById( 'calendar' );
    cal.style.display = 'block';
}

function setDate( day, month, year )
{
    if( String( day ).length < 2 )
        day = "0" + day;
    if( String( month ).length < 2 )
        month = "0" + month;

    document.getElementById( 'date' ).innerHTML = day + "-" + month + "-" + year;
    document.getElementById( 'calendar' ).style.display = 'none';
}

function searchMonth( day, month, year )
{
    jQuery.ajax(
    {
        url : "calendarSearch.php",
        type : "POST",
        data : "day=" + day + "&mon=" + month + "&year=" + year,
        dataType : "html",
        success : function( calendar )
        {
            document.getElementById( 'calendar' ).innerHTML = calendar;
        }
    } );
}

function searchLog( )
{
    var date = document.getElementById( 'date' ).innerHTML;
    if( date != 'Selecione a data: ' )
    {
        var l = parent.document.getElementById( 'loadingTable' );
        l.style.display = 'block';

        jQuery.ajax(
        {
            url : "searchLog.php",
            type : "POST",
            data : "date=" + date,
            dataType : "json",
            success : function( lines )
            {
                countLines = countElements( lines );
                if( countLines > 0 )
                {
                    printNewTable( countLines, lines );
                }
            }
        } );

    }
    else
    {
        alert( 'É necessário informar uma data.' );
    }

}

function showMore( page )
{
    var linesToShow = document.getElementById( 'linesToShow' ).value;
    execute = true;
    if( linesToShow.length > 4 )
    {
        if( confirm( 'Busca muito grande. Tem certeza?' ) )
            execute = true;
        else
            execute = false;
    }

    if( execute )
    {
        var l = parent.document.getElementById( 'loadingTable' );
        l.style.display = 'block';
        jQuery.ajax(
        {
            url : "showMore.php",
            type : "POST",
            data : "page=" + page + "&linesToShow=" + linesToShow,
            dataType : "json",
            success : function( lines )
            {
                countLines = countElements( lines );
                if( countLines > 0 )
                {
                    printNewTable( countLines, lines );
                }
            }
        } );
    }
}