<?php
    if( file_exists( '/etc/elastix.conf' ) )
    {
        session_name( 'elastixSession' );
        require_once '/var/www/html/modules/khomp/constants.php';
    }
    else
    {
        require_once '../constants.php';
    }

    @session_start( );
    set_time_limit( 0 );
    unset( $_SESSION['logdir'] );

    require ("logUtil.php");

    header( "Content-Type: text/html; charset=UTF-8", true );
    date_default_timezone_set( "UTC" );

    $logdir = LogUtil::getLogDir( );
    $type = $_REQUEST['type'];

    if( isset( $_SESSION['login'] ) && $_SESSION['loginAccess']['diagnostic'] == 'full' )
    {
        if( PHP_OS == "WINNT" )
            shell_exec( KROOT . "\\..\\..\\Tools\\system_report.bat {$logdir}" );
        else
        {
            if( function_exists( 'posix_getuid' ) )
                $root = posix_getuid( ) == 0;
            else
            {
                $ret = shell_exec( 'whoami' );
                $root = strcasecmp( $ret, 'root' );
            }
            $prepend = $root ? '' : '/usr/bin/sudo -u root ';
            shell_exec( "{$prepend}/usr/sbin/khomp-sudo /usr/sbin/system_report.sh" );
        }
        appendDateOnReportFiles( );

        if( $type == 'basicLogs' )
        {
            echo getLogsDownload( 'basicLogs' );
        }
        elseif( $type == 'last24' )
        {
            echo getLogsDownload( 'logsLast24hours' );
        }
        elseif( $type == 'lastWeek' )
        {
            echo getLogsDownload( 'logsLastWeek' );
        }
    }
    else
        echo "Sem permissão";

    function getLogsDownload( $fileName )
    {
        $zipMe = array( );
        $zipMe = $_SESSION['logZipMe'];
        $today = date( "Ymd-His" );

        $fileName = LogUtil::getTempDir( ) . $fileName . '-' . $today . '.tar.gz';
        if( ZipLastLogs( $zipMe, $fileName ) )
        {
            unset( $_SESSION['logZipMe'] );
            return $fileName;
        }
    }

    function getAllLogsDownload( )
    {
        $zipMe = array( );
        $zipMe = $_SESSION['logZipMe'];

        $today = date( "Ymd-His" );
        $fileName = LogUtil::getTempDir( ) . '/AllLogs-' . $today . '.tar.gz';

        if( ZipLastLogs( $zipMe, $fileName ) )
        {
            unset( $_SESSION['logZipMe'] );
            return $fileName;
        }
    }

    function getLastDateLogsDownload( $lastDate, $period )
    {
        $zipMe = array( );
        $zipMe = $_SESSION['logZipMe'];

        $today = date( "Ymd-His" );
        $fileName = LogUtil::getTempDir( ) . '/last' . $period . 'Logs-' . $today . '.tar.gz';
        if( ZipLastLogs( $zipMe, $fileName ) )
        {
            unset( $_SESSION['logZipMe'] );
            return $fileName;
        }
    }

    function getLastLogsDownloadFile( )
    {
        $zipMe = array( );
        $zipMe = $_SESSION['logZipMe'];

        $today = date( "Ymd-His" );
        $fileName = LogUtil::getTempDir( ) . '/basicLogs-' . $today . '.tar.gz';

        if( ZipLastLogs( $zipMe, $fileName ) )
        {
            unset( $_SESSION['logZipMe'] );
            return $fileName;
        }

    }

    function getDownloadFile( $zip_name )
    {
        if( $fd = fopen( $zip_name, "r" ) )
        {
            $fsize = sprintf( "%u", filesize( $zip_name ) );
            $path_parts = pathinfo( $zip_name );
            $ext = strtolower( $path_parts["extension"] );
            header( "Content-type: application/zip" );
            header( "Content-Disposition: attachment; filename=\"" . $path_parts["basename"] . "\"" );
        }
        header( "Content-length: $fsize" );
        header( "Cache-control: private" );
        while( !feof( $fd ) )
        {
            $buffer = fread( $fd, 2048 );
            echo $buffer;
        }
        fclose( $fd );
        exit ;
    }

    function ZipLastLogs( $filesToZip, $zipName, $overwrite = true )
    {
        Global $sistema;

        if( !$overwrite )
            return false;
        $valid_files = array( );
        if( is_array( $filesToZip ) )
        {
            foreach( $filesToZip as $file )
            {
                if( file_exists( $file ) )
                    $valid_files[] = $file;
            }
        }

        $logdir = LogUtil::getLogDir( );

        if( file_exists( $logdir . 'reports' ) )
        {
            $configDir = scandir( $logdir . 'reports' );
            $reports = array( );
            foreach( $configDir as $configFile )
            {
                if( $configFile != "." && $configFile != ".." )
                    $valid_files[] = $logdir . 'reports' . DIRECTORY_SEPARATOR . $configFile;
            }
        }

        if( count( $valid_files ) )
        {
            $path = KROOT . '\\..\\..\\Tools\\';
            if( PHP_OS == "WINNT" )
            {
                if( file_exists( "{$path}tar.exe" ) && file_exists( "{$path}gzip.exe" ) )
                {
                    if( sizeof( $valid_files ) > 1 )
                    {
                        $files = str_replace( "\\", '\\\\', implode( ' ', $valid_files ) );
                        exec("{$path}tar.exe -c " . $files . " | {$path}gzip.exe > {$zipName}");
                    }

                    return file_exists( $zipName );
                }
                else
                    return false;
            }
            else
            {
                if( is_file( '/usr/bin/zip' ) && is_file( '/bin/tar' ) )
                {
                    if( sizeof( $valid_files ) > 1 )
                        exec( "tar zcf {$zipName} " . implode( ' ', $valid_files ) );

                    return file_exists( $zipName );
                }
                else
                    return false;
            }
        }
        else
            return false;

    }

    function appendDateOnReportFiles( )
    {
        $logdir = LogUtil::getLogDir( );
        if( file_exists( $logdir . 'reports' ) )
        {
            $reportDir = scandir( $logdir . 'reports' );
            foreach( $reportDir as $file )
            {
                if( $file != "." && $file != ".." )
                {
                    $fh = fopen( $logdir . 'reports' . DIRECTORY_SEPARATOR . $file, 'a+' );
                    $date = "\r\nGerado em " . date( "d/m/Y-H:i:s" ) . " UTC\r\n";
                    fwrite( $fh, $date );
                    fclose( $fh );
                }
            }
        }
    }
?>