<?php
    session_name( 'elastixSession' );
    @session_start( );

    function _moduleContent( &$smarty, $module_name )
    {
        global $dicionario, $sistema, $image_dir, $boardModel, $module_dir;

        require_once 'modules/khomp/constants.php';
        require_once KROOT . '/classes/KSystem.php';
        $app = KSystem::getInstance( );

        require_once KROOT . '/topo.php';
        require_once KROOT . '/rodape.php';
        require_once KROOT . '/util.php';
        require_once KCONFIG . '/classes/classKSistema.php';
        require_once KMONITOR . '/languages/dictionary.php';
        require_once KMONITOR . '/mapDevices.php';
        require_once KMONITOR . '/monitorService.php';
        require_once KMONITOR . '/monitorDevice.php';
        require_once KMONITOR . '/monitorLink.php';
        require_once KMONITOR . '/monitorChannel.php';

        $image_dir = "modules/khomp";
        $module_dir = "modules/{$module_name}";

        if( !isset( $_SESSION['sis'] ) )
        {
            $sistema = new KSistema( $app->getLanguage( ) );
        }
        else
        {
            $sistema = unserialize( $_SESSION['sis'] );
            $sistema->setLanguage( $app->getLanguage( ) );
        }
        $_SESSION['sis'] = serialize( $sistema );

        $_SESSION['loginAccess']['configuration'] = 'full';
        $_SESSION['loginAccess']['monitoring'] = 'full';
        $_SESSION['loginAccess']['diagnostic'] = 'full';
        $_SESSION['loginAccess']['administration'] = 'full';
        $_SESSION['login'] = 'elastix-user';
        $_SESSION['installDir'] = '/etc/khomp/';

        $ajaxTo = isset( $_REQUEST['ajaxTo'] ) ? $_REQUEST['ajaxTo'] : NULL;
        if( isset( $ajaxTo ) )
        {
            require_once KROOT . '/json_util.php';
            require_once KMONITOR . '/ajax/includeAjaxFiles.php';

            if( function_exists( $AjaxFunctions[$ajaxTo] ) )
            {
                return call_user_func_array( $AjaxFunctions[$ajaxTo], array( $_REQUEST ) );
            }
            else
            {
                return "Undefined function {$ajaxTo}";
            }
        }
        else
        {
            reimplementation( $smarty, $module_name );
        }

        return $smarty->fetch( "/var/www/html/modules/{$module_name}/themes/default/default.tpl" );
    }

    function reimplementation( $smarty, $module_name )
    {
        global $image_dir;
        $app = KSystem::getInstance( );

        $location = isset( $_REQUEST['location'] ) ? $_REQUEST['location'] : NULL;
        if( isset( $location ) )
        {
            switch( $location )
            {
                case 'services':
                    $monitor = new MonitorService( );
                    $smarty->assign( "CONTENT", $monitor->showServices( ) );
                    $smarty->assign( "LEGEND", $app->translate( 'services' ) );
                    $smarty->assign( "MODULE", 'Services' );
                    $smarty->assign( "JSmodule", 'Services' );
                    break;

                case 'devices':
                    $monitor = new MonitorDevice( );
                    $smarty->assign( "CONTENT", $monitor->showDevices( ) );
                    $smarty->assign( "LEGEND", $app->translate( 'devices' ) );
                    $smarty->assign( "MODULE", 'Devices' );
                    $smarty->assign( "JSmodule", 'Devices' );
                    break;

                case 'links':
                    $monitor = new MonitorLink( );
                    $smarty->assign( "CONTENT", $monitor->showLinks( ) );
                    $smarty->assign( "LEGEND", $app->translate( 'links' ) );
                    $smarty->assign( "MODULE", 'Links' );
                    $smarty->assign( "JSmodule", 'Links' );
                    break;

                case 'channels':
                    $monitor = new MonitorChannel( );
                    $content = $monitor->getMessages( );
                    $content .= $monitor->getDevices( );
                    $smarty->assign( "CONTENT", $content );
                    $smarty->assign( "LEGEND", $app->translate( 'channels' ) );
                    $smarty->assign( "MODULE", 'Channels' );
                    $smarty->assign( "JSmodule", 'Channels' );
                    break;
                default:
                    $monitor = new MonitorDevice( );
                    $smarty->assign( "CONTENT", $monitor->showDevices( ) );
                    $smarty->assign( "LEGEND", $app->translate( 'devices' ) );
                    $smarty->assign( "MODULE", 'Devices' );
                    $smarty->assign( "JSmodule", 'Devices' );
                    break;
            }
        }
        else
        {
            $monitor = new MonitorDevice( );
            $smarty->assign( "CONTENT", $monitor->showDevices( ) );
            $smarty->assign( "LEGEND", $app->translate( 'devices' ) );
            $smarty->assign( "MODULE", 'Devices' );
            $smarty->assign( "JSmodule", 'Devices' );

        }

        $smarty->assign( 'MODULO_PAI', 'modules/khomp' );
        $smarty->assign( 'MODULO', "modules/{$module_name}" );
        $topo = Topo::printTopo( '', '', 'none', '', '', 'modules/khomp' );
        $smarty->assign( 'TOP', $topo );
        $rodape = Rodape::printRodape( );
        $smarty->assign( 'FOOTER', $rodape );

        $dev = "<input id='devices-button' value='{$app->translate( 'devices' )}' onclick=\"window.location = 'index.php?location=devices';colorMe(this.id);\" type='button' />";
        $smarty->assign( 'DEVICES', $dev );

        $smarty->assign( 'LINKS', $app->translate( 'links' ) );
        $smarty->assign( 'CHANNELS', $app->translate( 'channels' ) );
        $smarty->assign( 'SERVICES', $app->translate( 'services' ) );
        $smarty->assign( 'REFRESH', $app->translate( 'refresh' ) );
        $smarty->assign( 'REFRESH_DELAY', $app->translate( 'refreshDelay' ) );
        $smarty->assign( 'NOT_REFRESH', $app->translate( 'notRefresh' ) );
        $smarty->assign( 'DELAY1', $app->translate( 'delay1' ) );
        $smarty->assign( 'DELAY2', $app->translate( 'delay2' ) );
        $smarty->assign( 'DELAY3', $app->translate( 'delay3' ) );

        $SO = (PHP_OS == 'WINNT') ? 'WIN' : 'LINUX';
        $smarty->assign( 'SO', $SO );

        $smarty->assign( "DESVIO_X", '150' );
        $smarty->assign( "DESVIO_Y", '150' );
    }
