function updateDataChannels( justRefresh )
{
    var board = document.getElementById( 'boardNow' );
    var link = document.getElementById( 'linkNow' );
    var gcc = document.getElementById( 'groupCh' );

    if( gcc != null )
        var gc = gcc.value;
    else
        var gc = '|';

    if( board !== null && link !== null )
    {
        var boardNow = board.value;
        var linkNow = link.value;
        $( '#refreshing' ).show( );
        jQuery.ajax(
        {
            data : "ajaxTo=updateDataChannels&boardNow=" + boardNow + "&linkNow=" + linkNow + "&gc=" + gc,
            url : GLOBALAjaxURL,
            dataType : "json",
            success : function( json )
            {
                if( json['Message']['error'] == null && json['Message']['warning'] == '' )
                {
                    if( document.getElementById( 'listDevices' ) == null )
                    {
                        sleep( 1000 );
                        window.location.reload( true );
                    }
                    else
                    {
                        $( '#divErrorMessage' ).hide( 'slow' );
                        $( '#divAlertMessage' ).hide( 'slow' );
                        $( '#listDevices' ).show( 'slow' );

                        if( document.getElementById( 'div-links' ).style.display != 'none' )
                            $( '#div-links' ).show( 'slow' );
                    }
                }
                else
                {
                    if( json['Message']['error'] != null )
                    {
                        $( '#listDevices' ).hide( 'slow' );
                        $( '#div-links' ).hide( 'slow' );
                        $( '#divErrorMessageLine' ).html( json['Message']['error'] );
                        $( '#divErrorMessage' ).show( 'slow' );
                        $( '#divAlertMessage' ).hide( 'slow' );
                        $( '#fieldsetSubConteudo' ).hide( 'slow' );
                    }
                    else
                    {
                        if( json['Message']['warning'] != '' )
                        {
                            $( '#divAlertMessageLine' ).html( json['Message']['warning'] );
                            $( '#divAlertMessage' ).show( 'slow' );
                            $( '#divErrorMessage' ).hide( 'slow' );
                        }
                    }
                }

                if( countElements( json ) > 1 )
                {
                    var linkNow = json.linkNow;
                    if( linkNow == 99 )
                    {
                        var groupCh = document.getElementById( 'groupCh' ).value;
                        var chs = groupCh.split( '|' );
                        var start = chs[0];
                        var end = chs[1];
                    }
                    else
                    {
                        var qtdeCh = countElements( json[0].links[linkNow].channels );
                        var start = 0;
                        var end = qtdeCh - 1;
                    }

                    for( var start; start <= end; start++ )
                    {
                        var ch = start;
                        if( linkNow != 99 )
                            var ch = (30 * linkNow) + start;

                        var celulaSignaling = document.getElementById( "channels-" + ch + "-signaling" );
                        var celulaStatus = document.getElementById( "channels-" + ch + "-status" );
                        var celulaDetails = document.getElementById( "channels-" + ch + "-details" );
                        var celulaInbound = document.getElementById( "channels-" + ch + "-inbound" );
                        var celulaOutbound = document.getElementById( "channels-" + ch + "-outbound" );
                        var celulaFailed = document.getElementById( "channels-" + ch + "-failed" );
                        var celulaSucceed = document.getElementById( "channels-" + ch + "-succeed" );
                        var celulaOper = document.getElementById( "channels-" + ch + "-oper" );
                        var celulaStrength = document.getElementById( "channels-" + ch + "-strength" );

                        celulaSignaling.innerHTML = json[0].links[linkNow].channels[start].signaling;

                        celulaStatus.innerHTML = json[0].links[linkNow].channels[start].callStatus;
                        celulaDetails.innerHTML = json[0].links[linkNow].channels[start].details;

                        var inbound = json[0].links[linkNow].channels[start].inbound;
                        celulaInbound.innerHTML = inbound;

                        if( inbound > 0 )
                            celulaInbound.style.fontWeight = 'bold';

                        var outbound = json[0].links[linkNow].channels[start].outbound;
                        celulaOutbound.innerHTML = outbound;

                        if( outbound > 0 )
                            celulaOutbound.style.fontWeight = 'bold';

                        var succeed = json[0].links[linkNow].channels[start].succeed;
                        celulaSucceed.innerHTML = succeed;

                        if( succeed > 0 )
                            celulaSucceed.style.fontWeight = 'bold';

                        var failed = json[0].links[linkNow].channels[start].failed;
                        celulaFailed.innerHTML = failed;

                        if( failed > 0 )
                            celulaFailed.style.fontWeight = 'bold';

                        if( celulaOper != null )
                            celulaOper.innerHTML = json[0].links[linkNow].channels[start].oper;

                        if( celulaStrength != null )
                            celulaStrength.innerHTML = json[0].links[linkNow].channels[start].strength;
                    }
                }
                $( '#refreshing' ).hide( );
            }
        } );
    }
    if( !justRefresh )
    {
        var bool = $( '#ctrlMonitoracao' ).val( ) == 1
        if( bool )
        {
            var intervalo = $( "#refreshDelay" ).val( ) * 1000;
            setTimeout( "updateDataChannels(false)", intervalo );
        }
    }
}

function exibicaoGC( serial, board, link )
{
    var gc = document.getElementById( 'channelsGC' ).value;
    var divLinks = document.getElementById( "exibicao" );
    jQuery.ajax(
    {
        data : "ajaxTo=showVoIPChannels&gc=" + gc + "&serial=" + serial + "&link=" + link + "&board=" + board,
        url : GLOBALAjaxURL,
        dataType : "text",
        success : function( text )
        {
            divLinks.innerHTML = text;
        }
    } );
}

function exibicao( link, board )
{
    var divLinks = document.getElementById( "exibicao" );
    var spans = document.getElementById( "div-links" ).getElementsByTagName( "input" );
    for( i = 0; i < spans.length; i++ )
        spans[i].style.background = "#306845";

    if( link != 99 )
        var spanSerial = document.getElementById( "span-link-" + link );
    else
    {
        var spansDev = document.getElementById( "devices" ).getElementsByTagName( "input" );
        for( i = 0; i < spansDev.length; i++ )
            spansDev[i].style.background = "#306845";

        var spanSerial = document.getElementById( "span-board-" + board );
        document.getElementById( "div-links" ).style.display = 'NONE';
        $( '#span-ch-modular' ).hide( );
    }

    jQuery.ajax(
    {
        data : "ajaxTo=showChannels&link=" + link + "&board=" + board,
        url : GLOBALAjaxURL,
        dataType : "html",
        success : function( text )
        {
            divLinks.innerHTML = text;
        }
    } );
    spanSerial.style.background = "#339966";
}

function showLinksGC( serial, board )
{
    jQuery.ajax(
    {
        data : "ajaxTo=getLinksFromDevice&serial=" + serial + "&board=" + board,
        url : GLOBALAjaxURL,
        dataType : "text",
        success : function( text )
        {
            var divLinks = document.getElementById( "div-links" );
            divLinks.innerHTML = text;
            divLinks.style.display = "block";

            var divDevice = document.getElementById( "devices" ).getElementsByTagName( "input" );

            for( i = 0; i < divDevice.length; i++ )
                divDevice[i].style.background = "#306845";

            var spanSerial = document.getElementById( "span-board-" + board );
            spanSerial.style.background = "#339966";

            $( '#channelsTable' ).hide( );
        }
    } );
}

function showModularChannels( board, serial, link, startCh, chCount )
{
    jQuery.ajax(
    {
        url : GLOBALAjaxURL,
        data : "ajaxTo=showModularChannels&board=" + board + "&serial=" + serial + "&link=" + link + "&startChannel=" + startCh + "&endChannel=" + chCount,
        dataType : "text",
        success : function( ret )
        {
            channels = ret;
            $( '#exibicao' ).html( channels );
            $( '#exibicao' ).show( );

            $( '#devices input' ).each( function( )
            {
                $( this ).css( 'background', '#306845' );
            } );

            $( '#span-board-' + board ).css( 'background', '#339966' );

            if( startCh == 0 )
                $( '#div-links' ).hide( );
            else
            {
                $( '#div-links input' ).each( function( )
                {
                    $( this ).css( 'background', '#306845' );
                } );
            }

            $( '#span-ch-modular' ).css( 'background', "#339966" );
        }
    } );

}

function showModular( board, serial )
{
    jQuery.ajax(
    {
        // url : "obtemLinksDoDevice.php?serial=" + serial + "&board=" + board,

        url : GLOBALAjaxURL,
        data : "ajaxTo=obtemLinksDoDevice&serial=" + serial + "&board=" + board,
        dataType : "text",
        success : function( text )
        {
            $( '#div-links' ).html( text );
            $( '#div-links' ).show( );
            $( '#devices input' ).each( function( )
            {
                $( this ).css( 'background', '#339966' );
            } );
            $( '#span-board-' + board ).css( 'background', '#306845' );
            $( '#channelsTable' ).hide( );
        }
    } );
}

//Links
function updateDataLinks( justRefresh )
{
    $( '#refreshing' ).show( );
    jQuery.ajax(
    {
        data : "ajaxTo=updateDataLinks",
        url : GLOBALAjaxURL,
        dataType : "json",
        success : function( json )
        {
            if( json['Message']['error'] == null && json['Message']['warning'] == '' )
            {
                if( document.getElementById( 'linkTable' ) == null && document.getElementById( 'noDeviceLink' ).value == 'undefined' )
                {
                    sleep( 1000 );
                    window.location.reload( true );
                }
                else
                {
                    $( '#divErrorMessage' ).hide( 'slow' );
                    $( '#divAlertMessage' ).hide( 'slow' );
                }
            }
            else
            {
                if( json['Message']['error'] != null )
                {
                    $( '#divErrorMessageLine' ).html( json['Message']['error'] );
                    $( '#divErrorMessage' ).show( 'slow' );
                    $( '#divAlertMessage' ).hide( 'slow' );
                }
                else
                {
                    if( json['Message']['warning'] != '' )
                    {
                        $( '#divAlertMessageLine' ).html( json['Message']['warning'] );
                        $( '#divAlertMessage' ).show( 'slow' );
                        $( '#divErrorMessage' ).hide( 'slow' );
                    }
                }
            }

            if( countElements( json ) > 1 )
            {
                for( i = 0; i < countElements( json ) - 1; i++ )
                {
                    var serial = json[i].serial;
                    for( j = 0; j < countElements( json[i].links ); j++ )
                    {
                        var statusLink = json[i].links[j]["status"];
                        var idLink = json[i].links[j]["id"];
                        var celula = document.getElementById( "links-" + serial + "-status-" + idLink );
                        celula.innerHTML = "<b>" + statusLink + "</b>";

                        var celulaAlarm = document.getElementById( "links-" + serial + "-alarms-" + idLink );
                        var celulaVariations = document.getElementById( "links-" + serial + "-variations-span-" + idLink );

                        if( json[i].links[j]["alarms"] != null || json[i].links[j]["alarms"] || undefined )
                        {
                            var texto = "";
                            if( json[i].links[j]["alarms"]["SignalLost"] )
                                texto += ajaxI18N( "SignalLost" ) + "</br>";

                            if( json[i].links[j]["alarms"]["NetworkAlarm"] )
                                texto += ajaxI18N( "NetworkAlarm" ) + "</br>";

                            if( json[i].links[j]["alarms"]["FrameSyncLost"] )
                                texto += ajaxI18N( "FrameSyncLost" ) + "</br>";

                            if( json[i].links[j]["alarms"]["MultiframeSyncLost"] )
                                texto += ajaxI18N( "MultiframeSyncLost" ) + "</br>";

                            if( json[i].links[j]["alarms"]["RemoteAlarm"] )
                                texto += ajaxI18N( "RemoteAlarm" ) + "</br>";

                            if( json[i].links[j]["alarms"]["HighErrorRate"] )
                                texto += ajaxI18N( "HighErrorRate" ) + "</br>";

                            if( json[i].links[j]["alarms"]["UnknownAlarm"] )
                                texto += ajaxI18N( "UnknownAlarm" ) + "</br>";

                            if( json[i].links[j]["alarms"]["E1Error"] )
                                texto += ajaxI18N( "E1Error" ) + "</br>";

                            if( json[i].links[j]["alarms"]["NotInitialized"] )
                                texto += ajaxI18N( "NotInitialized" ) + "</br>";

                            if( texto == "" )
                                texto = " - ";
                            celulaAlarm.innerHTML = texto;
                        }
                        else
                            celulaAlarm.innerHTML = "<b>N/A</b>"

                        if( json[i].links[j]["variations"] != null || json[i].links[j]["variations"] || undefined )
                        {
                            if( existeVariations( json[i].links[j]["variations"] ) )
                                celulaVariations.style.fontWeight = "bold";
                            else
                                celulaVariations.style.fontWeight = "normal";
                        }
                        else
                            celulaVariationsIcone.innerHTML = "<b>N/A</b>";
                    }
                }
            }
            $( '#refreshing' ).hide( );
        }
    } );
    if( !justRefresh )
    {
        var bool = document.getElementById( "ctrlMonitoracao" ).value == 1;
        if( bool )
        {
            var intervalo = document.getElementById( "refreshDelay" ).value * 1000;
            setTimeout( "updateDataLinks(false)", intervalo );
        }
    }
}

function viewVariations( event, serial, link )
{

    jQuery.ajax(
    {
        data : "ajaxTo=viewVariations&link=" + link + "&serial=" + serial,
        url : GLOBALAjaxURL,
        dataType : "html",
        success : function( result )
        {
            var div = $( "#popup" );
            div.html( result );
            div.css( 'top', event.clientY - desvioX );
            div.css( 'left', event.clientX - desvioY );
            div.show( 'slow' );
        }
    } );

}

function existeVariations( arr )
{
    if( arr["BlockedCount"] > 0 || arr["SignalLostError"] > 0 || arr["AlarmReceived"] > 0 || arr["RemoteAlarm"] > 0 || arr["SlipAlarm"] > 0 || arr["WrongEBits"] > 0 || arr["PRBS"] > 0 || arr["FIFOJitter"] > 0 || arr["FrameAlignment"] > 0 || arr["WrongFramesCount"] > 0 || arr["BipolarViolation"] > 0 || arr["CRC-4Error"] > 0 )
        return true;
    else
        return false;
}

function operationLink( serial, boardLink, operacao )
{
    $( '#refreshing' ).show( );
    jQuery.ajax(
    {
        data : "ajaxTo=operationLink&serial=" + serial + "&link=" + boardLink + "&operation=" + operacao,
        url : GLOBALAjaxURL,
        dataType : "text",
        type : "POST",
        success : function( result )
        {
            result = result.replace( /(\r\n|\n|\r)/gm, "" );
            if( result )
            {
                ShowNotice( ajaxI18N( 'performOperation' ), true );
                if( operacao == 'clean' )
                {
                    var span = document.getElementById( "links-" + serial + "-variations-span-" + boardLink );
                    span.style.fontWeight = 'normal';
                }
            }
            else
                ShowNotice( ajaxI18N( 'CanPerformOperation' ), false );
            $( '#refreshing' ).hide( );
        }
    } );
}

//Devices
function updateDataDevices( justRefresh )
{

    $( '#refreshing' ).show( );
    jQuery.ajax(
    {
        data : "ajaxTo=updateDataDevices",
        url : GLOBALAjaxURL,
        dataType : "json",
        success : function( json )
        {
            if( json['Message']['error'] == null && json['Message']['warning'] == '' )
            {
                if( document.getElementById( 'devicesTable' ) == null )
                {
                    sleep( 1000 );
                    window.location.reload( true );
                }
                else
                {
                    $( '#divErrorMessage' ).hide( 'slow' );
                    $( '#divAlertMessage' ).hide( 'slow' );
                }
            }
            else
            {
                if( json['Message']['error'] != null )
                {
                    $( '#divErrorMessageLine' ).html( json['Message']['error'] );
                    $( '#divErrorMessage' ).show( 'slow' );
                    $( '#divAlertMessage' ).hide( 'slow' );
                }
                else
                {
                    if( json['Message']['warning'] != '' )
                    {
                        $( '#divAlertMessageLine' ).html( json['Message']['warning'] );
                        $( '#divAlertMessage' ).show( 'slow' );
                        $( '#divErrorMessage' ).hide( 'slow' );
                    }
                }
            }

            if( countElements( json ) > 1 )
            {
                for( i = 0; i < countElements( json ) - 1; i++ )
                {
                    var board = json[i].board;
                    var serial = json[i].serial;
                    var modelo = json[i].modelo;
                    var status = json[i].status;
                    var celula = document.getElementById( "status-" + serial );

                    celula.innerHTML = "<b>" + status + "</b>";

                    for( j = 0; j < countElements( json[i].links ); j++ )
                    {
                        var status = json[i].links[j].status;
                        var celula = document.getElementById( "links-" + serial + "-link-" + j );
                        var texto = "Link " + j + " : ";
                        celula.innerHTML = texto + "<b>" + status + "</b></br>";
                    }

                    var celulaFail = document.getElementById( "channels-" + serial + "-fail" );
                    var fail = json[i].channels["fail"];

                    if( celulaFail != null && fail != undefined )
                        celulaFail.innerHTML = "<b>" + fail + "</b>";

                    var celulaIdle = document.getElementById( "channels-" + serial + "-idle" );
                    var idle = json[i].channels["idle"];

                    if( celulaIdle != null && idle != undefined )
                        celulaIdle.innerHTML = "<b>" + idle + "</b>";

                    var celulaCall = document.getElementById( "channels-" + serial + "-call" );
                    var call = json[i].channels["call"];

                    if( celulaCall != null && call != undefined )
                        celulaCall.innerHTML = "<b>" + call + "</b>";
                }
            }
            $( '#refreshing' ).hide( );
        }
    } );
    if( !justRefresh )
    {
        var bool = $( '#ctrlMonitoracao' ).val( ) == 1
        if( bool )
        {
            var intervalo = $( "#refreshDelay" ).val( ) * 1000;
            setTimeout( "updateDataDevices(false)", intervalo );
        }
    }
}

//Servicos
function updateDataServices( justRefresh )
{
    $( '#refreshing' ).show( );
    jQuery.ajax(
    {
        url : GLOBALAjaxURL,
        data : "ajaxTo=updateDataServices",
        dataType : "text",
        success : function( ret )
        {
            $( '#services' ).html( ret );
            $( '#refreshing' ).hide( );
        }
    } );

    if( !justRefresh )
    {
        var bool = $( '#ctrlMonitoracao' ).val( ) == 1
        if( bool )
        {
            var intervalo = $( "#refreshDelay" ).val( ) * 1000;
            setTimeout( "updateDataServices(false)", intervalo );
        }
    }
}

function isKhompAPIServerActive( )
{
    api = document.getElementById( "status-Khomp API Server" ).innerHTML;
    if( api == "<b>Ativo</b>" || api == "<b>Active</b>" )
        return true;
    else
        return false;
}

function isKhompQueryServerActive( )
{
    api = document.getElementById( "status-Khomp Query Server" ).innerHTML;
    if( api == "<b>Ativo</b>" || api == "<b>Active</b>" )
        return true;
    else
        return false;
}

function isKhompMediaServerActive( )
{
    var kmp = document.getElementById( "status-Khomp Media Server" );
    if( kmp != null )
    {
        api = document.getElementById( "status-Khomp Media Server" ).innerHTML;
        if( api == "<b>Ativo</b>" || api == "<b>Active</b>" )
            return true;
        else
            return false;
    }
    else
        return true;
}

function startService( service )
{
    if( service == "Khomp API Server" && !isKhompMediaServerActive( ) && SO == "WIN" )
    {
        if( ajaxConfirm( 'needToStartKMP' ) )
        {
            $( '#refreshing' ).show( );
            jQuery.ajax(
            {
                type : "POST",
                data : "ajaxTo=startStopServices&action=start&service=" + service,
                url : GLOBALAjaxURL,
                dataType : "text",
                success : function( ret )
                {
                    ret = ret.replace( /(\r\n|\n|\r)/gm, "" );
                    resp = ret.split( '|' );
                    if( resp[0] == 'ok' )
                        ShowNotice( resp[1], true );
                    else
                        ShowNotice( resp[1], false );
                    $( '#refreshing' ).hide( );
                }
            } );
        }
        else
            return false;
    }
    else
    {
        $( '#refreshing' ).show( );
        jQuery.ajax(
        {
            type : "POST",
            data : "ajaxTo=startStopServices&action=start&service=" + service,
            url : GLOBALAjaxURL,
            dataType : "text",
            success : function( ret )
            {
                ret = ret.replace( /(\r\n|\n|\r)/gm, "" );
                resp = ret.split( '|' );
                if( resp[0] == 'ok' )
                    ShowNotice( resp[1], true );
                else
                    ShowNotice( resp[1], false );
                $( '#refreshing' ).hide( );

            }
        } );
    }
}

function stopService( service )
{
    if( service == "Khomp Media Server" && isKhompAPIServerActive( ) && SO == "WIN" )
    {
        if( ajaxConfirm( 'needToStopK3L' ) )
        {
            $( '#refreshing' ).show( );
            jQuery.ajax(
            {
                type : "POST",
                data : "ajaxTo=startStopServices&action=stop&service=" + service,
                url : GLOBALAjaxURL,
                dataType : "text",
                success : function( ret )
                {
                    ret = ret.replace( /(\r\n|\n|\r)/gm, "" );
                    resp = ret.split( '|' );
                    if( resp[0] == 'ok' )
                        ShowNotice( resp[1], true );
                    else
                        ShowNotice( resp[1], false );
                    $( '#refreshing' ).hide( );
                }
            } );
        }
        else
            return false;
    }
    else
    {
        $( '#refreshing' ).show( );
        jQuery.ajax(
        {
            type : "POST",
            data : "ajaxTo=startStopServices&action=stop&service=" + service,
            url : GLOBALAjaxURL,
            dataType : "text",
            success : function( ret )
            {
                ret = ret.replace( /(\r\n|\n|\r)/gm, "" );
                resp = ret.split( '|' );
                if( resp[0] == 'ok' )
                    ShowNotice( resp[1], true );
                else
                    ShowNotice( resp[1], false );
                $( '#refreshing' ).hide( );
            }
        } );
    }
}

//coloring menu buttons
$( document ).ready( function( )
{
    currentMonitoring = $( '#current-monitoring' ).val( );
    $( '#' + currentMonitoring + '-button' ).css( 'background', '#339966' );
} );
