function sleep( milliseconds )
{
    var start = new Date( ).getTime( );
    while( (new Date( ).getTime( ) - start) < milliseconds )
    {
        // Do nothing
    }
}

function updateData( justRefresh, module )
{

    switch (module)
    {

        case 'Devices':
            updateDataDevices( justRefresh );
            break;
        case 'Links':
            updateDataLinks( justRefresh );
            break;
        case 'Channels':
            updateDataChannels( justRefresh );
            break;
        case 'Services':
            updateDataServices( justRefresh );
            break;
    }
}

function getRefreshDelay( module )
{
    jQuery.ajax(
    {
        data : "ajaxTo=getRefreshDelay",
        url : GLOBALAjaxURL,
        dataType : "html",
        success : function( resp )
        {

            responseText = resp.replace( /[\r\n]+/g, "" );
            if( parseInt( responseText ) > 0 )
            {
                switch (responseText)
                {
                    case '0':
                        var index = '0';
                        break;
                    case '1':
                        var index = '1';
                        break;
                    case '5':
                        var index = '2';
                        break;
                    case '30':
                        var index = '3';
                        break;
                }
                document.getElementById( 'refreshDelay' ).selectedIndex = index;
                setRefreshDelay( responseText, module );
            }
        }
    } );
}

function setRefreshDelay( delay, module )
{
    jQuery.ajax(
    {
        data : "ajaxTo=setRefreshDelay&delay=" + delay,
        url : GLOBALAjaxURL,
        dataType : "text",
        type : "POST",
        success : function( resp )
        {

            resp = resp.replace( /[\r\n]+/g, "" );

            if( parseInt( resp ) > 0 )
            {
                // document.getElementById("refreshing").style.display =
                // "inline";
                document.getElementById( "ctrlMonitoracao" ).value = "1";
                $( '#monitoring-on' ).show( );
                $( '#monitoring-off' ).hide( );
                updateData( false, module );
            }
            else
            {
                $( '#monitoring-on' ).hide( );
                $( '#monitoring-off' ).show( );
                // document.getElementById("refreshing").style.display = "none";
                document.getElementById( "ctrlMonitoracao" ).value = "0";
            }
        }
    } );
}

function countElements( obj )
{
    var prop;
    var propCount = 0;
    for( prop in obj )
    {
        propCount++;
    }
    return propCount;
}

function hideDiv( )
{
    $( "#popup" ).hide( 'slow' );
}

function colorMe( id )
{
    comp = document.getElementById( id );
    if( comp != null )
    {
        comp.style.background = '#339966';
    }
}

function ajaxConfirm( word )
{
    var retorno = '';
    jQuery.ajax(
    {
        data : "ajaxTo=I18N&word=" + word,
        url : GLOBALAjaxURL,
        dataType : "text",
        async : false,
        success : function( ret )
        {
            retorno = confirm( ret );
        }
    } );
    return retorno;
}

function ajaxAlert( word )
{
    var retorno = '';
    jQuery.ajax(
    {
        data : "ajaxTo=I18N&word=" + word,
        url : GLOBALAjaxURL,
        dataType : "text",
        async : false,
        success : function( ret )
        {
            retorno = ret;
        }
    } );
    ShowNotice( retorno );
}

function ajaxI18N( word )
{
    var retorno = '';
    jQuery.ajax(
    {
        data : "ajaxTo=I18N&word=" + word,
        url : GLOBALAjaxURL,
        dataType : "text",
        async : false,
        success : function( ret )
        {
            retorno = ret;
        }
    } );
    return retorno;
}
