<?php

    // error_reporting(E_ALL);
    require_once ("populator.php");
    require_once ("querist.php");
    require_once ("monitorService.php");
    require_once ("monitorDevice.php");

    class MonitorLink
    {
        function __construct( )
        {
            Global $sistema;
            $op = -1;
            $operational = Querist::ask( "QUERY k3l.Connected", $op );
            if( $op > 0 )
            {
                $deviceList = array( );
                $CountDevices = 0;
                Querist::ask( "QUERY k3l.DeviceCount", $CountDevices );
                for( $i = 0; $i < (int)$CountDevices; $i++ )
                {
                    $links_count = 0;
                    $query_link_count = sprintf( "QUERY k3l.Config.Device.%s.LinkCount", $i );
                    Querist::ask( $query_link_count, $links_count );
                    if( $links_count > 0 )
                    {
                        $device = array( 'model' => '', 'board' => $i, 'serial' => '', 'status' => '', 'links' => array( ) );
                        $device = Populator::populateLink( $device );
                        $deviceList[] = $device;
                    }
                }
                $_SESSION['DeviceList'] = $deviceList;
                unset( $_SESSION['errorMessage'] );
            }
            else
            {
                if( !$operational )
                {
                    unset( $_SESSION['DeviceList'] );
                    $_SESSION['errorMessage'] = $sistema->retTranslate( Querist::$last_error );
                }
                else
                    unset( $_SESSION['DeviceList'] );
            }
            if( !isset( $_SESSION['errorMessage'] ) )
                $_SESSION['errorMessage'] = MonitorService::checkMediaServerMessages( );
        }

        public static function showLinks( )
        {
            Global $sistema, $image_dir;
            $alertMessage = $sistema->retTranslate( MonitorService::getWarningMessage( ) );

            if( isset( $_SESSION['errorMessage'] ) && $_SESSION['errorMessage'] != '' )
            {
                $style1 = "display:block;";
                $style2 = "display:none;";
            }
            elseif( isset( $alertMessage ) && $alertMessage != '' )
            {
                $style2 = "display:block;";
                $style1 = "display:none;";
            }
            else
            {
                $style2 = "display:none;";
                $style1 = "display:none;";
            }

            $buffer = '';

            $buffer .= "<div id='divErrorMessage' class='errorMessage' style='$style1'>";
            $buffer .= "<img id='errorIco' src='$image_dir/imagens/error.png' />";
            $buffer .= "<div id='divErrorMessageLine'>" . $_SESSION['errorMessage'] . "</div>";
            $buffer .= "</div>";

            $buffer .= "<div id='divAlertMessage' class='errorMessage' style='$style2'>";
            $buffer .= "<img id='errorIco' src='$image_dir/imagens/error.png' />";
            $buffer .= "<div id='divAlertMessageLine'>" . $alertMessage . "</div>";
            $buffer .= "</div>";

            $buffer .= "<br>";
            $buffer .= "<input type='hidden' value='links' id='current-monitoring' />";

            if( isset( $_SESSION['DeviceList'][0] ) && sizeof( $_SESSION['DeviceList'] ) > 0 )
            {
                $deviceList = $_SESSION['DeviceList'];
                $buffer .= "<table id ='linkTable' border='1' class='tabelaLinks'>";
                $buffer .= "<tr>";
                $buffer .= "<th class='link' scope='col'><b>" . $sistema->retTranslate( "link" ) . "</b></th> ";
                $buffer .= "<th class='status' scope='col'><b>" . $sistema->retTranslate( "status" ) . "</b></th>";
                $buffer .= "<th class='label-alarms' scope='col'><b>" . $sistema->retTranslate( "alarms" ) . "</b></th>";
                $buffer .= "<th class='variations' scope='col'><b>" . $sistema->retTranslate( "variations" ) . "</b></th>";
                $buffer .= "<th class='signaling' scope='col'><b>" . $sistema->retTranslate( "signaling" ) . "</b></th>";
                $buffer .= "<th class='options' scope='col'><b>" . $sistema->retTranslate( "options" ) . "</b></th>";
                $buffer .= "</tr>";

                $column = 0;
                for( $i = 0; $i < count( $deviceList ); $i++ )
                {
                    $serial = $deviceList[$i]["serial"];
                    if( count( $deviceList[$i]['links'] ) > 0 )
                    {
                        for( $j = 0; $j < count( $deviceList[$i]['links'] ); $j++ )
                        {
                            if( ($column % 2) == 0 )
                                $buffer .= "<tr style='background: #FFFFFF;'>";
                            else
                                $buffer .= "<tr style='background: #F5F5F5;'>";

                            $column++;
                            $id = $j;
                            $link = $serial . "." . $id;

                            $buffer .= "<td id='links-" . $serial . "-link-" . $id . "' >";

                            $linkString = $link;
                            $linkString .= $deviceList[$i]['type'] == 24 ? ' (' . MonitorDevice::getRX( $id ) . ')' : '';
                            $linkString .= $deviceList[$i]['links'][$j]['nick'] != '' ? ' - ' . utf8_decode( $deviceList[$i]['links'][$j]['nick'] ) : '';

                            $buffer .= $linkString;

                            $buffer .= "</td>";
                            $buffer .= "<td id='links-" . $serial . "-status-" . $id . "'>";
                            $buffer .= "<b>" . $deviceList[$i]['links'][$j]['status'] . "</b>";
                            $buffer .= "</td>";

                            $buffer .= "<td class='alarms' id='links-" . $serial . "-alarms-" . $id . "' >";
                            if( isset( $deviceList[$i]['links'][$j]['alarms'] ) )
                            {
                                $alarms = $deviceList[$i]['links'][$j]['alarms'];
                                $existAlarm = false;
                                foreach( $alarms as $key => $value )
                                {
                                    if( $value )
                                    {
                                        $buffer .= $sistema->retTranslate( $key ) . "</br>";
                                        $existAlarm = true;
                                    }
                                }
                                if( !$existAlarm )
                                    $buffer .= "<b>-</b>";
                            }
                            else
                                $buffer .= "<b>" . $sistema->retTranslate( 'deviceUnreacheable' ) . "</b>";
                            $buffer .= "</td>";
                            $buffer .= "<td class='alarms' id=\"links-" . $serial . "-variations-" . $id . "\" >";

                            $existsVariations = existsVariations( $deviceList[$i]['links'][$j]['variations'] );
                            if( $existsVariations )
                            {
                                $buffer .= "<span style='font-weight: bold;' id=\"links-" . $serial . "-variations-span-" . $id . "\" >";
                                $buffer .= "<a href='#' onclick=\"viewVariations(event," . $serial . "," . $id . "); return true;\" >";
                                $buffer .= "<span class='span-link'>" . $sistema->retTranslate( "view" ) . "</span>";
                                $buffer .= "</a>";
                                $buffer .= "</span>";
                                if( $_SESSION['loginAccess']['monitoring'] == 'full' )
                                {
                                    $buffer .= " - ";
                                    $buffer .= "<a href='#' onclick=\"operationLink(" . $serial . "," . $id . ",'clean'" . ");updateDataLinks(true);\" >";
                                    $buffer .= "<span class='span-link'>" . $sistema->retTranslate( "clear" ) . "</span>";
                                    $buffer .= "</a>";
                                    $buffer .= "</td>";
                                }
                                else
                                {
                                    // echo "";
                                }
                            }
                            else
                            {
                                $buffer .= "<span id='links-" . $serial . "-variations-span-" . $id . "' >";
                                $buffer .= "<a href='#' onclick=\"viewVariations(event," . $serial . "," . $id . "); return true;\" >";
                                $buffer .= "<span class='span-link'>" . $sistema->retTranslate( "view" ) . "</span>";
                                $buffer .= "</a>";
                                $buffer .= "</span>";
                                if( $_SESSION['loginAccess']['monitoring'] == 'full' )
                                {
                                    $buffer .= " - ";
                                    $buffer .= "<a href='#' onclick=\"operationLink(" . $serial . "," . $id . ",'clean'" . ");updateDataLinks(true);\" >";
                                    $buffer .= "<span class='span-link'>" . $sistema->retTranslate( "clear" ) . "</span>";
                                    $buffer .= "</a>";
                                    $buffer .= "</td>";
                                }
                                else
                                {
                                    // echo "-";
                                }
                            }

                            $buffer .= "<td id=\"links-" . $serial . "-signaling-" . $id . "\" >";
                            $buffer .= $deviceList[$i]['links'][$j]['signaling'];
                            $buffer .= "</td>";

                            $buffer .= "<td class='alarms' id=\"links-" . $serial . "-options-" . $id . "\" >";

                            if( $_SESSION['loginAccess']['monitoring'] == 'full' )
                            {
                                $buffer .= "<a href='#' onclick=\"operationLink(" . $serial . "," . $id . ",'restart'" . ");\" >";
                                $buffer .= "<span class='span-link'>" . $sistema->retTranslate( "restart" ) . "</span>";
                                $buffer .= "</a>";
                                $buffer .= " - ";
                                $buffer .= "<a href='#' onclick=\"operationLink(" . $serial . "," . $id . ",'block'" . ");\" >";
                                $buffer .= "<span class='span-link'>" . $sistema->retTranslate( "block" ) . "</span>";
                                $buffer .= "</a>";
                            }
                            else
                                $buffer .= '-';
                            $buffer .= "</td>";
                        }
                    }
                    $buffer .= "</tr>";
                }
                $buffer .= "</table>";
                $buffer .= "<input type='hidden' id='lang' value='" . $sistema->getLanguage( ) . "' name='lang' />";
                $buffer .= "</br>";
            }
            else
                $buffer .= "<span id='noDeviceLink'>" . $sistema->retTranslate( "noDeviceLink" ) . "</span>";

            return $buffer;
        }

    }

    function existsVariations( $a )
    {
        $existe = 0;
        foreach( $a as $key => $value )
        {
            if( $value > 0 )
                $existe++;
        }
        if( $existe > 0 )
            return true;
        else
            return false;
    }
?>