<?php
    require_once 'constants.php';
    require_once KROOT . '/classes/KSystem.php';
    $app = KSystem::getInstance( );

    require_once KROOT . '/languages/dictionary.php';

    $action = isset( $_REQUEST['action'] ) ? $_REQUEST['action'] : NULL;
    if( isset( $action ) )
    {
        if( $action == 'logoff' )
        {
            session_destroy( );
            $host = $_SERVER['HTTP_HOST'];
            header( "Location: http://{$host}/?language={$app->getLanguage()}" );
            exit ;
        }
    }

    require_once KROOT . '/smarty-libs/Smarty.class.php';
    require_once KROOT . '/topo.php';
    require_once KROOT . '/rodape.php';
    $smarty = new Smarty( );

    $error = isset( $_REQUEST['error'] ) ? $_REQUEST['error'] : NULL;
    if( isset( $error ) )
    {
        $smarty->assign( 'ERROR', getErrorMessage( $error ) );
    }

    $smarty->assign( 'AUTENTICATION', $app->translate( 'autentication' ) );
    $smarty->assign( 'USER', $app->translate( 'user' ) );
    $smarty->assign( 'PASSWORD', $app->translate( 'password' ) );
    $smarty->assign( 'ENTER', $app->translate( 'login' ) );
    $smarty->assign( 'ERR_MSG_LOGIN', $app->translate( 'loginRequired' ) );
    $smarty->assign( 'ERR_MSG_PASSWORD', $app->translate( 'passwordRequired' ) );

    $smarty->assign( 'YOU_ARE_USING', $app->translate( 'youAreUsing' ) );
    $smarty->assign( 'SOME_FUNC_ARE_LIMITED', $app->translate( 'someFuncAreLimited' ) );
    $smarty->assign( 'YOUR_BROWSER_ISNT_COMPATIBLE', $app->translate( 'yourBrowserIsntCompatible' ) );

    $topo = Topo::printTopo( '', false, false, false, false );
    $smarty->assign( 'TOP', $topo );
    $rodape = Rodape::printRodape( );
    $smarty->assign( 'FOOTER', $rodape );
    $smarty->display( 'themes/default/default.tpl' );

    function getErrorMessage( $code )
    {
        $app = KSystem::getInstance( );

        switch( $code )
        {
            case 'Kerr1':
                return $app->translate( 'UserOrPasswdIncorrect' );
            case 'Kerr2':
                return $app->translate( 'UsersFileNotfound' );
            case 'Kerr3':
                return $app->translate( 'SessionExpired' );
            default:
                return $app->translate( 'UnknowError' );
        }
    }
