#!/bin/bash -l

LOG_NET="/var/log/khomp/reports/network.log"
LOG_FW="/var/log/khomp/reports/firewall.log"
LOG_SYS="/var/log/khomp/reports/system.log"

if [ ! -d /var/log/khomp/reports ];
then
    mkdir /var/log/khomp/reports
fi

exec 2>&1
echo -n "ifconfig: " >> "${LOG_NET}"
ifconfig >> "${LOG_NET}"
echo >> "${LOG_NET}"

echo "netstat: " >> "${LOG_NET}"
netstat -ano >> "${LOG_NET}"

echo "iptables -L: " >> "${LOG_FW}"
iptables -L >> "${LOG_FW}"

echo "uname -a: " >> "${LOG_SYS}"
uname -a >> "${LOG_SYS}"
echo >> "${LOG_SYS}"

echo "gcc --version: " >> "${LOG_SYS}"
gcc --version >> "${LOG_SYS}"
echo >> "${LOG_SYS}"

echo "ldd --version: " >> "${LOG_SYS}"
ldd --version >> "${LOG_SYS}"
echo >> "${LOG_SYS}"

cat '/etc/issue' >> "${LOG_SYS}"
echo >> "${LOG_SYS}"

echo "/proc/cpuinfo" >> "${LOG_SYS}"
cat '/proc/cpuinfo' >> "${LOG_SYS}"
echo >> "${LOG_SYS}"

echo "/proc/meminfo" >> "${LOG_SYS}"
cat '/proc/meminfo' >> "${LOG_SYS}"
echo >> "${LOG_SYS}"

echo "/proc/interrupts" >> "${LOG_SYS}"
cat '/proc/interrupts' >> "${LOG_SYS}"
echo >> "${LOG_SYS}"

echo "/proc/modules" >> "${LOG_SYS}"
cat '/proc/modules' >> "${LOG_SYS}"
echo >> "${LOG_SYS}"

echo "ps" >> "${LOG_SYS}"
ps -eo 'pid,tid,class,rtprio,ni,pri,psr,pcpu,stat,args' >> "${LOG_SYS}"
echo >> "${LOG_SYS}"

cat /proc/`pidof asterisk`/limits > limit.log
ls /proc/`pidof asterisk`/fd | wc -l >> limit.log

cp /etc/khomp/devices /var/log/khomp/reports/
