<?php
require_once KCONFIG . '/classes/classKService.php';

    function loadSystemYAML($configDir = '')
    {
        Global $sistema;

        if ($configDir == '')
            $configDir = $sistema -> getConfigDir();

        $filename = $configDir . '/system.yaml';

        if (!is_file($filename) || filesize($filename) < 1)
            copy(dirname(__FILE__) . "../../defaultConfig/defaultSystem.yaml", $configDir . "/system.yaml");

        return new KYaml($filename);
    }

    function loadKIBSYAML($configDir = '')
    {
        Global $sistema;

        if ($configDir == '')
            $configDir = $sistema -> getConfigDir();

        $filename = $configDir . '/kibs.yaml';

        return new KYaml($filename);
    }

    function getSelectorLoadService($serviceName)
    {
        Global $sistema;

        $service = new KService($serviceName);
        $serviceStartupType = $service -> getStartupType();
        $validStartupTypes = $service -> getValidTypes();
        $buff = '';
        
        $disable = PHP_OS != 'WINNT' ? "disabled='disabled'" : '';
        
        $buff .= "<select name='load-{$serviceName}' id='load-{$serviceName}' class='selector2' {$disable}>";
        foreach ($validStartupTypes as $validType)
        {
            $selected = $validType == $serviceStartupType ? 'selected' : '';
            $buff .= "<option value='$validType' $selected>" . $sistema -> retTranslate($validType) . "</option>\n";
        }
        $buff .= '</select>';
        return $buff;
    }

    function loadKLogConfigs($configDir = '')
    {

        Global $sistema;

        if ($configDir == '')
            $configDir = $sistema -> getConfigDir();

        $logConfigs = array();

        $fileContent = file($configDir . "/klog.cfg");
        $sectionName = '';
        for ($x = 0; $x < sizeof($fileContent); $x++)
        {
            if (@ereg("\[", $fileContent[$x]))
            {

                $sectionName = explode("]", $fileContent[$x]);
                $sectionName = explode("[", $sectionName[0]);
                $sectionName = $sectionName[1];
            }
            elseif (@ereg("=", $fileContent[$x]))
            {
                $varName = explode("=", $fileContent[$x]);
                $value = trim($varName[1]);
                $logConfigs[$sectionName . $varName[0]] = $value;
            }
        }
        return $logConfigs;
    }

    function getFXODevices()
    {
        Global $sistema;
        $FXOChannels = $sistema -> getFXOChannels();
        $FXOChannelsSize = sizeof($FXOChannels);
        $return = "";
        $return .= "<select id='fxodevice' onChange='javascript: selectFXODeviceChannels(this.value);'>";

        for ($i = 0; $i < $FXOChannelsSize; $i++)
            $return .= "<option value='$FXOChannels[$i]'>" . $FXOChannels[$i] . "</option>";

        $return .= "</select>";
        return $return;
    }

    function getFXODeviceChannels($device)
    {
        Global $sistema;
        $FXOChannels = $sistema -> getFXODeviceChannels($device);
        $FXOChannels = explode('-', $FXOChannels);
        $return = "";
        $return .= "<select id='fxoDeviceChannel'>";
        for ($i = $FXOChannels[0]; $i <= $FXOChannels[1]; $i++)
            $return .= "<option value='$i'>Channel " . $i . "</option>";

        $return .= "</select>";
        return $return;
    }

    function getDevicelinks($device)
    {
        Global $sistema;

        $links = $sistema -> getDeviceLinksList($device);
        $return = "<option value=''>" . $sistema -> retTranslate('SelectValue') . "</option>";
        for ($i = 0; $i < sizeof($links); $i++)
            $return .= "<option value='$links[$i]'>$links[$i]</option>";
        return $return;
    }

    function getDeviceChannels($device, $sChannel, $eChannel = '')
    {
        Global $sistema;
        $channels = $sistema -> getDeviceChannelList($device);
        $return = "<option value=''>".$sistema -> retTranslate('SelectValue') . "</option>";
        $toSelect = $sChannel;
        if ($eChannel != '')
            $toSelect = $eChannel;
        for ($i = $sChannel; $i < sizeof($channels); $i++)
        {
            if ($i == $toSelect)
                $selected = "selected";
            else
                $selected = "";

            $return .= "<option value='$channels[$i]' $selected>$channels[$i]</option>";
        }
        return $return;
    }

    function createWC($type, $wc)
    {
        switch($type)
        {
            case 'ACAnalyzer' :
                $sysYAML = loadSystemYaml();
                $WC = $sysYAML -> getValue('AutoCallAnalyzer');

                if($WC != '')
                {
                    $tmpWC = str_replace(' ', '', $WC);
                    $arr_WC = explode(',', $tmpWC);
                    if(!in_array($wc, $arr_WC))
                    {
                        $WC .= ', ' . $wc;
                        $sysYAML -> changeVarValue('AutoCallAnalyzer', $WC, 'Features');
                    }
                }
                else
                    $sysYAML -> changeVarValue('AutoCallAnalyzer', $wc, 'Features');

                $sysYAML -> saveYaml();
            break;

            case 'AECancel' :
                $sysYAML = loadSystemYaml();
                $AECancel = $sysYAML -> getValue('AutoEchoCanceller');
                if($AECancel != '')
                {
                    $tmpAE = str_replace(' ', '', $AECancel);
                    $arr_AE = explode(',', $tmpAE);
                    if(!in_array($wc, $arr_AE))
                    {
                        $AECancel .= ', ' . $wc;
                        $sysYAML -> changeVarValue('AutoEchoCanceller', $AECancel, 'Features');
                    }
                }
                 else
                    $sysYAML -> changeVarValue('AutoEchoCanceller', $wc, 'Features');

                $sysYAML -> saveYaml();
                break;

            case 'ADSup' :
                $sysYAML = loadSystemYaml();
                $AECancel = $sysYAML -> getValue('AutoDtmfSuppression');
                if($AECancel != '')
                {
                    $tmpAE = str_replace(' ', '', $AECancel);
                    $arr_AE = explode(',', $tmpAE);
                    if(!in_array($wc, $arr_AE))
                    {
                        $AECancel .= ', ' . $wc;
                        $sysYAML -> changeVarValue('AutoDtmfSuppression', $AECancel, 'Features');
                    }
                }
                 else
                    $sysYAML -> changeVarValue('AutoDtmfSuppression', $wc, 'Features');

                $sysYAML -> saveYaml();
                break;

            case 'AAGC' :
                $sysYAML = loadSystemYaml();
                $AECancel = $sysYAML -> getValue('AutoAGC');
                if($AECancel != '')
                {
                    $tmpAE = str_replace(' ', '', $AECancel);
                    $arr_AE = explode(',', $tmpAE);
                    if(!in_array($wc, $arr_AE))
                    {
                        $AECancel .= ', ' . $wc;
                        $sysYAML -> changeVarValue('AutoAGC', $AECancel, 'Features');
                    }
                }
                 else
                    $sysYAML -> changeVarValue('AutoAGC', $wc, 'Features');

                $sysYAML -> saveYaml();

                break;

            case 'DCCall' :
                $sysYAML = loadSystemYaml();
                $DCCalls = $sysYAML -> getValue('DropCollectCalls');
                $DCCalls[$wc] = array('AutoBlock' => false, 'BlockResponse' => 'Busy', 'DropCallAnalyzer' => false, 'AutoDoubleAnswer' => false, 'DoubleAnswerDelay' => 500);
                $DCCalls = precedSort($DCCalls);
                $sysYAML -> changeVarValue('DropCollectCalls', $DCCalls);
                $sysYAML -> saveYaml();
                break;

            // case 'EF' :
                // $this -> createEF($wc);
                // echo $this -> printEnabledFeatures();
                // break;
            // case 'AG' :
                // $this -> createAG($wc);
                // echo $this -> printAgcGains();
                // break;
            // case 'PAG' :
                // $this -> createPAG($wc);
                // echo $this -> printPlayerAgcGains();
                // break;
            // case 'Gen' :
                // $this -> createGen($wc);
                // echo $this -> printGenerations();
                // break;
            // case 'Det' :
                // $this -> createDet($wc);
                // echo $this -> printDetections();
                // break;
        }
    }

    function removeWC($type, $wc)
    {
        switch($type)
        {
            case 'ACAnalyzer' :
                removeACAnalyzer($wc);
                break;
            case 'AECancel' :
                removeAECancel($wc);
                break;
            case 'ADSup' :
                removeADSupression($wc);
                break;
            case 'AAGC' :
                removeAAGC($wc);
                break;
            case 'DCCall' :
                deleteDCCall($wc);
                break;


            // case 'EF' :
                // $this -> deleteEF($wc);
                // echo $this -> printEnabledFeatures();
                // break;
            // case 'AG' :
                // $this -> deleteAG($wc);
                // echo $this -> printAgcGains();
                // break;
            // case 'PAG' :
                // $this -> deletePAG($wc);
                // echo $this -> printPlayerAgcGains();
                // break;
            // case 'Gen' :
                // $this -> deleteGen($wc);
                // echo $this -> printGenerations();
                // break;
            // case 'Det' :
                // $this -> deleteDet($wc);
                // echo $this -> printDetections();
                // break;
        }
    }

    function saveDCCallConfigs($data)
    {
        $SysYAML = loadSystemYAML();
        $yaml = $SysYAML -> yaml;

        $data = explode(',', $data);
        foreach($data as $d)
        {
            $dcc = explode('|', $d);
            for($i=1;$i<sizeof($dcc);$i++)
            {
                $cv = explode(';', $dcc[$i]);
                 $yaml['Features']['DropCollectCalls'][$dcc[0]][$cv[0]] = $cv[1];
            }
        }
        $SysYAML ->yaml = $yaml;
        $SysYAML->saveYaml();
    }

    function removeACAnalyzer($wc)
        {
            $SysYAML = loadSystemYAML();
            $aca = $SysYAML -> getValue('AutoCallAnalyzer');
            $finalACA = explode(", ", $aca);

            for ($i = 0; $i < sizeof($finalACA); $i++)
            {
                if ($finalACA[$i] != $wc)
                    $tmpACA[] = $finalACA[$i];
            }

            if (sizeof($tmpACA) == 1)
                $tmpACA = $tmpACA[0];
            elseif (sizeof($tmpACA) == 0)
                $tmpACA = '!';
            else
                $tmpACA = implode(", ", $tmpACA);

            $SysYAML -> changeVarValue('AutoCallAnalyzer', $tmpACA);
            $SysYAML -> saveYaml();
        }

        function removeAECancel($wc)
        {
            $SysYAML = loadSystemYAML();
            $AECancel = $SysYAML -> getValue('AutoEchoCanceller');
            $finalACE = explode(", ", $AECancel);

            for ($i = 0; $i < sizeof($finalACE); $i++)
            {
                if ($finalACE[$i] != $wc)
                    $nAECancel[] = $finalACE[$i];
            }

            if (sizeof($nAECancel) == 1)
                $nAECancel = $nAECancel[0];
            elseif (sizeof($nAECancel) == 0)
                $nAECancel = '!';
            else
                $nAECancel = implode(", ", $nAECancel);
            $SysYAML -> changeVarValue('AutoEchoCanceller', $nAECancel);
            $SysYAML -> saveYaml();
        }

        function removeADSupression($wc)
        {
            $SysYAML = loadSystemYAML();
            $ADS = $SysYAML -> getValue('AutoDtmfSuppression');

            $ADS = explode(", ", $ADS);

            for ($i = 0; $i < sizeof($ADS); $i++)
            {
                if ($ADS[$i] != $wc)
                    $nADS[] = $ADS[$i];
            }

            if (sizeof($nADS) == 1)
                $nADS = $nADS[0];
            elseif (sizeof($nADS) == 0)
                $nADS = '!';
            else
                $nADS = implode(", ", $nADS);
            $SysYAML -> changeVarValue('AutoDtmfSuppression', $nADS);
            $SysYAML -> saveYaml();
        }

        function removeAAGC($wc)
        {
            $SysYAML = loadSystemYAML();
            $AGC = $SysYAML -> getValue('AutoAGC');
            $AGC = explode(", ", $AGC);

            for ($i = 0; $i < sizeof($AGC); $i++)
            {
                if ($AGC[$i] != $wc)
                    $nAGC[] = $AGC[$i];
            }

            if (sizeof($nAGC) == 1)
                $nAGC = $nAGC[0];
            elseif (sizeof($nAGC) == 0)
                $nAGC = '!';
            else
                $nAGC = implode(", ", $nAGC);

            $SysYAML -> changeVarValue('AutoAGC', $nAGC);
            $SysYAML -> saveYaml();
        }

        function deleteDCCall($wc)
        {
            $SysYAML = loadSystemYAML();
            $DCC = $SysYAML -> getValue('DropCollectCalls');
            if(isset($DCC[$wc]))
            {
                $SysYAML -> deleteVar($wc, 'Features|DropCollectCalls');
                $SysYAML -> saveYaml();
            }
        }

        function precedSort($sortable)
        {
            $newArray = array();

            $keys = array_keys($sortable);
            $size = sizeof($keys);
            for ($j = 0; $j < 5; $j++)
            {
                for ($i = 0; $i < $size; $i++)
                {
                    $subPart = explode(".", $keys[$i]);
                    switch($j)
                    {
                        case 0 : //channel
                            if (@ereg("\[", $subPart[1]))
                                $newArray[$keys[$i]] = $sortable[$keys[$i]];
                        break;

                        case 1 : //link
                            if ($subPart[0] != "*" && $subPart[1] != "*" && !@ereg("\[", $subPart[1]))
                                $newArray[$keys[$i]] = $sortable[$keys[$i]];
                        break;

                        case 2 : //device
                            if ($subPart[0] != "*" && $subPart[1] == "*")
                                $newArray[$keys[$i]] = $sortable[$keys[$i]];
                        break;

                        case 3 : //tech
                            if ($subPart[1] == "FXO" || $subPart[1] == "FXS" || $subPart[1] == "E1" || $subPart[1] == "GSM")
                                $newArray[$keys[$i]] = $sortable[$keys[$i]];
                        break;

                        case 4 : //all
                            if ($subPart[0] == "*" && $subPart[1] == "*")
                                $newArray[$keys[$i]] = $sortable[$keys[$i]];
                            break;
                    }
                }
            }
            return $newArray;
        }

        function getBooleanValue($string)
        {
            if($string == 'true')
                return TRUE;
            else
                return false;
        }

        //**************************** telephony

        function printProfile($profile, $type, $name, $subType, $edit = "")
        {
            switch($type)
            {
                case 'R2' :
                    $return = printR2($profile, $name, $edit, $subType);
                    break;
                case 'ISDN' :
                    $return = printDefaultIsdn($profile, $name, $edit, $subType);
                    break;
                case 'ISUP' :
                    $return = printDefaultIsup($profile, $name, $edit);
                    break;
                case 'GSM' :
                    $return = printDefaultGSM($profile, $name, $edit);
                    break;
                case 'FXS' :
                    $return = printDefaultFXS($profile, $name, $edit);
                    break;
                case 'CAS PBX' :
                    $return = printDefaultLineSide($profile, $name, $edit, $subType);
                    break;
                case 'FXO' :
                    $return = printDefaultFXO($profile, $name, $edit);
                    break;
                default :
                    break;
            }
            return $return;
        }

        function printR2($profile, $name, $edit, $subType)
        {
            Global $sistema;
            $return = "";
            $return .= "<table id='defaultProfile'>";

            $return .= "<tr class='green'>";
            $return .= "<td align='left'>".$sistema -> retTranslate('Nome')."</td>";
            $return .= "<td width='15%' align='center'>";
            if ($edit == "")
            {
                $profileName = $name . "_copy";
                while (testProfile($profileName) != "Ok")
                    $profileName .= "_copy";
                $return .= " <input class='selector2' name='name' id='name' value='$profileName' type='text' >";
            } else
                $return .= $name." <input type='hidden' id='name' name='name' value='$name'/><span id='profileAnswer'></span>";

            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='lgreen'>";
            $return .= "<td align='left'>".$sistema -> retTranslate('Type')."</td>";
            $return .= "<td width='15%' align='center'>".$profile[$name]['Type']."</td>";
            $return .= "</tr>";

            $return .= "<tr class='green'>";
            $return .= "<td align='left'>".$sistema -> retTranslate('SubType')."</td>";
            $return .= "<td align='right'>";
            $value = $profile[$name]['SubType'];
            $return .= "<select class='selector2' name='SubType' id='SubType' >";
            $possibleValues = array('MFC' => 'MFC', 'Passive' => 'Passive');
            $keys = array_keys($possibleValues);
            for ($x = 0; $x <= 1; $x++)
            {
                if ($value == $keys[$x])
                    $selected = "selected";
                else
                    $selected = "";
                $return .= "<option value='$keys[$x]' $selected>" . $keys[$x] . "</option>";
            }
            $return .= "</select>";
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='lgreen'>";
            $return .= "<td align='left'>";
            $ForcedDisconnection = $profile[$name]['ForcedDisconnection'];
            if ($ForcedDisconnection)
                $checked = "checked";
            else
                $checked = "";

            $return .= $sistema -> retTranslate('ForcedDisconnection');
            $return .= "</td>";
            $return .= "<td width='15%' align='center'>";
            $return .= "<input class='check' name='ForcedDisconnection' id='ForcedDisconnection' value='' type='checkbox' $checked>";
            $return .= "</td>";
            $return .= "</tr>";
            $checked = "";

            $return .= "<tr class='green'>";
            $return .= "<td align='left'>";
            $return .= $sistema -> retTranslate('SeizeConfirmationTimeout');
            $return .= "</td>";
            $return .= "<td align='right'>";
            $value = $profile[$name]['SeizeConfirmationTimeout'];
            $return .= intSelectMaker('SeizeConfirmationTimeout','', $value, 1000, 160000, 1000);
            $return .= "</td>";
            $return .= "</tr>";

            $return.="<tr>";
            $return.="<td align='left'>";
            $return.=$sistema->retTranslate('DestEoNStandard');
            $return.="</td>";
            $return.="<td align='right'>";
            $DestEoNStandardvalue = $profile[$name]['DestEoNStandard'];
            $return .= "<select id='DestEoNStandard' class='selector2' name='DestEoNStandard'>";

            switch($DestEoNStandardvalue)
            {
                //waitA3
                case 0:
                    $return .= "<option selected='' value='0'>".$sistema->retTranslate('waitA3')."</option>";
                    $return .= "<option value='1'>".$sistema->retTranslate('sendI15')."</option>";
                    $return .= "<option value='2'>".$sistema->retTranslate('sendI12')."</option>";
                    break;

                //sendI15
                case 1:
                    $return .= "<option value='0'>".$sistema->retTranslate('waitA3')."</option>";
                    $return .= "<option selected='' value='1'>".$sistema->retTranslate('sendI15')."</option>";
                    $return .= "<option value='2'>".$sistema->retTranslate('sendI12')."</option>";
                    break;

                //sendI12
                default:
                    $return .= "<option value='0'>".$sistema->retTranslate('waitA3')."</option>";
                    $return .= "<option value='1'>".$sistema->retTranslate('sendI15')."</option>";
                    $return .= "<option selected='' value='2'>".$sistema->retTranslate('sendI12')."</option>";
                    break;
            }

            $return .= "</select>";
            $return.="</td>";
            $return.="</tr>";

            $return .= "<tr class='lgreen'>";
            $return .= "<td align='left'>";
            $return .= $sistema -> retTranslate('AnswerSignalReceptionTimeout');
            $return .= "</td>";
            $return .= "<td align='right'>";
            $value = $profile[$name]['AnswerSignalReceptionTimeout'];
            $return .= intSelectMaker('AnswerSignalReceptionTimeout','', $value, 1000, 160000, 1000);
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='green'>";
            $return .= "<td align='left'>";
            $return .= $sistema -> retTranslate('DisconnectConfirmationTime');
            $return .= "</td>";
            $return .= "<td align='right'>";
            $value = $profile[$name]['DisconnectConfirmationTime'];
            $return .= intSelectMaker('DisconnectConfirmationTime','', $value, 1000, 160000, 1000);
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='lgreen'>";
            $return .= "<td align='left'>";
            $return .= $sistema -> retTranslate('SeizeTimeout');
            $return .= "</td>";
            $return .= "<td align='right'>";
            $value = $profile[$name]['SeizeTimeout'];
            $return .= intSelectMaker('SeizeTimeout','', $value, 1000, 160000, 1000);
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='green'>";
            $return .= "<td align='left'>";
            $return .= $sistema -> retTranslate('R2MinLineSendTime');
            $return .= "</td>";
            $return .= "<td align='right'>";
            $value = $profile[$name]['R2MinLineSendTime'];
            $return .= intSelectMaker('R2MinLineSendTime','', $value, 0, 2000, 5);
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='lgreen'>";
            $return .= "<td align='left'>";
            $return .= $sistema -> retTranslate('BillingPulseMaxTime');
            $return .= "</td>";
            $return .= "<td align='right'>";
            $value = $profile[$name]['BillingPulseMaxTime'];
            $return .= intSelectMaker('BillingPulseMaxTime','', $value, 0, 2000, 5);
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='green'>";
            $return .= "<td align='left'>";
            $return .= $sistema -> retTranslate('IdentityRequestPosition');
            $return .= "</td>";
            $return .= "<td align='right'>";
            $value = $profile[$name]['IdentityRequestPosition'];
            $return .= intSelectMaker('IdentityRequestPosition','', $value, 1, 32, 1);
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='lgreen'>";
            $return .= "<td align='left'>";
            $return .= $sistema -> retTranslate('ForwardMfcReceptionTimeout');
            $return .= "</td>";
            $return .= "<td align='right'>";
            $value = $profile[$name]['ForwardMfcReceptionTimeout'];
            $return .= intSelectMaker('ForwardMfcReceptionTimeout','', $value, 1000, 160000, 1000);
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='green'>";
            $return .= "<td align='left'>";
            $return .= $sistema -> retTranslate('ForwardMfcSendingTimeout');
            $return .= "</td>";
            $return .= "<td align='right'>";
            $value = $profile[$name]['ForwardMfcSendingTimeout'];
            $return .= intSelectMaker('ForwardMfcSendingTimeout','', $value, 1000, 160000, 1000);
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='lgreen'>";
            $return .= "<td align='left'>";
            $return .= $sistema -> retTranslate('ForwardMfcSilenceTimeout');
            $return .= "</td>";
            $return .= "<td align='right'>";
            $value = $profile[$name]['ForwardMfcSilenceTimeout'];
            $return .= intSelectMaker('ForwardMfcSilenceTimeout','', $value, 1000, 160000, 1000);
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='green'>";
            $return .= "<td align='left'>";
            $return .= $sistema -> retTranslate('MfcPulseTime');
            $return .= "</td>";
            $return .= "<td align='right'>";
            $value = $profile[$name]['MfcPulseTime'];
            $return .= intSelectMaker('MfcPulseTime','', $value, 0, 2000, 5);
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='lgreen'>";
            $return .= "<td align='left'>";
            $return .= $sistema -> retTranslate('RingbackSilenceTime');
            $return .= "</td>";
            $return .= "<td align='right'>";
            $value = $profile[$name]['RingbackSilenceTime'];
            $return .= intSelectMaker('RingbackSilenceTime','', $value, 1000, 160000, 1000);
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='green'>";
            $return .= "<td align='left'>";
            $return .= $sistema -> retTranslate('RingbackToneTime');
            $return .= "</td>";
            $return .= "<td align='right'>";
            $value = $profile[$name]['RingbackToneTime'];
            $return .= intSelectMaker('RingbackToneTime','', $value, 0, 2000, 5);
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='lgreen'>";
            $return .= "<td align='left'>";
            $return .= $sistema -> retTranslate('ChannelsDefault');
            $return .= "</td>";
            $return .= "<td align='right'>";
            $value = $profile[$name]['Channels']['Default'];
            $return .= "<select name='ChannelsDefault' id='ChannelsDefault' >";
            $possibleValues = array(1 => $sistema->retTranslate('incoming'), 2 => $sistema->retTranslate('outgoing'), 3 => $sistema->retTranslate('bidirectional'));
            for ($x = 1; $x <= 3; $x++)
            {
                $selected = ($value == $x) ? "selected" : "";
                $return .= "<option value='$x' $selected>" . $possibleValues[$x] . "</option>";
            }

            $return .= "</select>";
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='green'>";
            $return .= "<td colspan='2' >";
            $return .= "<div id='ManuallyChannelsLink'>";

            $return .= "<a href='#' onclick='showManuallyChannels();'>";
            $return .= $sistema -> retTranslate('Channels')."</a></div>";
            $showDiv = false;

            $aux = "<table class='canaisManual'>";
            for ($x = 0; $x < 30; $x++)
            {
                if (isset($profile[$name]['Channels'][$x]))
                    $value = $profile[$name]['Channels'][$x];
                else
                    $value = "";

                $entrante = "";
                $sainte = "";
                switch ($value){
                    case 1:
                        $entrante = "checked";
                        $showDiv = true;
                        break;
                    case 2:
                        $sainte = "checked";
                        $showDiv = true;
                        break;
                    case 3:
                        $entrante = "checked";
                        $sainte = "checked";
                        $showDiv = true;
                        break;
                }
                $aux .= $x % 2 == 0 ? "<tr class='green'>" : "<tr class='lgreen'>";

                if ($x > 9)
                    $aux .= "<td>".$sistema -> retTranslate('Channel') . " $x </td>";
                else
                    $aux .= "<td>".$sistema -> retTranslate('Channel') . " $x </td>";

                $aux .= "<td align='right'><input class='check' name='entrante$x' id='entrante$x' value='1' type='checkbox' $entrante><label for='entrante$x'>" . $sistema -> retTranslate('incoming') . "</label></td>";
                $aux .= "<td width='5%'><td>";
                $aux .= "<td align='left'><input class='check' name='sainte$x' id='sainte$x' value='2' type='checkbox' $sainte><label for='sainte$x'>" . $sistema -> retTranslate('outgoing') . "</label></td>";

                $aux .= "</tr>";
            }
            $aux .= "</table>";

            $style = $showDiv ? 'display:block;' : 'display:none;';
            $return .= "<div id='ManuallyChannels' style='$style'>";
            $return .= $aux;
            $return .= "</div>";
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='lgreen'>";
            $return .= "<td align='left' colspan='2'><br>";

            $JSParam = $edit == "" ? "'copy'" : "'edit'";

            // if ($subType == "Passive")
                // $return .= "<input value='" . $sistema -> retTranslate("Concluir") . "' onclick=\"javascript: createOpenR2($JSParam);\" type='button'>";
            // else
                $return .= "<input value='" . $sistema -> retTranslate("Concluir") . "' onclick=\"javascript: createR2($JSParam);\" type='button'>";
            $return .= "<input value='" . $sistema -> retTranslate("Cancelar") . "' onclick='javascript:listProfiles();' type='button'>";
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "</table>";
            return $return;
        }

        function printDefaultIsdn($profile, $name, $edit, $subType)
        {
            Global $sistema;
            $return = "";
            $return .= "<table id='defaultProfile'>";

            $return .= "<tr class='green'>";
            $return .= "<td width='85%' align='left'>";
            $return .= $sistema -> retTranslate('Nome');
            $return .= "</td>";
            $return .= "<td width='15%' align='center'>";

            if ($edit == "")
            {
                $profileName = $name . "_copy";
                while (testProfile($profileName) != "Ok")
                    $profileName .= "_copy";
                $return .= " <input class='selector2' name='name' id='name' value='$profileName' type='text' >";
            } else
                $return .= $name . "<input type='hidden' id='name' name='name' value='$name'/><span class='hidden' id='profileAnswer'></span>";

            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='lgreen'>";
            $return .= "<td width='85%' align='left'>";
            $return .= $sistema -> retTranslate('Type');
            $return .= "</td>";
            $return .= "<td width='15%' align='center'>";
            $return .= $profile[$name]['Type'];
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='green'>";
            $return .= "<td width='85%' align='left'>";
            $return .= $sistema -> retTranslate('SubType');
            $return .= "</td>";
            $return .= "<td width='15%' align='right'>";
            $value = $profile[$name]['SubType'];
            $return .= "<select class='selector2' name='SubType' id='SubType' >";
            $possibleValues = array('EndPoint' => 'EndPoint', 'Network' => 'Network', 'Passive' => 'Passive');
            $keys = array_keys($possibleValues);
            for ($x = 0; $x < sizeof($keys); $x++)
            {
                if ($value == $keys[$x])
                    $selected = "selected";
                else
                    $selected = "";
                $return .= "<option value='$keys[$x]' $selected>" . $keys[$x] . "</option>";
            }
            $return .= "</select>";
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='lgreen'>";
            $return .= "<td width='85%' align='left'>";
            $ForcedDisconnection = $profile[$name]['AlwaysSendChannelId'];
            if ($ForcedDisconnection)
                $checked = "checked";
            else
                $checked = "";
            $return .= $sistema -> retTranslate('AlwaysSendChannelId');
            $return .= "</td>";
            $return .= "<td width='15%' align='center'>";
            $return .= "<input class='check' name='AlwaysSendChannelId' id='AlwaysSendChannelId' value='' type='checkbox' $checked>";
            $return .= "</td>";
            $return .= "</tr>";
            $checked = "";

            $return .= "<tr class='green'>";
            $return .= "<td width='85%' align='left'>";
            $ForcedDisconnection = $profile[$name]['AllowTransmissionInTimeoutRecovery'];
            if ($ForcedDisconnection)
                $checked = "checked";
            else
                $checked = "";
            $return .= $sistema -> retTranslate('AllowTransmissionInTimeoutRecovery');
            $return .= "</td>";
            $return .= "<td width='15%' align='center'>";
            $return .= "<input class='check' name='AllowTransmissionInTimeoutRecovery' id='AllowTransmissionInTimeoutRecovery' value='' type='checkbox' $checked>";
            $return .= "</td>";
            $return .= "</tr>";
            $checked = "";

            $return .= "<tr class='lgreen'>";
            $return .= "<td width='85%' align='left'>";
            $return .= $sistema -> retTranslate('DefaultBearerCapability');
            $return .= "</td>";
            $return .= "<td width='15%' align='right'>";
            $value = $profile[$name]['DefaultBearerCapability'];
            $possibleValues = array("0x00 - Speech", "0x08 - Unrestricted Digital", "0x10 - Audio 3.1 KHz", "0x11 - Audio 7 KHz", "0x18 - Video");
            $return .= "<select name='DefaultBearerCapability' id='DefaultBearerCapability' >";
            for ($x = 0; $x < 5; $x++)
            {
                if ($value == $possibleValues[$x])
                    $selected = "selected";
                else
                    $selected = "";
                $return .= "<option value='$possibleValues[$x]' $selected>$possibleValues[$x]</option>";
            }
            $return .= "</select>";
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='green'>";
            $return .= "<td width='85%' align='left'>";
            $return .= $sistema -> retTranslate('DefaultHLC');
            $return .= "</td>";
            $return .= "<td width='15%' align='right'>";
            $value = $profile[$name]['DefaultHLC'];
            $possibleValues = array("0x00 - N�o Enviar", "0x81 - Telephony", "0x84 - Fax Group 23", "0xa1 - Fax Group 4", "0xa4 - Teletex F.184", "0xa8 - Teletex F.220", "0xb1 - Teletex F.200", "0xb2 - Videotex", "0xb5 - Teletex F.60", "0xb8 - MHS", "0xc1 - OSI Application", "0xde - Maintenance", "0xdf - Management");
            $return .= "<select name='DefaultHLC' id='DefaultHLC' >";
            for ($x = 0; $x < 13; $x++)
            {
                if ($value == $possibleValues[$x])
                    $selected = "selected";
                else
                    $selected = "";
                $return .= "<option value='$possibleValues[$x]' $selected>$possibleValues[$x]</option>";
            }
            $return .= "</select>";
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='lgreen'>";
            $return .= "<td width='85%' align='left'>";
            $return .= $sistema -> retTranslate('TimeslotOffsetOption');
            $return .= "</td>";
            $return .= "<td width='15%' align='right'>";
            $value = $profile[$name]['TimeslotOffsetOption'];
            $return .= intSelectMaker('TimeslotOffsetOption', '', $value, 0, 1, 1);
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='green'>";
            $return .= "<td width='85%' align='left'>";
            $return .= $sistema -> retTranslate('RejectRecovery');
            $return .= "</td>";
            $return .= "<td width='15%' align='right'>";
            $value = $profile[$name]['IsdnTimers']['RejectRecovery'];
            $return .= intSelectMaker('RejectRecovery', '', $value, 1000, 180000, 1000);
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='lgreen'>";
            $return .= "<td width='85%' align='left'>";
            $return .= $sistema -> retTranslate('SSCTt1');
            $return .= "</td>";
            $return .= "<td width='15%' align='right'>";
            $value = $profile[$name]['IsdnTimers']['SSCTt1'];
            $return .= intSelectMaker('SSCTt1', '', $value, 1000, 180000, 1000);
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='green'>";
            $return .= "<td width='85%' align='left'>";
            $return .= $sistema -> retTranslate('CTt1');
            $return .= "</td>";
            $return .= "<td width='15%' align='right'>";
            $value = $profile[$name]['IsdnTimers']['CTt1'];
            $return .= intSelectMaker('CTt1', '', $value, 1000, 180000, 1000);
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='lgreen'>";
            $return .= "<td width='85%' align='left'>";
            $return .= $sistema -> retTranslate('CTt3');
            $return .= "</td>";
            $return .= "<td width='15%' align='right'>";
            $value = $profile[$name]['IsdnTimers']['CTt3'];
            $return .= intSelectMaker('CTt3', '', $value, 1000, 180000, 1000);
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='green'>";
            $return .= "<td colspan='2' width='100%' align='left'>";
            $return .= $sistema -> retTranslate('IsdnTimers') . ": ";

            $return .= "<table class='timersManual'>";
            $return .= "<tr class='lgreen'>";
            $return .= "<td width='40%' align='center'>";
            $return .= $sistema -> retTranslate('T301');
            $return .= "</td>";
            $return .= "<td width='10%'></td>";
            $return .= "<td width='40%' align='left'>";
            $value = $profile[$name]['IsdnTimers']['T301'];
            $return .= intSelectMaker('T301', '', $value, 1000, 180000, 1000);
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='green'>";
            $return .= "<td align='center'>";
            $return .= $sistema -> retTranslate('T302');
            $return .= "</td>";
            $return .= "<td width='10%'></td>";
            $return .= "<td width='40%' align='left'>";
            $value = $profile[$name]['IsdnTimers']['T302'];
            $return .= intSelectMaker('T302', '', $value, 1000, 180000, 1000);
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='lgreen'>";
            $return .= "<td align='center'>";
            $return .= $sistema -> retTranslate('T303');
            $return .= "</td>";
            $return .= "<td width='10%'></td>";
            $return .= "<td width='40%' align='left'>";
            $value = $profile[$name]['IsdnTimers']['T303'];
            $return .= intSelectMaker('T303', '', $value, 1000, 180000, 1000);
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='green'>";
            $return .= "<td align='center'>";
            $return .= $sistema -> retTranslate('T304');
            $return .= "</td>";
            $return .= "<td width='10%'></td>";
            $return .= "<td width='40%' align='left'>";
            $value = $profile[$name]['IsdnTimers']['T304'];
            $return .= intSelectMaker('T304', '', $value, 1000, 180000, 1000);
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='lgreen'>";
            $return .= "<td align='center'>";
            $return .= $sistema -> retTranslate('T305');
            $return .= "</td>";
            $return .= "<td width='10%'></td>";
            $return .= "<td width='40%' align='left'>";
            $value = $profile[$name]['IsdnTimers']['T305'];
            $return .= intSelectMaker('T305', '', $value, 1000, 180000, 1000);
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='green'>";
            $return .= "<td align='center'>";
            $return .= $sistema -> retTranslate('T308');
            $return .= "</td>";
            $return .= "<td width='10%'></td>";
            $return .= "<td width='40%' align='left'>";
            $value = $profile[$name]['IsdnTimers']['T308'];
            $return .= intSelectMaker('T308', '', $value, 1000, 180000, 1000);
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='lgreen'>";
            $return .= "<td align='center'>";
            $return .= $sistema -> retTranslate('T309');
            $return .= "</td>";
            $return .= "<td width='10%'></td>";
            $return .= "<td width='40%' align='left'>";
            $value = $profile[$name]['IsdnTimers']['T309'];
            $return .= intSelectMaker('T309', '', $value, 1000, 180000, 1000);
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='green'>";
            $return .= "<td align='center'>";
            $return .= $sistema -> retTranslate('T310');
            $return .= "</td>";
            $return .= "<td width='10%'></td>";
            $return .= "<td width='40%' align='left'>";
            $value = $profile[$name]['IsdnTimers']['T310'];
            $return .= intSelectMaker('T310', '', $value, 1000, 180000, 1000);
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='lgreen'>";
            $return .= "<td align='center'>";
            $return .= $sistema -> retTranslate('T313');
            $return .= "</td>";
            $return .= "<td width='10%'></td>";
            $return .= "<td width='40%' align='left'>";
            $value = $profile[$name]['IsdnTimers']['T313'];
            $return .= intSelectMaker('T313', '', $value, 1000, 180000, 1000);
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='green'>";
            $return .= "<td align='center'>";
            $return .= $sistema -> retTranslate('T200');
            $return .= "</td>";
            $return .= "<td width='10%'></td>";
            $return .= "<td width='40%' align='left'>";
            $value = $profile[$name]['IsdnTimers']['T200'];
            $return .= intSelectMaker('T200', '', $value, 1000, 180000, 1000);
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='lgreen'>";
            $return .= "<td align='center'>";
            $return .= $sistema -> retTranslate('T203');
            $return .= "</td>";
            $return .= "<td width='10%'></td>";
            $return .= "<td width='40%' align='left'>";
            $value = $profile[$name]['IsdnTimers']['T203'];
            $return .= intSelectMaker('T203', '', $value, 1000, 180000, 1000);
            $return .= "</td>";
            $return .= "</tr>";
            $return .= "</table>";

            $return .= "</td>";
            $return .= "</tr>";

            $JSParam = $edit == "" ? "'copy'" : "'edit'";

            $return .= "<tr>";
            $return .= "<td align='left' colspan='2'><br>";
            $return .= "<input value='" . $sistema -> retTranslate("Concluir") . "' onclick=\"javascript:createISDN($JSParam);\" type='button'>";
            $return .= "<input value='" . $sistema -> retTranslate("Cancelar") . "' onclick='javascript:listProfiles();' type='button'>";
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "</table>";
            return $return;
        }

        function printDefaultGSM($profile, $name, $edit)
        {
            Global $sistema;
            $return = "";
            $return .= "<table id='defaultProfile'>";

            $return .= "<tr class='green'>";
            $return .= "<td align='left'>";
            $return .= $sistema -> retTranslate('Nome');
            $return .= "</td>";
            $return .= "<td width='15%' align='center'>";

            if ($edit == "")
            {
                $profileName = $name . "_copy";
                while (testProfile($profileName) != "Ok")
                    $profileName .= "_copy";

                $return .= " <input class='selector2' name='name' id='name' value='$profileName' type='text' >";
            }
            else
                $return .= $name . "<input type='hidden' id='name' name='name' value='$name'/><span class='hidden' id='profileAnswer'></span>";

            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='lgreen'>";
            $return .= "<td align='left'>";
            $return .= $sistema -> retTranslate('Type');
            $return .= "</td>";
            $return .= "<td width='15%' align='center'>";
            $return .= $profile[$name]['Type'];
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='green'>";
            $return .= "<td align='left'>";
            $DecodeReceivedSMS = $profile[$name]['DecodeReceivedSMS'];
            if ($DecodeReceivedSMS)
                $checked = "checked";
            else
                $checked = "";
            $return .= $sistema -> retTranslate('DecodeReceivedSMS');
            $return .= "</td>";
            $return .= "<td width='15%' align='center'>";
            $return .= "<input class='check' name='DecodeReceivedSMS' id='DecodeReceivedSMS' value='' type='checkbox' $checked>";
            $return .= "</td>";
            $return .= "</tr>";
            $checked = "";

            $return .= "<tr class='lgreen'>";
            $return .= "<td align='left'>";
            $EnableCallHold = $profile[$name]['EnableCallHold'];
            if ($EnableCallHold)
                $checked = "checked";
            else
                $checked = "";
            $return .= $sistema -> retTranslate('EnableCallHold');
            $return .= "</td>";
            $return .= "<td width='15%' align='center'>";
            $return .= "<input class='check' name='EnableCallHold' id='EnableCallHold' value='' type='checkbox' $checked>";
            $return .= "</td>";
            $return .= "</tr>";
            $checked = "";

            $return .= "<tr class='green'>";
            $return .= "<td align='left'>";
            $DisableCallForward = $profile[$name]['DisableCallForward'];
            if ($DisableCallForward)
                $checked = "checked";
            else
                $checked = "";
            $return .= $sistema -> retTranslate('DisableCallForward');
            $return .= "</td>";
            $return .= "<td width='15%' align='center'>";
            $return .= "<input class='check' name='DisableCallForward' id='DisableCallForward' value='' type='checkbox' $checked>";
            $return .= "</td>";
            $return .= "</tr>";
            $checked = "";

            $return .= "<tr class='lgreen'>";
            $return .= "<td align='left'>";
            $ReceivePduSms = $profile[$name]['ReceivePduSms'];
            if ($ReceivePduSms)
                $checked = "checked";
            else
                $checked = "";
            $return .= $sistema -> retTranslate('ReceivePduSms');
            $return .= "</td>";
            $return .= "<td width='15%' align='center'>";
            $return .= "<input class='check' name='ReceivePduSms' id='ReceivePduSms' value='' type='checkbox' $checked>";
            $return .= "</td>";
            $return .= "</tr>";
            $checked = "";

            $return .= "<tr class='green'>";
            $return .= "<td align='left'>";
            $return .= $sistema -> retTranslate('TimeOutModem');
            $return .= "</td>";
            $return .= "<td align='right'>";
            $value = $profile[$name]['TimeOutModem'];
            $return .= intSelectMaker('TimeOutModem', '', $value, 1000, 160000, 1000);
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='lgreen'>";
            $return .= "<td align='left'>";
            $return .= $sistema -> retTranslate('CheckNetworkTimeOut');
            $return .= "</td>";
            $return .= "<td align='right'>";
            $value = $profile[$name]['CheckNetworkTimeOut'];
            $return .= intSelectMaker('CheckNetworkTimeOut', '', $value, 1000, 160000, 1000);
            $return .= "</td>";
            $return .= "</tr>";
            $JSParam = $edit == "" ? "'copy'" : "'edit'";
            $return .= "<tr>";
            $return .= "<td align='left' colspan='2'><br>";
            $return .= "<input value='" . $sistema -> retTranslate("Concluir") . "' onclick=\"javascript:createGSM($JSParam);\" type='button'>";
            $return .= "<input value='" . $sistema -> retTranslate("Cancelar") . "' onclick='javascript:listProfiles();' type='button'>";
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "</table>";
            return $return;
        }

        function printDefaultFXS($profile, $name, $edit)
        {
            Global $sistema;
            $return = "";
            $return .= "<table id='defaultProfile'>";

            $return .= "<tr class='green'>";
            $return .= "<td align='left'>";
            $return .= $sistema -> retTranslate('Nome');
            $return .= "</td>";
            $return .= "<td width='15%' align='center'>";

            if ($edit == "")
            {
                $profileName = $name . "_copy";

                while (testProfile($profileName) != "Ok")
                    $profileName .= "_copy";

                $return .= " <input class='selector2' name='name' id='name' value='$profileName' type='text' >";
            }
            else
                $return .= $name . " <input type='hidden' id='name' name='name' value='$name'/><span class='hidden' id='profileAnswer'></span>";

            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='lgreen'>";
            $return .= "<td align='left'>";
            $return .= $sistema -> retTranslate('Type');
            $return .= "</td>";
            $return .= "<td width='15%' align='center'>";
            $return .= $profile[$name]['Type'];
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='green'>";
            $return .= "<td align='left'>";
            $return .= $sistema -> retTranslate('CadenceTimes');
            $return .= "</td>";
            $return .= "<td align='right'>";
            $valueA = $profile[$name]['CadenceTimes'][0];
            $valueB = $profile[$name]['CadenceTimes'][1];
            $valueC = $profile[$name]['CadenceTimes'][2];
            $valueD = $profile[$name]['CadenceTimes'][3];
            $return .= intSelectMaker('CadenceTimesA', 'CadenceTime', $valueA, 50, 16000, 50);
            $return .= intSelectMaker('CadenceTimesB', 'CadenceTime', $valueB, 50, 16000, 50);
            $return .= "<br>";
            $return .= intSelectMaker('CadenceTimesC', 'CadenceTime', $valueC, 50, 16000, 50);
            $return .= intSelectMaker('CadenceTimesD', 'CadenceTime', $valueD, 50, 16000, 50);
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='lgreen'>";
            $return .= "<td align='left'>";
            $return .= $sistema -> retTranslate('FlashThresholdTime');
            $return .= "</td>";
            $return .= "<td align='right'>";
            $value = $profile[$name]['FlashThresholdTime'];
            $return .= intSelectMaker('FlashThresholdTime','FlashValidationTime', $value, 0, 5000, 5);
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='green'>";
            $return .= "<td align='left'>";
            $return .= $sistema -> retTranslate('FlashValidationTime');
            $return .= "</td>";
            $return .= "<td align='right'>";
            $value = $profile[$name]['FlashValidationTime'];
            $return .= intSelectMaker('FlashValidationTime','FlashValidationTime' ,$value, 0, 5000, 5);
            $return .= "</td>";
            $return .= "</tr>";
            $JSParam = $edit == "" ? "'copy'" : "'edit'";
            $return .= "<tr >";
            $return .= "<td align='left' colspan='2'><br>";
            $return .= "<input value='" . $sistema -> retTranslate("Concluir") . "' onclick=\"javascript:createFXS($JSParam);\" type='button'>";
            $return .= "<input value='" . $sistema -> retTranslate("Cancelar") . "' onclick='javascript:listProfiles();' type='button'>";
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "</table>";
            return $return;
        }

        function printDefaultLineSide($profile, $name, $edit, $subType)
        {
            Global $sistema;
            $return = "";
            $return .= "<table id='defaultProfile'>";

            $return .= "<tr class='green'>";
            $return .= "<td align='left'>";
            $return .= $sistema -> retTranslate('Nome');
            $return .= "</td>";
            $return .= "<td width='15%' align='center'>";

            if ($edit == "")
            {
                $profileName = $name . "_copy";
                while (testProfile($profileName) != "Ok")
                    $profileName .= "_copy";

                $return .= " <input class='selector2' name='name' id='name' value='$profileName' type='text' >";
            }
            else
                $return .= $name ." <input type='hidden' id='name' name='name' value='$name'/><span class='hidden' id='profileAnswer'></span>";

            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='lgreen'>";
            $return .= "<td align='left'>";
            $return .= $sistema -> retTranslate('Type');
            $return .= "</td>";
            $return .= "<td width='15%' align='center'>";
            $return .= $profile[$name]['Type'];
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='green'>";
            $return .= "<td align='left'>";
            $return .= $sistema -> retTranslate('SubType');
            $return .= "</td>";
            $return .= "<td align='right'>";
            $value = $profile[$name]['SubType'];
            $return .= "<select class='selector2' name='SubType' id='SubType' >";
            $possibleValues = array('LineSide' => 'LineSide', 'EL7' => 'EL7', 'LC' => 'LC');
            $keys = array_keys($possibleValues);
            for ($x = 0; $x < sizeof($keys); $x++)
            {
                if ($value == $keys[$x])
                    $selected = "selected";
                else
                    $selected = "";
                $return .= "<option value='$keys[$x]' $selected>" . $keys[$x] . "</option>";
            }
            $return .= "</select>";
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='lgreen'>";
            $return .= "<td align='left'>";
            $UseAddressSignaling = $profile[$name]['UseAddressSignaling'];
            if ($UseAddressSignaling)
                $checked = "checked";
            else
                $checked = "";
            $return .= $sistema -> retTranslate('UseAddressSignaling');
            $return .= "</td>";
            $return .= "<td width='15%' align='center'>";
            $return .= "<input class='check' name='UseAddressSignaling' id='UseAddressSignaling' value='' type='checkbox' $checked>";
            $return .= "</td>";
            $return .= "</tr>";
            $checked = "";

            $return .= "<tr class='green'>";
            $return .= "<td align='left'>";
            $UseAnswerSupervision = $profile[$name]['UseAnswerSupervision'];
            if ($UseAnswerSupervision)
                $checked = "checked";
            else
                $checked = "";
            $return .= $sistema -> retTranslate('UseAnswerSupervision');
            $return .= "</td>";
            $return .= "<td width='15%' align='center'>";
            $return .= "<input class='check' name='UseAnswerSupervision' id='UseAnswerSupervision' value='' type='checkbox' $checked>";
            $return .= "</td>";
            $return .= "</tr>";
            $checked = "";

            $return .= "<tr class='lgreen'>";
            $return .= "<td align='left'>";
            $UseFarEndDisconnect = $profile[$name]['UseFarEndDisconnect'];
            if ($UseFarEndDisconnect)
                $checked = "checked";
            else
                $checked = "";
            $return .= $sistema -> retTranslate('UseFarEndDisconnect');
            $return .= "</td>";
            $return .= "<td width='15%' align='center'>";
            $return .= "<input class='check' name='UseFarEndDisconnect' id='UseFarEndDisconnect' value='' type='checkbox' $checked>";
            $return .= "</td>";
            $return .= "</tr>";
            $checked = "";

            $return .= "<tr class='green'>";
            $return .= "<td align='left'>";
            $return .= $sistema -> retTranslate('ReleaseTime');
            $return .= "</td>";
            $return .= "<td align='right'>";
            $value = $profile[$name]['ReleaseTime'];
            $return .= intSelectMaker('ReleaseTime','', $value, 0, 10000, 500);
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='lgreen'>";
            $return .= "<td align='left'>";
            $return .= $sistema -> retTranslate('AbandonTime');
            $return .= "</td>";
            $return .= "<td align='right'>";
            $value = $profile[$name]['AbandonTime'];
            $return .= intSelectMaker('AbandonTime','', $value, 1000, 16000, 1000);
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='green'>";
            $return .= "<td align='left'>";
            $return .= $sistema -> retTranslate('RingsToNotify');
            $return .= "</td>";
            $return .= "<td align='right'>";
            $value = $profile[$name]['RingsToNotify'];
            $return .= intSelectMaker('RingsToNotify','', $value, 1, 10, 1);
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='lgreen'>";
            $return .= "<td align='left'>";
            $return .= $sistema -> retTranslate('FlashTime');
            $return .= "</td>";
            $return .= "<td align='right'>";
            $value = $profile[$name]['FlashTime'];
            $return .= intSelectMaker('FlashTime','', $value, 100, 16000, 100);
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='green'>";
            $return .= "<td align='left'>";
            $return .= $sistema -> retTranslate('LongSignalingTime');
            $return .= "</td>";
            $return .= "<td align='right'>";
            $value = $profile[$name]['LongSignalingTime'];
            $return .= intSelectMaker('LongSignalingTime','', $value, 0, 16000, 100);
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='lgreen'>";
            $return .= "<td align='left'>";
            $return .= $sistema -> retTranslate('ShortSignalingTime');
            $return .= "</td>";
            $return .= "<td align='right'>";
            $value = $profile[$name]['ShortSignalingTime'];
            $return .= intSelectMaker('ShortSignalingTime','', $value, 0, 16000, 100);
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='green'>";
            $return .= "<td align='left'>";
            $return .= $sistema -> retTranslate('SeizeTimeout');
            $return .= "</td>";
            $return .= "<td align='right'>";
            $value = $profile[$name]['SeizeTimeout'];
            $return .= intSelectMaker('SeizeTimeout','', $value, 1000, 160000, 1000);
            $return .= "</td>";
            $return .= "</tr>";
            $JSParam = $edit == "" ? "'copy'" : "'edit'";
            $return .= "<tr>";
            $return .= "<td align='left' colspan='2'><br>";
            // if ($subType == "LineSide")
                // $return .= "<input value='" . $sistema -> retTranslate("Concluir") . "' onclick=\"javascript: createLineSide($JSParam);\" type='button'>";
            // elseif ($subType == "EL7")
                // $return .= "<input value='" . $sistema -> retTranslate("Concluir") . "' onclick=\"javascript: createLineSideEL7($JSParam);\" type='button'>";
            // else
                $return .= "<input value='" . $sistema -> retTranslate("Concluir") . "' onclick=\"javascript: createLineSide($JSParam);\" type='button'>";
            $return .= "<input value='" . $sistema -> retTranslate("Cancelar") . "' onclick='javascript:listProfiles();' type='button'>";
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "</table>";
            return $return;
        }

        function printDefaultFXO($profile, $name, $edit)
        {
            Global $sistema;
            $return = "";
            $return .= "<table id='defaultProfile'>";

            $return .= "<tr class='green'>";
            $return .= "<td align='left'>";
            $return .= $sistema -> retTranslate('Nome');
            $return .= "</td>";
            $return .= "<td width='15%' align='center'>";

            if ($edit == "")
            {
                $profileName = $name . "_copy";
                while (testProfile($profileName) != "Ok")
                    $profileName .= "_copy";

                $return .= " <input class='selector2' name='name' id='name' value='$profileName' type='text' >";
            }
            else
                $return .= $name ." <input type='hidden' id='name' name='name' value='$name'/><span class='hidden' id='profileAnswer'></span>";

            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr  class='lgreen'>";
            $return .= "<td align='left'>";
            $return .= $sistema -> retTranslate('Type');
            $return .= "</td>";
            $return .= "<td width='15%' align='center'>";
            $return .= $profile[$name]['Type'];
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr  class='green'>";
            $return .= "<td align='left'>";
            $DisconnectOnPolarityReversal = $profile[$name]['DisconnectOnPolarityReversal'];
            if ($DisconnectOnPolarityReversal)
                $checked = "checked";
            else
                $checked = "";
            $return .= $sistema -> retTranslate('DisconnectOnPolarityReversal');
            $return .= "</td>";
            $return .= "<td width='15%' align='center'>";
            $return .= "<input class='check' name='DisconnectOnPolarityReversal' id='DisconnectOnPolarityReversal' value='' type='checkbox' $checked>";
            $return .= "</td>";
            $return .= "</tr>";
            $checked = "";

            $return .= "<tr class='lgreen'>";
            $return .= "<td align='left'>";
            $return .= $sistema -> retTranslate('RingsToNotify');
            $return .= "</td>";
            $return .= "<td align='right'>";
            $value = $profile[$name]['RingsToNotify'];
            $return .= intSelectMaker('RingsToNotify','', $value, 1, 10, 1);
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='green'>";
            $return .= "<td align='left'>";
            $return .= $sistema -> retTranslate('SeizeTimeout');
            $return .= "</td>";
            $return .= "<td align='right'>";
            $value = $profile[$name]['SeizeTimeout'];
            $return .= intSelectMaker('SeizeTimeout','', $value, 1000, 160000, 1000);
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='lgreen'>";
            $return .= "<td align='left'>";
            $return .= $sistema -> retTranslate('FlashTime');
            $return .= "</td>";
            $return .= "<td align='right'>";
            $value = $profile[$name]['FlashTime'];
            $return .= intSelectMaker('FlashTime','', $value, 100, 16000, 100);
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='green'>";
            $return .= "<td align='left'>";
            $return .= $sistema -> retTranslate('FlashValidationTime');
            $return .= "</td>";
            $return .= "<td align='right'>";
            $value = $profile[$name]['FlashValidationTime'];
            $return .= intSelectMaker('FlashValidationTime','', $value, 100, 16000, 100);
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "<tr class='lgreen'>";
            $return .= "<td align='left'>";
            $return .= $sistema -> retTranslate('LineTerminationImpedance');
            $return .= "</td>";
            $return .= "<td align='right'>";
            $value = $profile[$name]['LineTerminationImpedance'];
            $return .= intSelectMaker('LineTerminationImpedance','', $value, 600, 900, 300);
            $return .= "</td>";
            $return .= "</tr>";
            $JSParam = $edit == "" ? "'copy'" : "'edit'";
            $return .= "<tr>";
            $return .= "<td align='left' colspan='2'><br>";
            $return .= "<input value='" . $sistema -> retTranslate("Concluir") . "' onclick=\"javascript:createFXO($JSParam);\" type='button'>";
            $return .= "<input value='" . $sistema -> retTranslate("Cancelar") . "' onclick='javascript:listProfiles();' type='button'>";
            $return .= "</td>";
            $return .= "</tr>";

            $return .= "</table>";
            return $return;
        }

        function createR2($variables, $newProfile)
        {
            $Profiles = new KProfiles();
            $name = $variables['name'];
            $pos = $Profiles -> getProfilePosition($name);
            $edit = strlen($pos) >= 1 && $pos > -1 ? true : false;

            if($newProfile && $edit)
                return false;

            $profile = array();
            $profile['Type'] = 'R2';
            $profile['SubType'] = $variables['SubType'];
            $profile['ForcedDisconnection'] = checkBooleanValue($variables['ForcedDisconnection']);
            $profile['SeizeConfirmationTimeout'] = checkBooleanValue($variables['SeizeConfirmationTimeout']);
            $profile['DestEoNStandard'] = checkBooleanValue($variables['DestEoNStandard']);
            $profile['AnswerSignalReceptionTimeout'] = checkBooleanValue($variables['AnswerSignalReceptionTimeout']);
            $profile['DisconnectConfirmationTime'] = checkBooleanValue($variables['DisconnectConfirmationTime']);
            $profile['SeizeTimeout'] = checkBooleanValue($variables['SeizeTimeout']);
            $profile['R2MinLineSendTime'] = checkBooleanValue($variables['R2MinLineSendTime']);
            $profile['BillingPulseMaxTime'] = checkBooleanValue($variables['BillingPulseMaxTime']);
            $profile['IdentityRequestPosition'] = checkBooleanValue($variables['IdentityRequestPosition']);
            $profile['ForwardMfcReceptionTimeout'] = checkBooleanValue($variables['ForwardMfcReceptionTimeout']);
            $profile['ForwardMfcSendingTimeout'] = checkBooleanValue($variables['ForwardMfcSendingTimeout']);
            $profile['ForwardMfcSilenceTimeout'] = checkBooleanValue($variables['ForwardMfcSilenceTimeout']);
            $profile['MfcPulseTime'] = checkBooleanValue($variables['MfcPulseTime']);
            $profile['RingbackSilenceTime'] = checkBooleanValue($variables['RingbackSilenceTime']);
            $profile['RingbackToneTime'] = checkBooleanValue($variables['RingbackToneTime']);
            $profile['Channels']['Default'] = checkBooleanValue($variables['ChannelsDefault']);

            for ($x = 0; $x < 30; $x++)
            {
                if (isset($variables['Channels' . $x]))
                    $profile['Channels'][$x] = $variables['Channels' . $x];
            }

            $tmp = $Profiles -> profilesYaml -> getYaml();
            if($edit)
                $tmp['ChannelGroupProfiles'][$pos][$name] = $profile;
            else
                $tmp['ChannelGroupProfiles'][] = array($name => $profile);
            $Profiles -> profilesYaml -> yaml = $tmp;

            $Profiles -> saveProfiles();
            return true;
        }

        function createIsdn($variables, $newProfile)
        {
            $Profiles = new KProfiles();
            $name = $variables['name'];
            $pos = $Profiles -> getProfilePosition($name);
            $edit = strlen($pos) >= 1 && $pos > -1 ? true : false;

            if($newProfile && $edit)
                return false;

            $profile = array();
            $profile['Type'] = 'ISDN';
            $profile['SubType'] = $variables['SubType'];
            $profile['DefaultBearerCapability'] = checkBooleanValue($variables['DefaultBearerCapability']);
            $profile['DefaultHLC'] = checkBooleanValue($variables['DefaultHLC']);
            $profile['AlwaysSendChannelId'] = checkBooleanValue($variables['AlwaysSendChannelId']);
            $profile['AllowTransmissionInTimeoutRecovery'] = checkBooleanValue($variables['AllowTransmissionInTimeoutRecovery']);
            $profile['TimeslotOffsetOption'] = checkBooleanValue($variables['TimeslotOffsetOption']);
            $profile['IsdnTimers']['T301'] = checkBooleanValue($variables['T301']);
            $profile['IsdnTimers']['T302'] = checkBooleanValue($variables['T302']);
            $profile['IsdnTimers']['T303'] = checkBooleanValue($variables['T303']);
            $profile['IsdnTimers']['T304'] = checkBooleanValue($variables['T304']);
            $profile['IsdnTimers']['T305'] = checkBooleanValue($variables['T305']);
            $profile['IsdnTimers']['T308'] = checkBooleanValue($variables['T308']);
            $profile['IsdnTimers']['T309'] = checkBooleanValue($variables['T309']);
            $profile['IsdnTimers']['T310'] = checkBooleanValue($variables['T310']);
            $profile['IsdnTimers']['T313'] = checkBooleanValue($variables['T313']);
            $profile['IsdnTimers']['T200'] = checkBooleanValue($variables['T200']);
            $profile['IsdnTimers']['T203'] = checkBooleanValue($variables['T203']);
            $profile['IsdnTimers']['RejectRecovery'] = checkBooleanValue($variables['RejectRecovery']);
            $profile['IsdnTimers']['SSCTt1'] = checkBooleanValue($variables['SSCTt1']);
            $profile['IsdnTimers']['CTt1'] = checkBooleanValue($variables['CTt1']);
            $profile['IsdnTimers']['CTt3'] = checkBooleanValue($variables['CTt3']);

            $tmp = $Profiles -> profilesYaml -> getYaml();
            if($edit)
                $tmp['ChannelGroupProfiles'][$pos][$name] = $profile;
            else
                $tmp['ChannelGroupProfiles'][] = array($name => $profile);
            $Profiles -> profilesYaml -> yaml = $tmp;

            $Profiles -> saveProfiles();
            return true;
        }

        function createGSM($variables, $newProfile)
        {
            $Profiles = new KProfiles();
            $name = $variables['name'];
            $pos = $Profiles -> getProfilePosition($name);
            $edit = strlen($pos) >= 1 && $pos > -1 ? true : false;

            if($newProfile && $edit)
                return false;

            $profile = array();
            $profile['Type'] = 'GSM';
            $profile['TimeOutModem'] = checkBooleanValue($variables['TimeOutModem']);
            $profile['CheckNetworkTimeOut'] = checkBooleanValue($variables['CheckNetworkTimeOut']);
            $profile['EnableCallHold'] = checkBooleanValue($variables['EnableCallHold']);
            $profile['DisableCallForward'] = checkBooleanValue($variables['DisableCallForward']);
            $profile['ReceivePduSms'] = checkBooleanValue($variables['ReceivePduSms']);
            $profile['DecodeReceivedSMS'] = checkBooleanValue($variables['DecodeReceivedSMS']);

            $tmp = $Profiles -> profilesYaml -> getYaml();
            if($edit)
                $tmp['ChannelGroupProfiles'][$pos][$name] = $profile;
            else
                $tmp['ChannelGroupProfiles'][] = array($name => $profile);
            $Profiles -> profilesYaml -> yaml = $tmp;

            $Profiles -> saveProfiles();
            return true;
        }

        function createFXS($variables, $newProfile)
        {
            $Profiles = new KProfiles();
            $name = $variables['name'];
            $pos = $Profiles -> getProfilePosition($name);
            $edit = strlen($pos) >= 1 && $pos > -1 ? true : false;

            if($newProfile && $edit)
                return false;

            $profile = array();
            $profile['Type'] = 'FXS';
            $profile['CadenceTimes'][0] = checkBooleanValue($variables['CadenceTimesA']);
            $profile['CadenceTimes'][1] = checkBooleanValue($variables['CadenceTimesB']);
            $profile['CadenceTimes'][2] = checkBooleanValue($variables['CadenceTimesC']);
            $profile['CadenceTimes'][3] = checkBooleanValue($variables['CadenceTimesD']);
            $profile['FlashThresholdTime'] = checkBooleanValue($variables['FlashThresholdTime']);
            $profile['FlashValidationTime'] = checkBooleanValue($variables['FlashValidationTime']);

            $tmp = $Profiles -> profilesYaml -> getYaml();
            if($edit)
                $tmp['ChannelGroupProfiles'][$pos][$name] = $profile;
            else
                $tmp['ChannelGroupProfiles'][] = array($name => $profile);
            $Profiles -> profilesYaml -> yaml = $tmp;

            $Profiles -> saveProfiles();
            return true;
        }

        function createLineSide($variables, $newProfile)
        {
            $Profiles = new KProfiles();
            $name = $variables['name'];
            $pos = $Profiles -> getProfilePosition($name);
            $edit = strlen($pos) >= 1 && $pos > -1 ? true : false;

            if($newProfile && $edit)
                return false;

            $profile = array();
            $profile['Type'] = 'CAS PBX';
            $profile['SubType'] = $variables['SubType'];
            $profile['UseAddressSignaling'] = checkBooleanValue($variables['UseAddressSignaling']);
            $profile['UseAnswerSupervision'] = checkBooleanValue($variables['UseAnswerSupervision']);
            $profile['UseFarEndDisconnect'] = checkBooleanValue($variables['UseFarEndDisconnect']);
            $profile['ReleaseTime'] = checkBooleanValue($variables['ReleaseTime']);
            $profile['AbandonTime'] = checkBooleanValue($variables['AbandonTime']);
            $profile['RingsToNotify'] = checkBooleanValue($variables['RingsToNotify']);
            $profile['FlashTime'] = checkBooleanValue($variables['FlashTime']);
            $profile['LongSignalingTime'] = checkBooleanValue($variables['LongSignalingTime']);
            $profile['ShortSignalingTime'] = checkBooleanValue($variables['ShortSignalingTime']);
            $profile['SeizeTimeout'] = checkBooleanValue($variables['SeizeTimeout']);

            $tmp = $Profiles -> profilesYaml -> getYaml();
            if($edit)
                $tmp['ChannelGroupProfiles'][$pos][$name] = $profile;
            else
                $tmp['ChannelGroupProfiles'][] = array($name => $profile);
            $Profiles -> profilesYaml -> yaml = $tmp;

            $Profiles -> saveProfiles();
            return true;
        }

        function createFXO($variables, $newProfile)
        {
            $Profiles = new KProfiles();
            $name = $variables['name'];
            $pos = $Profiles -> getProfilePosition($name);
            $edit = strlen($pos) >= 1 && $pos > -1 ? true : false;

            if($newProfile && $edit)
                return false;

            $profile['Type'] = 'FXO';
            $profile['RingsToNotify'] = checkBooleanValue($variables['RingsToNotify']);
            $profile['SeizeTimeout'] = checkBooleanValue($variables['SeizeTimeout']);
            $profile['DisconnectOnPolarityReversal'] = checkBooleanValue($variables['DisconnectOnPolarityReversal']);
            $profile['FlashTime'] = checkBooleanValue($variables['FlashTime']);
            $profile['FlashValidationTime'] = checkBooleanValue($variables['FlashValidationTime']);
            $profile['LineTerminationImpedance'] = $variables['LineTerminationImpedance'];

            $tmp = $Profiles -> profilesYaml -> getYaml();
            if($edit)
                $tmp['ChannelGroupProfiles'][$pos][$name] = $profile;
            else
                $tmp['ChannelGroupProfiles'][] = array($name => $profile);
            $Profiles -> profilesYaml -> yaml = $tmp;

            $Profiles -> saveProfiles();
            return true;
        }

        function checkBooleanValue($var)
        {
            if ($var == 'true')
                return true;
            elseif ($var == 'false')
                return false;
            else
                return $var;
        }

        function testProfile($profileName)
        {
            Global $sistema;
            $Profiles = new KProfiles();
            $profile = $Profiles -> getProfile($profileName);
            if ($profile == NULL && $profileName != "")
                return "Ok";
            else
                return $sistema -> retTranslate('invalidName');
        }

        function intSelectMaker($name, $class, $value, $min, $max, $step, $fator = 1)
        {
            $return = '';

            if($class != '')
                $return .= "<select class='$class' name='$name' id='$name' >";
            else
                $return .= "<select class='selector2' name='$name' id='$name' >";
            for ($x = $min; $x <= $max; $x = $x + $step)
            {
                if ($x == $value)
                    $selected = "selected";
                else
                    $selected = "";
                $return .= "<option value='$x' $selected>" . ($fator * $x) . "</option>";
            }
            $return .= "</select>";
            return $return;
        }

        function cadenceAssistant($first = true)
        {
            Global $sistema;

            $return = '';

            if ($first)
                $return .= "<div id='dialog-modal' title='".$sistema -> retTranslate('CadencesAssistant')."'>";

            $return .= "<p>".$sistema -> retTranslate('InitCadenceAssistant')."</p>";
            $return .= "<div id='looper'>";
            $FXOChannels = $sistema -> getFXOChannels();

            if (sizeof($FXOChannels) > 0)
            {
                $return .= "<form>";
                $return .= "<table id='cadenceAssistantTable' >";
                $return .= "<tr>";
                $return .= "<td align='left'>".$sistema -> retTranslate("Device")."</td>";
                $return .= "<td align='left'>";
                $return .= getFXODevices();
                $return .= "</td>";
                $return .= "</tr>";
                $return .= "<td align='left'>". $sistema -> retTranslate("Channel"). "</td>";
                $return .= "<td align='left' id='fxoDeviceChannelsList'>";
                $FXO = $sistema -> getFirstFXODevice();
                $return .= getFXODeviceChannels($FXO);
                $return .= "</td>";
                $return .= "</tr>";
                $return .= "<tr>";
                $return .= "<td align='left'>".$sistema -> retTranslate("NumeroRamalLigacoes"). "</td>";
                $return .= "<td align='left'>";
                $return .= "<input id='busy' type='text' onkeyup='javascript: validateNumber(this);' onmouseup='return numberMask(this, event);' onKeyPress='return numberMask(this, event);'>";
                $return .= "</td>";
                $return .= "</tr>";
                $return .= "<tr>";
                $return .= "<td align='left'>". $sistema -> retTranslate("NumeroRingBack")."</td>";
                $return .= "<td align='left'>";
                $return .= "<input id='ringback' type='text' onkeyup='javascript: validateNumber(this);' onmouseup='return numberMask(this, event);' onKeyPress='return numberMask(this, event);'>";
                $return .= "</td>";
                $return .= "</tr>";
                $return .= "<tr>";
                $return .= "<td align='left'>". $sistema -> retTranslate("NumeroInvalido"). "</td>";
                $return .= "<td align='left'>";
                $return .= "<input id='invalid' type='text' onkeyup='javascript: validateNumber(this);' onmouseup='return numberMask(this, event);' onKeyPress='return numberMask(this, event);'>";
                $return .= "</td>";
                $return .= "</tr>";
                // $return .= "<tr>";
                // $return .= "<td colspan='2'>";
                // $return .= "</td>";
                // $return .= "</tr>";
                $return .= "</table>";
                $return .= "</br>";

                $return .= "<input type='button' onClick='initAssintant();' value='".$sistema -> retTranslate("gerarCadencias") . "' />";

                $return .= "</form>";
            }
            else
                $return .= $sistema -> retTranslate("NDevice4Assitance");

            $return .= "</div>";
            if ($first)
                $return .= "</div>";

            return $return;
        }
