<?php
    @session_start( );

    $AjaxFunctions['createDevice'] = 'createDevice';
    $AjaxFunctions['showManualCreateDevice'] = 'showManualCreateDevice';
    $AjaxFunctions['showAutoCreateDevice'] = 'showAutoCreateDevice';
    $AjaxFunctions['showDevices'] = 'showDevices';
    $AjaxFunctions['checkDevice'] = 'checkDevice';
    $AjaxFunctions['manualCreateDevice'] = 'manualCreateDevice';
    $AjaxFunctions['autoCreateDevice'] = 'autoCreateDevice';
    $AjaxFunctions['removeDevice'] = 'removeDevice';
    $AjaxFunctions['editDevice'] = 'editDevice';
    $AjaxFunctions['saveDevice'] = 'saveDevice';
    $AjaxFunctions['k3lReload'] = 'k3lReload';
    $AjaxFunctions['changeDeviceOrder'] = 'changeDeviceOrder';

    function changeDeviceOrder( $_REQUEST )
    {
        Global $sistema;
        $deviceList = isset( $_REQUEST['deviceList'] ) ? $_REQUEST['deviceList'] : NULL;

        if( isset( $deviceList ) )
            $sistema->changeDeviceOrder( $deviceList );
    }

    function k3lReload( $_REQUEST )
    {
        Global $sistema;
        $result = reload( 'k3lreload' );

        if( $result == 'OK' )
            return 'ok|' . $sistema->retTranslate( 'K3LRealoaded' );
        else
            return 'notok|' . $sistema->retTranslate( 'K3LNRunning' );
    }

    function showDevices( $_REQUEST )
    {
        Global $sistema, $image_dir;

        $buff = '';

        $DevicesYAML = new KYaml( $sistema->getConfigDir( ) . '/devices.yaml' );
        $data = $DevicesYAML->getYaml( );

        $data = $data['Devices'];
        $maxBoards = sizeof( $data );
        $columCount = 1;
        $deviceOriginalOrder = '';

        $buff .= '<div id="divDevices">';
        $buff .= '<fieldset id="deviceList">';
        $buff .= '<legend>' . $sistema->retTranslate( 'Devices' ) . '</legend>';

        if( $maxBoards > 0 )
        {
            $buff .= '<ul class="devList" id="sortableDevice">';
            for( $i = 0; $i < $maxBoards; $i++ )
            {
                $deactivated = false;
                $tmp = array_keys( $data[$i] );
                $serial = $tmp[0];

                if( $deviceOriginalOrder == '' )
                    $deviceOriginalOrder = $serial;
                else
                    $deviceOriginalOrder .= "|" . $serial;

                if( $data[$i][3] > 22 || (($data[$i][3] === 0) && ($data[$i][4] === 0)) )
                {

                    $jsfunction = "onclick=\"alert('" . $sistema->retTranslate( "placaDesconhecida" ) . "');\"";
                    $img = "<img src='$image_dir/imagens/fail.png'/>";
                    $data[$i][1] = $sistema->retTranslate( "placaDesc" );
                }
                else
                {
                    $deactivated = $sistema->getDeactivatedE1( $serial );
                    $sentence = "";
                    if( $deactivated )
                        $sentence = $sistema->retTranslate( "E1Deactivated" );

                    if( @ereg( 'EBS', $data[$i][$serial]['Type'] ) && ($data[$i][$serial]['IP'] == '!') )
                    {
                        $deactivated = true;
                        if( $sentence == "" )
                            $sentence = $sistema->retTranslate( "noIP" );
                        else
                            $sentence .= " | " . $sistema->retTranslate( "noIP" );
                    }

                    if( @ereg( 'EBS', $data[$i][$serial]['Type'] ) && checkIPConflict( $data[$i][$serial]['IP'], $serial, $DevicesYAML->getYaml( ) ) )
                    {
                        $deactivated = true;
                        if( $sentence == "" )
                            $sentence = $sistema->retTranslate( "IPConflict" );
                        else
                            $sentence .= " | " . $sistema->retTranslate( "IPConflict" );
                    }
                    $jsfunction = "onmousedown='getMousePosition(event);' onclick=\"checkDeviceOrder('device=" . $sistema->retTranslate( $data[$i][$serial]['Type'] ) . "&serial=" . $serial . "',event)\"";
                    $type = getDeviceType( $data[$i][$serial]['Type'] );
                    $img = "<img src='$image_dir/imagens/$type.png' />";

                }
                $columDelete = '<table class="deleteDevice"><tr>';
                $columDelete .= '<td></td>';
                $columDelete .= '<td valign="top" width="5%">';
                $columDelete .= "<a class='profile' href='#' onClick=\"javascript: removeDevice('$serial')\">X</a>";
                $columDelete .= "</td>";
                $columDelete .= "</tr></table>";

                $buff .= "<li>";
                $buff .= "<input type='hidden' value='$serial' id='serial$i' />";
                $buff .= "<table class='listDevices'>";
                $buff .= "<tr><td>" . $columDelete . "</td></tr>";

                $buff .= "<tr><td>";
                $buff .= "<a class='cursorHand' $jsfunction>" . $img;

                if( $deactivated )
                    $buff .= "<img id='pngAlert' src='$image_dir/imagens/alert.png' title='$sentence' >";

                $buff .= "<br>";
                $buff .= "<span class='infoPlacas'>";
                $buff .= $sistema->retTranslate( $data[$i][$serial]['Type'] );

                $version = isset( $data[$i][$serial]['Version'] ) ? $data[$i][$serial]['Version'] : '';
                $buff .= $version != '!' ? ' ' . $version : '';

                $buff .= "<br>";
                $buff .= $sistema->retTranslate( "placas_Serial" );
                $buff .= "</span>:" . $serial . "</a>";

                if( @ereg( 'EBS', $data[$i][$serial]['Type'] ) )
                {
                    if( $data[$i][$serial]['IP'] != "!" )
                        $buff .= "<br>IP: " . $data[$i][$serial]['IP'];
                    else
                        $buff .= "<br>IP: <span class='red'>" . $sistema->retTranslate( 'NConfigurado' ) . "</span>";
                }
                $buff .= "</td></tr></table></li>";
            }
            $buff .= "</ul>";
            $buff .= "<input type='hidden' value='$deviceOriginalOrder' id='originalDeviceOrder' />";
        }
        else
            $buff .= "<p>" . $sistema->retTranslate( 'noDevicesConfigured' ) . "</p>";

        $buff .= "</fieldset>";
        $buff .= "<br>";

        $buff .= "<input type='button' id='bAutomatico' value='" . $sistema->retTranslate( "DetectarPlacas" ) . "' onClick='javascript: preCreateDevice();'>";
        $buff .= "<input type='button' id='bManual' value='" . $sistema->retTranslate( "AdicionarManualmente" ) . "' onClick='javascript: preManualCreateDevice();'>";
        $buff .= "</div>";

        return $buff;
    }

    function showAutoCreateDevice( $_REQUEST )
    {
        Global $sistema;
        $time = isset( $_REQUEST['time'] ) ? $_REQUEST['time'] : '';
        $buff = '';

        $buff .= "<fieldset id='deviceList'>";
        $buff .= "<legend>" . $sistema->retTranslate( 'Devices' ) . "</legend>";
        $buff .= getNotIsntalledDevices( $time );
        $buff .= "</fieldset>";
        $buff .= "<br>";

        return $buff;
    }

    function showManualCreateDevice( $_REQUEST )
    {
        Global $sistema, $invDevices, $boardNames;

        $return = '';
        $return .= "<table>";
        $return .= "<tr>";
        $return .= "<td  width='20%' align='left'>" . $sistema->retTranslate( "Serial" ) . "</td>";
        $return .= "<td width='80%' align='left'>";
        $return .= "<input type='text' name='manualSerial' id='manualSerial' value='' onkeyup='javascript: validateSerial(this);' onmouseup='return serialMask(this, event);' onKeyPress='return serialMask(this, event);'> ";
        $return .= "<span id='serialResult'></span></td>";
        $return .= "</tr>";
        $return .= "<tr>";
        $return .= "<td valign='top' width='20%' align='left'>" . $sistema->retTranslate( "Modelo" ) . "</td>";
        $return .= "<td  width='80%' align='left'>";
        $disp = "style='display:none'";
        $return .= "<a class='profile' href='#' onClick=\"javascript:changeArrow(this);showId('manualModulos');\">- " . $sistema->retTranslate( "Modulos" ) . "</a>";
        $return .= "<fieldset id='manualModulos' style='display:block'>";
        $return .= getModuleDevices( );
        $return .= "</fieldset><br>";
        $return .= "<a class='profile' href='#' onClick=\"javascript:changeArrow(this);showId('manualModular');\">+ " . $sistema->retTranslate( "Modular" ) . "</a>";
        $return .= "<fieldset id='manualModular' $disp>";
        $return .= getModularDevices( );
        $return .= "</fieldset><br>";
        $return .= "<a class='profile' href='#' onClick=\"javascript:changeArrow(this);showId('manualPlacas');\">+ " . $sistema->retTranslate( "BPlacas" ) . "</a>";
        $return .= "<fieldset id=\"manualPlacas\" $disp>" . getBoardDevices( ) . "</fieldset><br>";
        $return .= "</td>";
        $return .= "</tr>";
        $return .= "<tr>";
        $return .= "<td colspan='2'>";
        $return .= "<input type='button' value='" . $sistema->retTranslate( "Adicionar" ) . "' onClick='javascript: manualCreateDevice();'> ";
        $return .= "<input type='button' value='" . $sistema->retTranslate( "back" ) . "' onClick='javascript: showDevices();'>";
        $return .= "</td>";
        $return .= "</table>";

        return $return;
    }

    function autoCreateDevice( $_REQUEST )
    {
        Global $sistema;
        $serial = isset( $_REQUEST['serialGroup'] ) ? $_REQUEST['serialGroup'] : NULL;
        if( isset( $serial ) )
        {

            if( checkSerialIsAReplacer( $serial ) )
                return "1|SerialAlreadyConfiguredAsReplacer";

            $serialGroup = explode( '|', $serial );
            for( $x = 0; $x < sizeof( $serialGroup ); $x++ )
            {
                $deviceSerial = explode( ":", $serialGroup[$x] );
                //boards
                if( sizeof( $deviceSerial ) == 1 )
                {
                    $sistema->createDevice( $deviceSerial[0] );
                    $dev = $sistema->getDevice( $deviceSerial[0] );
                    //ebs
                }
                elseif( sizeof( $deviceSerial ) == 2 )
                {
                    $extra = explode( ";", $deviceSerial[1] );
                    $sistema->createDevice( $deviceSerial[0], $extra );
                }

            }
            return '0|' . showDevices( $_REQUEST );
        }
    }

    function manualCreateDevice( $_REQUEST )
    {
        Global $sistema;

        $serial = isset( $_REQUEST['serialGroup'] ) ? $_REQUEST['serialGroup'] : NULL;
        $deviceDef = isset( $_REQUEST['deviceDef'] ) ? $_REQUEST['deviceDef'] : NULL;

        if( isset( $serial ) && isset( $deviceDef ) )
        {
            $sistema->manualCreateDevice( $serial, $deviceDef );
            return showDevices( $_REQUEST );
        }
    }

    function checkDevice( $_REQUEST )
    {
        Global $sistema;

        $serial = isset( $_REQUEST['serialGroup'] ) ? $_REQUEST['serialGroup'] : NULL;

        if( isset( $serial ) )
        {
            if( checkSerialIsAReplacer( $serial ) )
                return 2;

            $serials = $sistema->getDeviceSerials( );

            if( in_array( $serial, $serials ) )
                return 1;
            else
                return 0;
        }
        return '';
    }

    function removeDevice( $_REQUEST )
    {
        Global $sistema;
        $serial = isset( $_REQUEST['serial'] ) ? $_REQUEST['serial'] : NULL;

        if( isset( $serial ) )
            $sistema->deleteDevice( $serial );

        return $sistema->retTranslate( 'deviceRemoved' );
    }

    function editDevice( $_REQUEST )
    {
        Global $sistema;
        $device = isset( $_REQUEST['device'] ) ? $_REQUEST['device'] : NULL;
        $serial = isset( $_REQUEST['serial'] ) ? $_REQUEST['serial'] : NULL;

        $buff = '';

        if( isset( $serial ) && isset( $device ) )
        {
            $buff .= "<div id='deviceOpen'>";

            $DevicesYAML = new KYaml( $sistema->getConfigDir( ) . "/devices.yaml" );
            $dev = $DevicesYAML->getValue( $serial );

            $buff .= "<fieldset id='Device'>";
            $buff .= '<legend>' . $device . ' - ' . 'Serial ' . $serial . '</legend>';

            if( isset( $dev['IP'] ) )
            {
                $buff .= '<table>';
                $buff .= "<tr class='green'>";
                $buff .= "<td style='text-align:left;'>IP</td>";
                $buff .= "<td></td>";
                $buff .= "<td></td>";
                $buff .= "<td style='text-align:right;'>";
                $ip = isset( $dev['IP'] ) && $dev['IP'] != '!' ? $dev['IP'] : '';
                $buff .= "<input id='IP' type='text' onclick='validateIP(this)' onkeyup='validateIP(this)' onmouseup='validateIP(this)' onkeydown='return maskIP(event, this);' value='$ip' name='IP'>";
                $buff .= "</td>";
                $buff .= "</tr>";
                $buff .= '</table>';
            }

            $buff .= '<br/>';

            $cont = 0;
            if( isset( $dev['Links'] ) )
            {
                $buff .= '<table>';
                $buff .= "<tr>";
                $buff .= "<th width='20%' >Link</th>";
                $buff .= "<th width='40%'>" . $sistema->retTranslate( 'SynchronismClock' ) . "</th>";
                $buff .= "<th width='40%'>Profile</th>";
                $buff .= "</tr>";
                $keys = array_keys( $dev['Links'] );
                $sysYAML = loadSystemYAML( );
                $sys = $sysYAML->getYaml( );
                $reference = explode( ',', $sys['System']['EnableLinkAsReference'] );

                foreach( $keys as $k )
                {
                    $valor = $dev['Links'][$k][$cont]['Profile'];

                    $chave = array_keys( $dev['Links'][$k] );
                    $profiles = getProfiles( "Links|$cont|" . $chave[0], $dev );
                    $class = $cont % 2 == 0 ? "class='lgreen'" : "class='green'";
                    $buff .= "<tr $class>";
                    $buff .= "<td style='text-align:center;'>$cont</td>";

                    $buff .= "<td style='text-align:center;'>";
                    $buff .= "<select id='Clock-$cont' name='Clock:$cont'>";

                    if( in_array( "$serial.$cont", $reference ) )
                    {
                        $receive = "selected=''";
                        $generate = "";
                    }
                    else
                    {
                        $generate = "selected=''";
                        $receive = "";
                    }

                    if( @ereg( 'HI', $device ) || @ereg( 'KPR', $device ) )
                    {
                        $buff .= "<option value='receive' $receive>" . $sistema->retTranslate( 'receive' ) . "</option>";
                    }
                    else
                    {
                        $buff .= "<option value='receive' $receive>" . $sistema->retTranslate( 'receive' ) . "</option>";
                        $buff .= "<option value='generate' $generate >" . $sistema->retTranslate( 'generate' ) . "</option>";
                    }

                    $buff .= "</select>";

                    $buff .= "</td>";
                    $buff .= "<td style='text-align:center;'>";
                    $buff .= "<select id='Links-$cont' name='Links:$cont'>";
                    foreach( $profiles as $p )
                        $buff .= ($p == $valor) ? "<option value='$valor' selected=''>$valor</option>" : "<option value='$p'>$p</option>";
                    $buff .= "</select>";
                    $buff .= "</td>";
                    $buff .= "<tr>";
                    $cont++;
                }
                $buff .= '</table>';
                $buff .= "<input type='hidden' id='qtdeLinks' value='" . sizeof( $keys ) . "' >";
            }

            if( isset( $dev['ChannelGroups'] ) )
            {
                $buff .= "<table id='channelGroup'>";
                $buff .= "<tr>";
                $buff .= "<th width='20%'>Channel Group</th>";
                $buff .= "<th width='40%'>" . $sistema->retTranslate( 'Canais' ) . "</th>";
                $buff .= "<th width='40%'>Profile</th>";
                $buff .= "</tr>";
                $aux = 0;
                $keys = array_keys( $dev['ChannelGroups'] );
                foreach( $keys as $k )
                {
                    $chaves = array_keys( $dev['ChannelGroups'][$k] );
                    $profiles = getProfiles( "ChannelGroups|$aux|" . $chaves[0], $dev );

                    foreach( $chaves as $ch )
                    {
                        $class = $cont % 2 == 0 ? "class='lgreen'" : "class='green'";
                        $buff .= "<tr $class>";
                        $buff .= "<td style='text-align:center;'>" . $dev['ChannelGroups'][$k][$chaves[0]]['Type'] . "</td>";
                        $v = explode( '-', $chaves[0] );
                        $buff .= "<td>" . abs( ($v[0] - $v[1]) - 1 ) . $sistema->retTranslate( 'canais' ) . ' (' . $chaves[0] . ")</td>";

                        $valor = utf8_encode( $dev['ChannelGroups'][$k][$ch]['Profile'] );
                        $buff .= "<td style='text-align:center;'><select id='ChannelGroups:$k:$ch' name='ChannelGroups:$k:$ch'>";
                        foreach( $profiles as $p )
                            $buff .= $p == $valor ? "<option value='$valor' selected=''>$valor</option>" : "<option value='$p'>$p</option>";
                        $buff .= "</select></td><tr>";
                    }
                    $cont++;
                    $aux++;
                }
                $buff .= '</table>';
            }

            if( isset( $dev['IP'] ) )
            {
                $buff .= '<br/>';
                $buff .= '<span id="MaintenanceClosed" onclick="openMaintenance();">' . $sistema->retTranslate( 'MaintenanceClosed' ) . '</span>';
                $buff .= '<span id="MaintenanceOpened" onclick="closeMaintenance();">' . $sistema->retTranslate( 'MaintenanceOpened' ) . '</span>';
                $buff .= '<fieldset id="Maintenance">';
                
                $buff .= '<table border="0"><tr><td>';
                
                $buff .= '<div>';
                $buff .= '<label for="Replacer">' . $sistema->retTranslate( 'Replacer' ) . '</label>';
                $replace = isset( $dev['Replacer'] ) && $dev['Replacer'] != '!' ? $dev['Replacer'] : '';
                $buff .= "<input style='float:right;' id='Replacer' type='text' onkeypress='return serialMask(this, event);' onmouseup='return serialMask(this, event);' onkeyup='validateSerial(this);' value='$replace' name='Replacer'>";
                $buff .= '</div>';
                
                $buff .= '</td></tr></table>';
                
                
                $buff .= '</fieldset>';
            }

            $buff .= "</fieldset>";
            $buff .= '<br/>';
            $buff .= "<div style='width:99%; text-align:right;'>";
            $buff .= "<input type='button' onclick=\"javascript:saveDevice('$serial');\" value='" . $sistema->retTranslate( 'Salvar' ) . "'>";
            $buff .= "<input type='button' onclick='javascript: showDevices();' value='" . $sistema->retTranslate( 'back' ) . "'>";
            $buff .= "</div>";
            $buff .= "</div>";

            return $buff;
        }
    }

    function checkSerialIsAReplacer( $serial )
    {
        Global $sistema;

        $DevicesYAML = new KYaml( $sistema->getConfigDir( ) . "/devices.yaml" );
        $deviceYAML = $DevicesYAML->getYaml( );

        for( $i = 0; $i < sizeof( $deviceYAML['Devices'] ); $i++ )
        {
            $keys = array_keys( $deviceYAML['Devices'][$i] );
            if( $deviceYAML['Devices'][$i][$keys[0]]['Replacer'] == $serial )
                return true;
        }

        return false;
    }

    function checkReplacerConflict( $serial, $replacer, $devicesYAML )
    {
        if( $serial == $replacer )
            return 3;

        $deviceYAML = $devicesYAML->getYaml( );
        for( $i = 0; $i < sizeof( $deviceYAML['Devices'] ); $i++ )
        {
            $keys = array_keys( $deviceYAML['Devices'][$i] );
            if( $keys[0] != $serial )
            {
                if( $keys[0] == $replacer )
                    return 2;

                if( $deviceYAML['Devices'][$i][$keys[0]]['Replacer'] == $replacer )
                    return 1;
            }
        }
        return 0;
    }

    function getReplacerErrorMessage( $code )
    {
        Global $sistema;
        switch ($code)
        {
            case 1:
                return '1|' . $sistema->retTranslate( 'ReplacerConflict' );

            case 2:
                return '2|' . $sistema->retTranslate( 'ReplacerAlreadyConfiguredAsDevice' );

            case 3:
                return '3|' . $sistema->retTranslate( 'ReplacerAndDeviceAreTheSame' );

            default:
                return '1|' . $sistema->retTranslate( 'ReplacerConflict' );
        }
    }

    function saveDevice( $_REQUEST )
    {
        Global $sistema;

        $serial = isset( $_REQUEST['serial'] ) ? $_REQUEST['serial'] : NULL;
        $data = isset( $_REQUEST['data'] ) ? $_REQUEST['data'] : NULL;
        $ip = isset( $_REQUEST['ip'] ) ? $_REQUEST['ip'] : NULL;
        $replacer = isset( $_REQUEST['Replacer'] ) ? $_REQUEST['Replacer'] : NULL;

        if( isset( $serial ) && isset( $data ) )
        {
            $DevicesYAML = new KYaml( $sistema->getConfigDir( ) . "/devices.yaml" );
            $dev = $DevicesYAML->getValue( $serial );
            if( isset( $ip ) )
            {
                $check = checkIPConflict( $ip, $serial, $DevicesYAML->getYaml( ) );
                if( $check )
                    return '0|' . $sistema->retTranslate( 'IPAlreadyUsed' );
                else
                    $dev['IP'] = $ip == '' ? '!' : $ip;
            }

            if( isset( $replacer ) )
            {
                $check_repl = checkReplacerConflict( $serial, $replacer, $DevicesYAML );

                if( $check_repl > 0 )
                    return getReplacerErrorMessage( $check_repl );
                else
                    $dev['Replacer'] = $replacer;
            }
            else if(isset($dev['Replacer']))
                $dev['Replacer'] = '!';

            $data = explode( '|', $data );
            foreach( $data as $d )
            {
                $tmp = explode( ':', $d );

                if( $tmp[0] == 'Links' )
                {
                    $dev[$tmp[0]][$tmp[1]][$tmp[1]]['Profile'] = $tmp[2];
                }
                elseif( $tmp[0] == 'ChannelGroups' )
                {
                    $dev[$tmp[0]][$tmp[1]][$tmp[2]]['Profile'] = utf8_decode( $tmp[3] );
                }
                else
                {
                    $sys = loadSystemYAML( );
                    $yaml = $sys->getYaml( );

                    if( $yaml['System']['EnableLinkAsReference'] != '!' && $yaml['System']['EnableLinkAsReference'] != '' )
                        $refs = explode( ',', $yaml['System']['EnableLinkAsReference'] );
                    else
                        $refs = array( );

                    $link = "$serial.$tmp[1]";

                    if( $tmp[2] == 'receive' )
                    {
                        if( !in_array( $link, $refs ) )
                            $refs[] = $link;
                    }
                    else
                    {
                        if( in_array( $link, $refs ) )
                        {
                            $key = array_search( $link, $refs );
                            unset( $refs[$key] );
                        }
                    }
                    $arr_tmp = array( );
                    foreach( $refs as $r )
                        $arr_tmp[] = $r;

                    $size = sizeof( $arr_tmp );
                    if( $size == 0 )
                        $yaml['System']['EnableLinkAsReference'] = '!';
                    elseif( $size == 1 )
                        $yaml['System']['EnableLinkAsReference'] = $arr_tmp[0];
                    else
                        $yaml['System']['EnableLinkAsReference'] = implode( ',', $arr_tmp );

                    $sys->setYaml( $yaml );
                    $sys->saveYaml( );
                }

            }
            $DevicesYAML->changeVarValue( $serial, $dev );
            $DevicesYAML->saveYaml( true );

            return '0|' . $sistema->retTranslate( 'ConfiguracaoSalva' );
        }
    }

    //***** aux func ********//

    function checkIPConflict( $ip, $serial, $yaml )
    {
        if( trim( $ip ) == '' )
            return false;

        $devices = $yaml['Devices'];
        $keys = array_keys( $devices );

        foreach( $keys as $k )
        {
            $x = array_keys( $devices[$k] );

            if( $x[0] != $serial )
            {
                if( $devices[$k][$x[0]]['IP'] == $ip )
                    return true;
            }
        }
        return false;
    }

    function getProfiles( $path, $device )
    {
        Global $sistema;
        $Profiles = new KProfiles( );
        $pathParts = explode( '|', $path );

        $Devicetype = $device[$pathParts[0]][$pathParts[1]][$pathParts[2]]['Type'];

        $defaultE1Types = array( 'R2', 'ISDN', 'ISUP', 'CAS PBX', 'CAS' );
        $defaultGSMTypes = array( 'GSM' );
        $defaultFXOTypes = array( 'FXO' );
        $defaultFXSTypes = array( 'FXS' );

        $profilesYaml = new KYaml( $sistema->getConfigDir( ) . "/profiles.yaml" );
        $profiles = $profilesYaml->yaml["ChannelGroupProfiles"];

        $newProfile = array( );

        if( $Devicetype == 'E1' )
            $newProfile[] = "Deactivated";

        switch ($Devicetype)
        {
            case 'FXO':
                $defaultTypes = $defaultFXOTypes;
                break;
            case 'FXS':
                $defaultTypes = $defaultFXSTypes;
                break;
            case 'GSM':
                $defaultTypes = $defaultGSMTypes;
                break;
            case 'E1':
                $defaultTypes = $defaultE1Types;
                break;
        }

        for( $x = 0; $x < sizeof( $profiles ); $x++ )
        {
            $keys = array_keys( $profiles[$x] );
            $profile = $Profiles->getProfile( $keys[0] );
            $type = $profile[$keys[0]]['Type'];

            if( isset( $profile[$keys[0]]['SubType'] ) )
                $profileSubType = $profile[$keys[0]]['SubType'];
            else
                $profileSubType = '';

            if( in_array( $type, $defaultTypes ) )
            {
                if( (@ereg( "HI", $device['Type'] ) && $Devicetype == "E1") || @ereg( "KPR", $device['Type'] ) )
                {
                    if( @ereg( "Passive", $profileSubType ) )
                        $newProfile[] = $keys[0];
                }
                else
                {
                    if( !@ereg( "Passive", $profileSubType ) )
                        $newProfile[] = $keys[0];
                }
            }
        }
        return $newProfile;
    }

    function getModuleDevices( )
    {
        Global $sistema, $invDevices, $boardNames;

        $EBSNames = getEBSNames( $invDevices );
        $return = '';
        $return .= "<table>";
        for( $i = 0; $i < sizeof( $EBSNames ); $i++ )
        {
            $class = (fmod( $i, 2 ) == 0) ? "class='green'" : "class='lgreen'";
            $return .= "<tr $class>";
            $return .= "<td>";
            $invDevData = implode( "|", $invDevices[$EBSNames[$i]] );
            $return .= "<input name='manualDevice' id='manualDevice' value='$invDevData' type='radio'>";
            $return .= "</td>";
            $return .= "<td width='90%' align='left'>" . $sistema->retTranslate( $EBSNames[$i] ) . "</td>";
            $return .= "</tr>";
        }
        $return .= "</table>";

        return $return;
    }

    function getNotIsntalledDevices( $time = '' )
    {
        Global $sistema;
        $return = '';

        if( $time === '' )
            $time = 30;

        $data = $sistema->getNotIsntalledDevices( $time );

        $tmpData = getDeviceList( $data );

        $return .= "<table>";
        $return .= "<tr><td colspan='3'>" . $sistema->retTranslate( "TempoKibs" ) . "</td><td colspan='2'>";
        $return .= getKibsTime( $time );
        $return .= "</td></tr>";

        if( $tmpData == "" )
            $return .= "<tr><td colspan='4'>" . $sistema->retTranslate( "NDevice" ) . "</td></tr>";
        else
        {
            $return .= "<tr><td colspan='4'>&nbsp;</td></tr>";
            $return .= "<tr>";
            $return .= "<th></th>";
            $return .= "<th align='center' width='25%'>" . $sistema->retTranslate( "type" ) . "</th>";
            $return .= "<th align='center' width='25%'>" . $sistema->retTranslate( "Serial" ) . "</th>";
            $return .= "<th align='center' width='40%'>" . $sistema->retTranslate( "Modelo" ) . "</th>";
            $return .= "</tr>";
            $return .= $tmpData;
        }
        $return .= "<tr><td colspan='4'>";
        if( $tmpData != "" )
            $return .= "<input style='width:100px;' type='button' value='" . $sistema->retTranslate( "Adicionar" ) . "' onClick='javascript: autoCreateDevice();'> ";
        $return .= "<input style='width:100px;' type='button' value='" . $sistema->retTranslate( "back" ) . "' onClick='javascript: showDevices();'>";
        $return .= "</td>";
        $return .= "</table>";
        return $return;
    }

    function getDeviceList( $data )
    {
        Global $sistema;

        $dataSize = sizeof( $data );
        $return = "";
        $nome = "deviceList";
        for( $x = 0; $x < $dataSize; $x++ )
        {
            $class = fmod( $x, 2 ) == 0 ? "class='green'" : "class='lgreen'";
            $return .= "<tr $class><td>";
            $return .= "<input class='check' type='checkbox' name='$nome$x' id='$nome$x' value='" . $data[$x][0] . "'>";
            $return .= "<input type='hidden' name='version$x' id='version$x' value='" . $data[$x][5] . "'>";
            $return .= "</td>";
            $return .= "<td>" . $sistema->retTranslate( $sistema->getDeviceType( $data[$x] ) ) . "</td>";
            $return .= "<td>" . $data[$x][0] . "</td>";
            $return .= "<td>" . $sistema->retTranslate( getName( $data[$x][1], $x, $data[$x] ) ) . "</td>";
            $return .= "</tr>";
        }
        return $return;
    }

    function getName( $name, $deviceOrder, $device = '' )
    {
        require_once (dirname( __FILE__ ) . "/../placas.php");
        Global $sistema, $boardNames, $invDevices;

        $return = '';

        $EBSNames = getEBSNames( $invDevices );

        if( $name != "" && !@ereg( "EBS", $name ) )
            return $name;

        if( $name == "" || !isset( $invDevices[$name] ) )
        {
            $return .= "<select style='width:125px;' name='deviceListType$deviceOrder' id='deviceListType$deviceOrder'>";
            $return .= "<option value=''>" . $sistema->retTranslate( 'selectType' ) . "</option>";
            for( $i = 0; $i < sizeof( $EBSNames ); $i++ )
            {
                $EBSTypeSubTypeLink = implode( ";", $invDevices[$EBSNames[$i]] );
                $return .= "<option value='$EBSTypeSubTypeLink'>" . $sistema->retTranslate( $EBSNames[$i] ) . "</option>";
            }
            $return .= "</select>";
        }
        else
        {
            $deviceName = $name;
            if( isset( $invDevices[$deviceName] ) )
                $deviceType = implode( ";", $invDevices[$deviceName] );
            else
                $deviceType = "0;0;0";

            $return = "<input type='hidden' id='deviceListType$deviceOrder' name='deviceListType$deviceOrder' value='$deviceType'/>" . $sistema->retTranslate( $deviceName );
        }
        return $return;
    }

    function getKibsTime( $time )
    {
        Global $sistema;
        $all = $sistema->retTranslate( "all" );
        $group = array( '05 min' => 5, '30 min' => 30, '01 h' => 60, '05 h' => 300, '10 h' => 600, '01 d' => 1440, '05 d' => 7200, '10 d' => 14400, "$all" => 0 );
        $GKeys = array_keys( $group );
        $select = "<select id='kibsTime' onChange='javascript:preCreateDevice(this.value);' class='selector3'>";
        for( $i = 0; $i < sizeof( $GKeys ); $i++ )
        {
            if( $group[$GKeys[$i]] == $time )
                $selected = 'selected';
            else
                $selected = '';

            $select .= "<option value='" . $group[$GKeys[$i]] . "' $selected>" . $GKeys[$i] . "</option>";
        }
        $select .= "</select>";
        $select .= "<a href='#' onclick='refreshKibsTime();'>" . $sistema->retTranslate( 'refresh' ) . "</a>";

        return $select;
    }

    function getModularDevices( )
    {
        Global $sistema, $invDevices, $boardNames;

        $ModularNames = getModularNames( $invDevices );
        $totalModular = sizeof( $ModularNames );
        $return = '';
        $return .= "<input type='hidden' value='$totalModular' id='totalTypes' />";
        $return .= "<table>";

        for( $i = 0; $i < $totalModular; $i++ )
        {
            $class = fmod( $i, 2 ) == 0 ? "class='green'" : "class='lgreen'";

            $return .= "<tr $class>";
            $return .= "<td>";

            $invDevData = implode( "|", $invDevices[$ModularNames[$i]] );
            $return .= "<input name='manualDevice' id='manualDevice' onClick=\"hideModularTypes();showModularType('modularType$i');\" value='$invDevData' type='radio'>";
            $return .= "</td>";
            $return .= "<td width='70%' align='left'>" . $sistema->retTranslate( $ModularNames[$i] ) . "</td>";
            $return .= "<td width='20%' align='left'>";
            $return .= "<div id='modularType$i' style='display:none'>";
            $return .= "<input name='manualType$i' id='manualType$i' value='SPX' type='radio' checked> SPX ";
            $return .= "<input name='manualType$i' id='manualType$i' value='CTI' type='radio'> CTI";
            $return .= "</div>";
            $return .= "</td>";
            $return .= "</tr>";
        }
        $return .= "</table>";

        return $return;
    }

    function getBoardDevices( )
    {
        Global $sistema;
        $devices = $sistema->getBoardDevices( );
        $devices = cleanArray( $devices );
        $return = '';
        if( sizeof( $devices ) > 0 )
        {
            $return .= "<table>";
            for( $x = 0; $x < sizeof( $devices ); $x++ )
            {
                if( fmod( $x, 2 ) == 0 )
                    $class = "class='green'";
                else
                    $class = "class='lgreen'";
                $return .= "<tr $class>";
                $return .= "<td>";
                $return .= "<input type='radio' name='manualDevice' id='manualDevice' value='" . $devices[$x]['id'] . "'>";
                $return .= "</td>";
                $return .= "<td width='90%' align='left'>" . $sistema->retTranslate( $devices[$x]['name'] ) . "</td>";
                $return .= "</tr>";
            }
            $return .= "</table>";
        }
        return $return;
    }

    function getEBSNames( $invDevices )
    {
        $keys = array_keys( $invDevices );
        $data = array( );
        for( $i = 0; $i < sizeof( $keys ); $i++ )
        {
            if( @ereg( "EBS", $keys[$i] ) && @!ereg( 'Modular', $keys[$i] ) )
                $data[] = $keys[$i];
        }
        return $data;
    }

    function getModularNames( $invDevices )
    {
        $keys = array_keys( $invDevices );
        $data = array( );
        for( $i = 0; $i < sizeof( $keys ); $i++ )
        {
            if( @ereg( 'Modular', $keys[$i] ) )
            {
                $keys[$i] = @ereg_replace( "_CTI", '', $keys[$i] );
                $keys[$i] = @ereg_replace( "_SPX", '', $keys[$i] );
                if( !in_array( $keys[$i], $data ) )
                    $data[] = $keys[$i];
            }
        }
        return $data;
    }

    function cleanArray( $array )
    {
        $tmpArray = array( );
        for( $i = 0; $i < sizeof( $array ); $i++ )
        {
            $check = false;
            for( $j = $i + 1; $j < sizeof( $array ); $j++ )
            {
                if( $array[$i]['name'] == $array[$j]['name'] )
                    $check = true;
            }
            if( $check == false )
                $tmpArray[] = $array[$i];
        }
        return $tmpArray;
    }

    function getDevicetype( $device )
    {
        if( @ereg( "EBS-Modular", $device ) )
            return "Modular";
        elseif( @ereg( "EBS", $device ) )
            return "Modulo";
        elseif( @ereg( "USB", $device ) )
            return "USB";
        else
            return "Placa";
    }
?>
