<?php
    require_once KCONFIG . '/classes/classKGatewayUtil.php';
    require_once KCONFIG . '/classes/classKGatewayNetwork.php';
    require_once KCONFIG . '/classes/classKGatewayNTP.php';

    $AjaxFunctions['showNetworkGW'] = 'showNetworkGW';
    $AjaxFunctions['saveNetworkGW'] = 'saveNetworkGW';
    $AjaxFunctions['showVoIPOptionsGW'] = 'showVoIPOptionsGW';

    define( 'GATEWAY_NETWORK_CONFIG', '/etc/network/interfaces' );
    define( 'GATEWAY_NETWORK_DEV', 'eth1' );

    function showNetworkGW( $_REQUEST )
    {

        $app = KSystem::getInstance( );

        $buffer = '';

        $buffer .= "<fieldset><legend>{$app->translate( 'gateway-network' )}</legend>";
        $buffer .= "<div id='gateway-network'>";

        try
        {
            $ntp = new KGatewayNTP( );
            $ntp->load( );
            $ntpconfig = $ntp->getConfiguration( );
            $parser = new KGatewayNetwork( GATEWAY_NETWORK_CONFIG );
            $parser->load( );
            //TODO: when needed, implement support to more than one interface
            // by iterating the parser's getInterfaces() method return
            $iface = GATEWAY_NETWORK_DEV;

            $properties = $parser->getProperties( $iface );
            $config = $parser->getConfiguration( $iface );
            $macaddress = $parser->getMacAddress( $iface );

            $address = array_key_exists( 'address', $config ) ? $config['address'] : '';
            $netmask = array_key_exists( 'netmask', $config ) ? $config['netmask'] : '';
            $gateway = array_key_exists( 'gateway', $config ) ? $config['gateway'] : '';

            $buffer .= "<div id='gateway-network-{$iface}' class='gateway-network-interface'>";
            $buffer .= "<fieldset><legend>{$app->translate( 'gateway-network-interface' )} [{$app->translate( 'gateway-network-interface-macaddress' )} {$macaddress}]</legend>";
            $buffer .= "<div class='gateway-network-method'><label for='gateway-network-method-{$iface}'>{$app->translate( 'gateway-network-method' )}</label> <select id='gateway-network-method-{$iface}' class='gateway-network-interface-method'>";
            foreach( KGatewayNetwork::$methods[$properties['family']] as $method )
            {
                $selected = $properties['method'] == $method ? ' selected=\'true\'' : '';
                $name = $app->translate( "gateway-network-method-{$method}" );
                $buffer .= "<option value='{$method}'{$selected}>{$name}</option>";
            }
            $buffer .= '</select></div><br />';
            $buffer .= "<div id='gateway-network-config-dhcp-{$iface}' style='display: none'>";
            $buffer .= '<table><tbody>';
            $buffer .= '</tbody></table>';
            $buffer .= "</div>";
            $buffer .= "<div id='gateway-network-config-static-{$iface}' style='display: none'>";
            $buffer .= "<table>";
            $buffer .= "<tr><td><label for='gateway-network-static-address-{$iface}'>{$app->translate( 'gateway-network-address' )}</label></td><td><input id='gateway-network-static-address-{$iface}' class='ipv4' type='text' value='{$address}' /></td></tr>";
            $buffer .= "<tr><td><label for='gateway-network-static-netmask-{$iface}'>{$app->translate( 'gateway-network-netmask' )}</label></td><td><input id='gateway-network-static-netmask-{$iface}' class='ipv4' type='text' value='{$netmask}' /></td></tr>";
            $buffer .= "<tr><td><label for='gateway-network-static-gateway-{$iface}'>{$app->translate( 'gateway-network-gateway' )}</label></td><td><input id='gateway-network-static-gateway-{$iface}' class='ipv4' type='text' value='{$gateway}' /></td></tr>";
            $buffer .= "</table>";
            $buffer .= "</div>";
            unset( $address );
            unset( $netmask );
            unset( $gateway );

            $buffer .= '<div id=\'gateway-network-dns\'><fieldset><legend>DNS</legend>';
            $buffer .= "<div class='gateway-network-method'><label for='gateway-network-dns-method'>{$app->translate( 'gateway-network-dns-method' )}</label> <select id='gateway-network-dns-method'>";
            foreach( KGatewayNetwork::$dnsmethods as $method )
            {
                $selected = array_key_exists( 'dns-nameservers', $config ) && $method == 'static' ? ' selected=\'true\'' : '';
                $name = $app->translate( "gateway-network-method-{$method}" );
                $buffer .= "<option value='{$method}'{$selected}>{$name}</option>";
            }
            $buffer .= '</select></div><br />';

            $dnssearch = array_key_exists( 'dns-search', $config ) ? $config['dns-search'] : '';
            $buffer .= '<div id=\'gateway-network-dns-config\'><table><tbody>';
            $buffer .= "<tr><td><lable for='gateway-network-dns-search'>{$app->translate( 'gateway-network-dns-search' )}</label></td><td><input type='text' id='gateway-network-dns-search' value='{$dnssearch}' /></td></tr>";
            $buffer .= "<tr><td>{$app->translate( 'gateway-network-servers' )}</td><td><div id='gateway-network-dns-server-list'>";
            $servers = array_key_exists( 'dns-nameservers', $config ) ? explode( ' ', $config['dns-nameservers'] ) : array( );
            foreach( $servers as $server )
            {
                $buffer .= "<input type='text' class='gateway-network-dns-server ipv4' value='{$server}' /><br />";
            }
            $buffer .= "</div><a href='#' id='gateway-network-dns-add'>{$app->translate( 'gateway-network-add-server' )}</a></td></tr>";
            $buffer .= '</tbody></table></fieldset></div><br />';
            $buffer .= "</fieldset><br />";
            unset( $dnssearch );

            $checked = array_key_exists( 'ntp-enabled', $ntpconfig ) && $ntpconfig['ntp-enabled'] == 'yes' ? ' checked=\'checked\'' : '';
            $buffer .= "<div id='gateway-network-ntp'><fieldset><legend><input type='checkbox' id='gateway-network-ntp-enable'{$checked}/> NTP / SNTP</legend>";
            $buffer .= '<table><tbody>';
            $buffer .= "<tr><td><label for='gateway-network-ntp-timeout'>{$app->translate( 'gateway-network-ntp-timeout')}</label></td><td><input type='text' id='gateway-network-ntp-timeout' value='{$ntpconfig['ntp-timeout']}' /></td></tr>";
            $buffer .= "<tr><td>{$app->translate( 'gateway-network-servers' )}</td><td><div id='gateway-network-ntp-server-list'>";
            $servers = array_key_exists( 'ntp-servers', $ntpconfig ) ? explode( ' ', $ntpconfig['ntp-servers'] ) : array( );
            foreach( $servers as $server )
            {
                $buffer .= "<input type='text' class='gateway-network-ntp-server' value='{$server}' /><br />";
            }
            $buffer .= "</div><a href='#' id='gateway-network-ntp-add'>{$app->translate( 'gateway-network-add-server' )}</a></td></tr>";
            $buffer .= '</td></tr>';
            $buffer .= '</tbody></table></fieldset></div><br />';

            $buffer .= "<input type='button' id='gateway-network-save' value='{$app->translate( 'save' )}' />";
        }
        catch( KGatewayNetworkException $e )
        {
            $buffer .= $app->translate( $e->getMessage( ) );
        }
        catch( KGatewayNTPException $e )
        {
            $buffer .= $app->translate( $e->getMessage( ) );
        }

        $buffer .= "</div></fieldset>";

        return $buffer;
    }

    function saveNetworkGW( )
    {
        require_once KROOT . '/json_util.php';

        $app = KSystem::getInstance( );
        $reply = array( 'success' => false, 'message' => $app->translate( 'gateway-network-save-error' ) );

        try
        {
            $ntp = new KGatewayNTP( );
            $ntp->load( );
            $ntpconfig = $ntp->getConfiguration( );
            $parser = new KGatewayNetwork( GATEWAY_NETWORK_CONFIG );
            $parser->load( );

            // interfaces configuration
            foreach( $_POST['ifaces'] as $iface => $data )
            {
                $config = array_key_exists( 'config', $data ) ? $data['config'] : array( );
                $parser->setProperties( $iface, $data['properties'], $config );
            }

            // ntp configuration
            $config = array( );
            foreach( $_POST['ntp'] as $key => $value )
            {
                $config["ntp-{$key}"] = $value;
            }
            $ntp->setConfiguration( $config );

            $parser->save( );
            $ntp->save( );

            $reply = array( 'success' => true, 'message' => $app->translate( 'gateway-network-saved' ) );
        }
        catch( KGatewayNetworkException $e )
        {
            $reply['message'] = $app->translate( $e->getMessage( ) );
        }
        catch( KGatewayNTPException $e )
        {
            $reply['message'] = $app->translate( $e->getMessage( ) );
        }
        return JSONencode( $reply );
    }

    function showVoIPOptionsGW( $_REQUEST )
    {
        return showVoIPOptions( $_REQUEST, 'GW' );
    }
