<?php
    if( file_exists( '/etc/elastix.conf' ) )
        session_name( 'elastixSession' );
    @session_start( );

    $AjaxFunctions['analyseLogDownload'] = 'analyseLogDownload';

    function analyseLogDownload( $_REQUEST )
    {
        $type = isset( $_REQUEST['type'] ) ? $_REQUEST['type'] : NULL;
        if( isset( $type ) )
        {
            switch($type)
            {
                case 'basicLogs':
                    return getBasicLogsDownloadFile( );

                case 'last24':
                    return getLastLogsDownload( 1 );

                case 'lastWeek':
                    return getLastLogsDownload( 7 );
            }
        }
    }

    function getBasicLogsList( )
    {
        $basicLogsFiles = array( 'sysinfo.log', 'messages.log', 'crash.log', 'link.log', 'k3l.log' );

        $logdir = LogUtil::getLogDir( );
        $basicLogs = array( );

        foreach( $basicLogsFiles as $file )
        {
            if( file_exists( $logdir . $file ) )
                $basicLogs[] = $logdir . $file;
        }

        if( file_exists( $logdir . 'config' ) )
        {
            $configDir = scandir( $logdir . 'config' );
            foreach( $configDir as $configFile )
            {
                if( $configFile != "." && $configFile != ".." )
                    $basicLogs[] = $logdir . "config" . DIRECTORY_SEPARATOR . $configFile;
            }
        }

        return $basicLogs;

    }

    //auc functions
    function getBasicLogsDownloadFile( )
    {
        return getFileSizeStyle( sizeMe( getBasicLogsList( ) ) );
    }

    function getLastLogsDownload( $days )
    {
        $lastDayfiles = array( );
        $logdir = LogUtil::getLogDir( );

        $lastDayfiles = getBasicLogsList( );

        $dirsToScan = array( $logdir, $logdir . "old" . DIRECTORY_SEPARATOR );

        foreach( $dirsToScan as $dir )
        {
            $filesLogDir = scandir( $dir );
            foreach( $filesLogDir as $fld )
            {
                $file = $dir . $fld;

                if( $fld != "." && $fld != ".." && !is_dir( $file ) )
                {
                    if( !in_array( $file, $lastDayfiles ) )
                    {
                        $stats = stat( $file );
                        if( $stats[9] > (time( ) - (86400 * $days)) )
                            $lastDayfiles[] = $file;
                    }
                }
            }
        }

        if( PHP_OS != "WINNT" )
        {
            if( is_dir( '/etc/asterisk/' ) )
            {
                $astk = scandir( '/etc/asterisk/' );
                foreach( $astk as $f )
                {
                    if( $f != "." && $f != ".." )
                        $lastDayfiles[] = '/etc/asterisk/' . $f;
                }
            }
            if( file_exists( '/var/log/asterisk/full' ) )
                $lastDayfiles[] = '/var/log/asterisk/full';
            elseif( file_exists( '/var/log/asterisk/message' ) )
                $lastDayfiles[] = '/var/log/asterisk/message';
        }

        return getFileSizeStyle( sizeMe( $lastDayfiles ) );
    }

    function getAllLogsDownload( )
    {
        $logdir = LogUtil::getLogDir( );
        $objects = scandir( $logdir );
        sort( $objects );
        foreach( $objects as $obj )
        {
            if( $obj != "." && $obj != ".." )
            {
                if( !is_dir( $logdir . $obj ) )
                    $sizeMe[] = $logdir . $obj;
                else
                    $sizeMe[] = $logdir . $obj;
            }
        }
        return getFileSizeStyle( sizeMe( $sizeMe ) );
    }

    function sizeMe( $sizeMe )
    {
        Global $_SESSION;
        $total = 0;
        $zipMe = array( );
        foreach( $sizeMe as $k => $v )
        {
            $total += filesize( $v );
            $zipMe[] = $v;
        }
        $_SESSION['logZipMe'] = $zipMe;
        return $total;
    }
?>