<?php
    require_once KROOT . '/util.php';

    $AjaxFunctions['diagnosticMode'] = 'diagnosticMode';
    $AjaxFunctions['showSettingLogs'] = 'showSettingLogs';
    $AjaxFunctions['saveSettingLogs'] = 'saveSettingLogs';

    function diagnosticMode( $_REQUEST )
    {
        Global $sistema;
        $action = isset( $_REQUEST['action'] ) ? $_REQUEST['action'] : NULL;

        if( isset( $action ) )
        {
            if( $action == 'active' )
            {
                if( PHP_OS == "WINNT" )
                    return setFullLog( true, $_REQUEST );
                else
                {
                    if( is_file( "/usr/sbin/kmpserver" ) )
                        return setFullLog( true, $_REQUEST );
                    else
                    {
                        $out = array( );
                        if( is_file( '/usr/sbin/kdiagnostic_run.sh' ) )
                        {

                            if( function_exists( 'posix_getuid' ) )
                                $root = posix_getuid( ) == 0;
                            else
                            {
                                $ret = shell_exec( 'whoami' );
                                $root = strcasecmp( $ret, 'root' );
                            }

                            if( $root )
                                $prepend = '';
                            else
                                $prepend = '/usr/bin/sudo -u root ';

                            exec( "{$prepend}/usr/bin/sudo -u root /usr/sbin/khomp-sudo /usr/sbin/kdiagnostic_run.sh start 2>&1", $out, $success );
                            if( $success == 0 )
                                return 'ok|' . $sistema->retTranslate( 'diagnosticModeActivated' );
                            else
                                return getDiagnosticErrorMessage( $out );
                        }
                        else
                            return 'notok|' . $sistema->retTranslate( 'diagnosticModeNotFound' );
                    }
                }
            }
            else
            {
                if( PHP_OS == "WINNT" )
                    return setFullLog( false, $_REQUEST );
                else
                {
                    if( is_file( "/usr/sbin/kmpserver" ) )
                        return setFullLog( false, $_REQUEST );
                    else
                    {
                        if( is_file( '/usr/sbin/kdiagnostic_run.sh' ) )
                        {
                            $out = array( );
                            if( function_exists( 'posix_getuid' ) )
                                $root = posix_getuid( ) == 0;
                            else
                            {
                                $ret = shell_exec( 'whoami' );
                                $root = strcasecmp( $ret, 'root' );
                            }

                            if( $root )
                                $prepend = '';
                            else
                                $prepend = '/usr/bin/sudo -u root ';

                            exec( "{$prepend}/usr/sbin/khomp-sudo /usr/sbin/kdiagnostic_run.sh stop 2>&1", $out, $success );

                            if( $success == 0 )
                                return 'ok|' . $sistema->retTranslate( 'diagnosticModeDeactivated' );
                            else
                                return 'notok|' . getDiagnosticErrorMessage( $out );
                        }
                        else
                            return 'notok|' . $sistema->retTranslate( 'diagnosticModeNotFound' );
                    }
                }
            }
        }
    }

    function showSettingLogs( $_REQUEST )
    {
        Global $sistema;

        $klog = new Klogs( dirname( __FILE__ ) . '/../logs.xml' );
        $return = "";
        $return .= printDownloadTable( );
        $return .= "<fieldset id='logsTable'><legend>Logs</legend></br>";
        $return .= printDiagnosticModeTable( $klog );
        $return .= "<span id='showSettingsLogs' onclick='showSettingsLogsAdvanced();'>" . $sistema->retTranslate( 'advancedLogSettings' ) . " »</span>";
        $return .= "<span id='hideSettingsLogs' onclick='hideSettingsLogsAdvanced();'>" . $sistema->retTranslate( 'hideAdvancedLogSettings' ) . " «</span>";
        $return .= $klog->createForm( );
        $return .= "</br></fieldset>";

        return $return;
    }

    function saveSettingLogs( $_REQUEST )
    {
        Global $sistema;
        $klog = new Klogs( 'logs.xml' );

        $apply = $_REQUEST['apply'];
        unset( $_REQUEST['apply'] );

        if( $klog->saveLogConfig( $_REQUEST ) )
        {
            if( $apply == 'yes' )
            {
                if( reload( "reload" ) == 'OK' )
                    return 'ok|' . $sistema->retTranslate( 'K3LRealoaded' );
                else
                    return 'notok|' . $sistema->retTranslate( 'K3LNRunning' );
            }
        }
        else
            return 'notok|' . $sistema->retTranslate( 'K3LNRunning' );
    }

    //aux funcs

    function printDownloadTable( )
    {
        Global $sistema, $image_dir;

        $return = "";

        $return .= "<fieldset id='downloadTable'><legend>" . $sistema->retTranslate( 'downloads' ) . "</legend></br>";
        $return .= "<input type='hidden' id='language' value='" . $sistema->getLanguage( ) . "' />";

        $return .= "<table id='tabelaLogs' border='1'><tbody>";
        $return .= "<th><b>" . $sistema->retTranslate( 'logs' ) . "</b></th>";
        $return .= "<th><b>" . $sistema->retTranslate( 'description' ) . "</b></th>";
        $return .= "<th><b>" . $sistema->retTranslate( 'download' ) . "</b></th>";
        $return .= "<tr style='background: #ffffff;'>";
        $return .= "<td>" . $sistema->retTranslate( 'basicLogs' ) . "</td>";
        $return .= "<td>" . $sistema->retTranslate( 'basicLogsDesc' ) . "</td>";
        $return .= "<td>";
        $return .= "<span id='downloadZipDir' onclick=\"analyseDownloadSize('basicLogs');\" style='cursor:pointer;'> <img src='$image_dir/imagens/download.png' border='0'> </span>";
        $return .= "</td>";
        $return .= "</tr>";
        $return .= "<tr style='background: #F5F5F5;'>";
        $return .= "<td>" . $sistema->retTranslate( 'last24' ) . "</td>";
        $return .= "<td >" . $sistema->retTranslate( 'last24Desc' ) . "</td>";
        $return .= "<td>";
        $return .= "<span id='downloadZipDir' onclick=\"analyseDownloadSize('last24');\" style='cursor:pointer;'> <img src='$image_dir/imagens/download.png' border='0'> </span>";
        $return .= "</tr>";
        $return .= "<tr style='background: #ffffff;'>";
        $return .= "<td>" . $sistema->retTranslate( 'last7Days' ) . "</td>";
        $return .= "<td >" . $sistema->retTranslate( 'last7DaysDesc' ) . "</td>";
        $return .= "<td>";
        $return .= "<span id='downloadZipDir' onclick=\"analyseDownloadSize('lastWeek');\" style='cursor:pointer;'> <img src='$image_dir/imagens/download.png' border='0'> </span>";
        $return .= "</td>";
        $return .= "</tr>";

        $return .= "</table></tbody>";
        $return .= "<a id='lastLogZip' href=''>";
        $return .= "<input type='button' style='display:none' name='downloadZipButton' id='downloadZipButton' value='' onclick='' ></a>";
        $return .= "</br></fieldset></br>";

        return $return;
    }

    function printDiagnosticModeTable( $klog )
    {
        Global $sistema;

        $return = "";

        $return .= "<table id='diagnosticModeTable' border='0'><tbody>";
        $return .= "<td width='50%'><b>" . $sistema->retTranslate( 'diagnosticMode' ) . "</b></td>";
        $return .= "<td width='50%'>";

        $displayA = '';
        $displayB = '';

        if( PHP_OS == "WINNT" )
        {
            if( $klog->logConfig['KLoggerFullLog'] == 'true' )
            {
                $displayA = "display:none";
                $displayD = "display:block";
            }
            else
            {
                $displayA = "display:block";
                $displayD = "display:none";
            }
        }
        else
        {
            if( is_file( "/usr/sbin/kmpserver" ) )
            {
                if( $klog->logConfig['KLoggerFullLog'] == 'true' )
                {
                    $displayA = "display:none";
                    $displayD = "display:block";
                }
                else
                {
                    $displayA = "display:block";
                    $displayD = "display:none";
                }
            }
            else
            {
                $out = array( );
                if( is_file( '/usr/sbin/kdiagnostic_run.sh' ) )
                {

                    if( function_exists( 'posix_getuid' ) )
                        $root = posix_getuid( ) == 0;
                    else
                    {
                        $ret = shell_exec( 'whoami' );
                        $root = strcasecmp( $ret, 'root' );
                    }

                    if( $root )
                        $prepend = '';
                    else
                        $prepend = '/usr/bin/sudo -u root ';
                    exec( "{$prepend}/usr/sbin/khomp-sudo /usr/sbin/kdiagnostic_run.sh status", $out, $ret );
                    if( $ret == 0 )
                    {
                        if( $out[0] == 'ACTIVE' )
                        {
                            $displayA = "display:none";
                            $displayD = "display:block";
                        }
                        else
                        {
                            $displayA = "display:block";
                            $displayD = "display:none";
                        }
                    }
                    else
                        return getDiagnosticErrorMessage( $ret );
                }
            }
        }
        if( $displayA != '' && $displayD != '' )
        {
            $return .= "<input class='diagnosticModeButton' onmouseover='botaefeito(this);' onmouseout='tiraefeito(this);' id='diagModeActive' style='" . $displayA . "' type='button' onclick=\"diagnosticMode('active');\" value='" . $sistema->retTranslate( 'active' ) . "'>";
            $return .= "<input class='diagnosticModeButton' id='diagModeDesactive' style='" . $displayD . "' type='button' onclick=\"diagnosticMode('deactive');\" value='" . $sistema->retTranslate( 'deactive' ) . "'>";
        }

        $return .= "</td>";
        $return .= "</tbody></table></br>";

        return $return;
    }

    function setFullLog( $boo, $_REQUEST )
    {
        Global $sistema;

        if( PHP_OS == "WINNT" )
        {
            $k3lServer = new KService( 'k3lServer' );
            $status = trim( $k3lServer->getStatus( ) );

            if( $status == '4  RUNNING' )
            {
                $log = new Klogs( 'logs.xml' );
                $log->logConfig['KLoggerFullLog'] = $boo ? 'true' : 'false';
                $log->saveLogConfig( $_REQUEST );
                exec( "..\\..\\..\\Tools\\kwebhelper reload" );

                if( $boo )
                    return 'ok|' . $sistema->retTranslate( 'diagnosticModeActivated' );
                else
                    return 'ok|' . $sistema->retTranslate( 'diagnosticModeDeactivated' );
            }
            else
                return 'notok|' . $sistema->retTranslate( 'diagnosticModeCantBeActivated' );
        }
        else
        {
            if( (bool) exec( 'ps cax | grep -i k3lserver | grep -v grep' ) )
            {
                $log = new Klogs( 'logs.xml' );
                $log->logConfig['KLoggerFullLog'] = $boo ? 'true' : 'false';
                $log->saveLogConfig( $_REQUEST );
                exec( "/usr/sbin/kwebhelper reload" );

                if( $boo )
                    return 'ok|' . $sistema->retTranslate( 'diagnosticModeActivated' );
                else
                    return 'ok|' . $sistema->retTranslate( 'diagnosticModeDeactivated' );
            }
            else
                return 'notok|' . $sistema->retTranslate( 'diagnosticModeCantBeActivated' );
        }
    }

    function getDiagnosticErrorMessage( $ret )
    {
        Global $sistema;

        switch($ret)
        {
            case 1:
                $return = $sistema->retTranslate( 'genericError' ) . "<BR>";
                break;
            case 2:
                $return = $sistema->retTranslate( 'permissionDenied' ) . "<BR>";
                break;
            case 3:
                $return = $sistema->retTranslate( 'ProgramsNotFound' ) . "<BR>";
                break;
            case 4:
                $return = $sistema->retTranslate( 'K3LServerInactive' ) . "<BR>";
                break;
            case 5:
                $return = $sistema->retTranslate( 'chan_khompNotLoaded' ) . "<BR>";
                break;
            case 6:
                $return = $sistema->retTranslate( 'mod_khompNotLoaded' ) . "<BR>";
                break;
            case 7:
                $return = $sistema->retTranslate( 'softPBXInactive' ) . "<BR>";
                break;
            default:
                $return = $sistema->retTranslate( 'genericError' ) . "<BR>";
                break;
        }
        return $return;
    }
