<?php
    @session_start( );

    $AjaxFunctions['showFileDir'] = 'showFileDir';
    $AjaxFunctions['analyseLogDir'] = 'analyseLogDir';

    function showFileDir( $_REQUEST )
    {
        Global $sistema;
        $return = "";

        $dir = isset( $_REQUEST['dir'] ) ? base64_decode( $_REQUEST['dir'] ) : NULL;

        if( isset( $dir ) && isValidDirToAccess( $dir ) )
        {

            $dir = substr( $dir, -1 ) != DIRECTORY_SEPARATOR ? $dir . DIRECTORY_SEPARATOR : $dir;
            $result = listFilesFromDir( $dir );

            if( sizeof( $result ) > 0 )
            {
                $return .= "<input id='language' type='hidden' value='" . $sistema->getLanguage( ) . "'>";
                $return .= "<table id='tabelaLogs' border='1'>";
                $return .= "<tr>";
                $return .= "<th rowspan='2' scope='col' id='sizeDownload'> <b>" . $sistema->retTranslate( 'size' ) . "</b></th>";
                $return .= "<th rowspan='2' scope='col' ><b>" . $sistema->retTranslate( 'files' ) . "</b></th>";
                $return .= "<th colspan='3' scope='col' ><b>" . $sistema->retTranslate( 'actions' ) . "</b></th>";
                $return .= "</tr>";
                $return .= "<tr>";
                $return .= "<th scope='col' id='columnDownload'>" . $sistema->retTranslate( 'download' ) . "</th>";
                $return .= "<th scope='col' id='columnRead'>" . $sistema->retTranslate( 'visualize' ) . "</th>";
                $return .= "<th scope='col' id='columnAnalyse'>" . $sistema->retTranslate( 'analyse' ) . "</th>";
                $return .= "</tr>";

                for( $x = 0; $x < sizeof( $result ); $x++ )
                    $return .= printFileInterface( $dir, $result[$x], $x );
                $return .= "</table>";
            }

            if( sizeof( $result ) == 0 )
                $return .= "<br>" . $sistema->retTranslate( 'noFilesAtFolder' );

        }
        return $return;
    }

    function analyseLogDir( $_REQUEST )
    {
        Global $sistema;
        $logDir = isset( $_REQUEST['logDir'] ) ? $_REQUEST['logDir'] : NULL;
        $oper = isset( $_REQUEST['oper'] ) ? $_REQUEST['oper'] : NULL;

        if( isset( $logDir ) && isset( $oper ) )
        {
            $logDir = base64_decode( $logDir );
            if( $oper == "sizeOf" )
                $size = getFileSizeStyle( dirSize( $logDir ) );

            if( isset( $size ) )
                return str_replace( '@@@', $size, $sistema->retTranslate( 'sizeOfLogDir' ) );
        }
    }

    // aux functions
    function dirsize( $dir )
    {
        $size = 0;
        if( is_dir( $dir ) )
        {
            $objects = scandir( $dir );
            foreach( $objects as $object )
                if( $object != "." && $object != ".." && $object != 'index.php' )
                    if( filetype( $dir . DIRECTORY_SEPARATOR . $object ) == "dir" )
                        $size += dirsize( $dir . DIRECTORY_SEPARATOR . $object );
                    else
                        $size += sprintf( "%u", filesize( $dir . DIRECTORY_SEPARATOR . $object ) );
            reset( $objects );
        }
        return $size;
    }

    function printFileInterface( $dir, $file, $index )
    {
        Global $sistema, $image_dir, $module_dir;

        $return = "";
        $tmpFile = $dir . $file;
        $extension = end( explode( ".", $file ) );

        if( $extension != 'zip' )
        {
            $return = ($index % 2) != 0 ? "<tr style='background: #F5F5F5;'>" : "<tr style='background: #FFFFFF;'>";

            if( is_dir( $tmpFile ) )
            {
                $return .= "<td> - </td>";
                $return .= "<td class='file'>" . $file . "/</td>";
                $return .= "<td> - </td>";
                $return .= "<td> - </td>";
                $return .= "<td> - </td>";
            }
            else
            {
                $file64 = base64_encode( $tmpFile );

                if( PHP_OS == "WINNT" )
                    $size = sprintf( "%u", filesize( $tmpFile ) );
                else
                    $size = exec( 'stat -c %s ' . escapeshellarg( $tmpFile ) );

                $return .= "<td class='filesize'>" . getFileSizeStyle( $size ) . "</td>";
                $return .= "<td class='file'>" . $file . "</td>";

                if( $size < 5241287 )
                {
                    $return .= "<td>";
                    $return .= "<a onclick='return browserTest();' href=\"$module_dir/zipAjax.php?file=" . $file64 . "&type=file\" target='_self'>";
                    $return .= "<img src=' $image_dir/imagens/download.png' border='0' ></a></td>";
                }
                else
                {
                    $return .= "<td>";
                    $return .= "<span id='downloadZipDir' style='cursor:pointer;' onclick=\"zipBigFile('" . $file64 . "');\">";
                    $return .= "<img id='downFile' src=' $image_dir/imagens/download.png' border='0' >";
                    $return .= "</span>";
                    $return .= "<a id='zipFileLink' onclick='return browserTest();' href='' target='_self'>";
                    $return .= "<input type='button' name='zipFileButton' id='zipFileButton' value='x' onclick='' style='display:none' >";
                    $return .= "<img id='downFile' style='display:none' src=' $image_dir/imagens/download.png' border='0' >";
                    $return .= "</a></td>";
                }

                if( $size < 2000000000 )
                {
                    $return .= "<td>";
                    $return .= "<div style='cursor:pointer;' onclick='openLog(\"$file64\");'>";
                    $return .= $extension != 'gz' ? "<img src=' $image_dir/imagens/log.png' width='20' height='20' border='0'>" : '-';
                    $return .= "</div>";
                    $return .= "</td>";
                }
                else
                {
                    $return .= "<td>";
                    $return .= "<div style='cursor:pointer;' onclick=\"alert('" . $sistema->retTranslate( 'filesTooBig' ) . "');\">";
                    $return .= $extension != 'gz' ? "<img src=' $image_dir/imagens/log.png' width=16' height='16' border='0'>" : '-';
                    $return .= "</div>";
                    $return .= "</td>";

                }
                $nameFile = end( explode( DIRECTORY_SEPARATOR, $file ) );
                if( $nameFile == 'isdn.log' )
                {
                    if( $size < 10482574 )
                    {
                        $return .= "<td>";
                        $return .= "<div style='cursor:pointer;' onclick=\"openOverlay('$file64');\">";
                        $return .= "<img src='$image_dir/imagens/analyse.png' width='20' height='20' border='0'>";
                        $return .= "</div>";
                        $return .= "</td>";
                    }
                    else
                    {
                        $return .= "<td>";
                        $return .= "<div style='cursor:pointer;' onclick=\"alert('" . $sistema->retTranslate( 'analyseTooBig' ) . "')\">";
                        $return .= "<img src='$image_dir/imagens/analyse.png' width='20' height='20' border='0'>";
                        $return .= "</div>";
                        $return .= "</td>";
                    }
                }
                else
                    $return .= "<td>-</td>";
            }
            $return .= "</tr>";
        }
        return $return;
    }

    function getFileSizeStyle( $size )
    {
        $kb = 1024;
        $mb = 1048576;
        $gb = 1073741824;

        if( !$size )
            return '0 bytes';
        elseif( $size < $kb )
            return $size . ' bytes';
        elseif( $size < $mb )
            return round( $size / $kb, 2 ) . ' KB';
        elseif( $size < $gb )
            return round( $size / $mb, 2 ) . ' MB';
        else
            return round( $size / $gb, 2 ) . ' GB';
    }

    function listFilesFromDir( $dir_ )
    {
        $sRootPath = $dir_ . DIRECTORY_SEPARATOR;
        $dir = dir( $dir_ );
        $files = array( );
        $dirs = array( );

        while( ($sDir = $dir->read( )) !== false )
        {

            if( $sDir != '.' && $sDir != '..' )
            {
                if( is_dir( $dir_ . $sDir ) )
                    $dirs[] = $sDir;
                else
                    $files[] = $sDir;
            }
        }

        natcasesort( $files );
        natcasesort( $dirs );

        $final = array( );
        foreach( $dirs as $k => $v )
        {
            $final[] = $v;
        }
        foreach( $files as $k => $v )
        {
            $final[] = $v;
        }

        return $final;
    }

    function isValidDirToAccess( $dir )
    {
        $logDir = getLogDir( );
        return true;
    }
?>