<?php

    class Klogs
    {
        var $logFile, $interfaceFile, $firstFieldSet, $logConfig;

        function __construct( $file )
        {
            Global $_SESSION;
            $this->interfaceFile = $file;
            $this->setLogConfig( );
        }

        function setLogConfig( )
        {
            Global $sistema;
            $logFile = $sistema->getConfigDir( ) . '/klog.cfg';
            $fileContent = file( $logFile );
            $sectionName = '';
            for( $x = 0; $x < sizeof( $fileContent ); $x++ )
            {
                if( @ereg( "\[", $fileContent[$x] ) )
                {
                    //session
                    $sectionName = explode( "]", $fileContent[$x] );
                    $sectionName = explode( "[", $sectionName[0] );
                    $sectionName = $sectionName[1];
                }
                elseif( @ereg( "=", $fileContent[$x] ) )
                {
                    //var
                    $varName = explode( "=", $fileContent[$x] );
                    $value = trim( $varName[1] );
                    $this->logConfig[$sectionName . $varName[0]] = $value;
                }
            }
        }

        function saveLogConfig( $_REQUEST )
        {
            Global $sistema;

            $logFile = $sistema->getConfigDir( ) . '/klog.cfg';
            $fileContent = file( $logFile );
            $sectionName = '';

            $data = (array) JSONdecode( $_REQUEST['data'] );

            $cfg_file = parse_ini_file( $logFile, true );

            foreach( $data as $k => $v )
            {
                $tmp = explode( '-', $k );
                $section = $tmp[0];
                $key = $tmp[1];

                $cfg_file[$section][$key] = $v;
            }

            for( $x = 0; $x < sizeof( $fileContent ); $x++ )
            {
                if( @ereg( "\[", $fileContent[$x] ) )
                {
                    $sectionName = explode( "]", $fileContent[$x] );
                    $sectionName = explode( "[", $sectionName[0] );
                    $sectionName = $sectionName[1];
                }
                elseif( @ereg( "=", $fileContent[$x] ) )
                {
                    $varName = explode( "=", $fileContent[$x] );

                    if( isset( $data[$sectionName . '-' . $varName[0]] ) )
                    {
                        $fileContent[$x] = $varName[0] . "=" . $data[$sectionName . '-' . $varName[0]] . "\n";
                        unset( $data[$sectionName . '-' . $varName[0]] );
                    }
                    elseif( isset( $this->logConfig[$sectionName . $varName[0]] ) )
                    {
                        $fileContent[$x] = $varName[0] . "=" . $this->logConfig[$sectionName . $varName[0]] . "\n";
                    }
                    else
                        $fileContent[$x] = $varName[0] . "=" . trim( $varName[1] ) . "\n";
                }
            }

            if( sizeof( $data ) > 0 )
            {
                $createdSessions = array( );
                $comments = end( $fileContent );
                array_pop( $fileContent );

                while( strlen( $comments ) < 3 )
                {
                    $comments = end( $fileContent );
                    array_pop( $fileContent );
                }

                foreach( $data as $k => $v )
                {
                    $tmp = explode( '-', $k );
                    $section = $tmp[0];
                    $key = $tmp[1];

                    if( !in_array( $section, $createdSessions ) )
                    {
                        $fileContent[] = "\n" . '[' . $section . ']' . "\n";
                        $createdSessions[] = $section;
                    }
                    $fileContent[] = $key . '=' . $v . "\n";
                }
                $fileContent[] = "\n" . $comments;
            }

            $content = implode( "", $fileContent );
            $pFile = fopen( $logFile, "w+" );
            fwrite( $pFile, $content );
            fclose( $pFile );
            return true;
        }

        function createForm( )
        {

            $form = "";

            $form = "<fieldset id='logSettingAdvanced'>";
            $form .= "<form id=\"LogForm\" name=\"LogForm\" method=\"get\">\n";
            $handler = simplexml_load_file( $this->interfaceFile, 'SimpleXMLElement', LIBXML_NOCDATA );

            foreach( $handler -> children() as $child )
            {
                if( $this->is_Attribute( $child, "name" ) )
                {
                    $form .= $this->printChild( $child );
                }
            }
            $form .= "</form>\n";
            $form .= "</fieldset>";
            return $form;
        }

        function printChild( $handler )
        {
            Global $sistema;
            $afterPrint = "";
            $print = "";

            foreach( $handler->children() as $child )
            {
                if( $this->is_Attribute( $child, "name" ) )
                {
                    $print .= $this->printChild( $child );
                }
                else
                {
                    switch($this->getAttribute($child, "type"))
                    {
                        case "fieldset":
                            if( $this->firstFieldSet == true )
                            {
                                $this->firstFieldSet = false;
                                $disp = "";
                                $strPart = " -";
                            }
                            else
                            {
                                $disp = "style='display:none'";
                                $strPart = " +";
                            }
                            if( $this->is_Attribute( $child, "id" ) )
                                $id = "id='" . (string)$this->getAttribute( $child, "id" ) . "'";
                            else
                                $id = "";
                            $afterPrint .= "<a href='#' class='collapsePara' onClick='javascript:changeArrow(this);'>" . $strPart . ' ' . $sistema->retTranslate( utf8_decode( $this->getAttribute( $child, "legend" ) ) ) . "</a>";
                            $afterPrint .= "<fieldset class='fieldsetLog' $id $disp>";
                            if( $this->is_Attribute( $child, "class" ) )
                                $class = "class=\"" . $this->getAttribute( $child, "class" ) . "\"";
                            else
                                $class = "";

                            $afterPrint .= $this->printChild( $child );
                            $afterPrint .= "</fieldset><br>";
                            break;
                        case "br":
                            $afterPrint .= "\n";
                            break;
                        case "radioLine":
                            $afterPrint .= $this->printRadioLine( $child );
                            $afterPrint .= "\n";
                            break;
                        case "button":
                            $afterPrint .= $this->printButton( $child );
                            $afterPrint .= "\n";
                            break;
                        default:
                            break;
                    }
                }
            }
            return $afterPrint;
        }

        function getAttribute( $handler, $name )
        {
            foreach( $handler->attributes() as $properties => $value )
            {
                if( $properties == $name )
                {
                    return $value;
                }
            }
            return "";
        }

        function is_Attribute( $handler, $attribute )
        {
            foreach( $handler->attributes() as $properties => $value )
            {
                if( $properties == $attribute )
                {
                    return true;
                }
            }

            return false;
        }

        function getVarValue( $name, $child )
        {
            if( isset( $this->logConfig[$name] ) )
            {
                return $this->logConfig[$name];
            }
            return $this->getAttribute( $child, "default" );
        }

        function printRadioLine( $child )
        {
            Global $sistema;

            $return = "";
            $name = $child->getName( );
            $divname = "div" . $name;

            $return .= "<div id='$divname'>";
            if( $this->getAttribute( $child, "caption" ) != "" )
                $return .= $sistema->retTranslate( utf8_decode( $this->getAttribute( $child, "caption" ) ) ) . "</br>\n";

            $disabled = "";
            if( $this->is_Attribute( $child, "disable" ) )
                $disabled = "disabled";

            $default = $this->getVarValue( str_replace( '-', '', $name ), $child );

            $opcoes = explode( "|", $this->getAttribute( $child, "options" ) );
            $checked = "";
            $display = explode( "|", $this->getAttribute( $child, "itens" ) );
            for( $x = 0; $x < sizeof( $opcoes ); $x++ )
            {
                if( $default == $opcoes[$x] )
                    $checked = "checked";
                else
                    $checked = "";
                $return .= "<input type='radio' name='$name' id='$name' value='$opcoes[$x]' $checked $disabled>" . $sistema->retTranslate( utf8_decode( $display[$x] ) );
            }

            $return .= " <br>";
            $return .= "</div>";

            return $return;
        }

        function printButton( $child )
        {
            Global $sistema;
            if( !$this->is_Attribute( $child, "pfunc" ) )
            {
                $javascript = "";
                $value = (string)$child["value"];
                $javascript = "";
                $funcoes = explode( "|", $child["funcoes"] );
                if( $this->is_Attribute( $child, "argumentos" ) )
                    $funcoesArgumentos = explode( ":", $child["argumentos"] );
                for( $x = 0; $x < sizeof( $funcoes ); $x++ )
                {
                    if( $this->is_Attribute( $child, "argumentos" ) )
                    {
                        $argumentos = explode( "|", $funcoesArgumentos[$x] );
                        for( $y = 0; $y < sizeof( $argumentos ); $y++ )
                        {
                            if( $argumentos[$y] != "this" )
                                $argumentos[$y] = "'$argumentos[$y]'";
                        }
                        $argumentos = implode( ",", $argumentos );
                    }
                    else
                    {
                        $argumentos = '';
                    }
                    $javascript .= "javascript:" . $funcoes[$x] . "(" . $argumentos . ");";
                }
                return "<input type=\"button\" value=\"" . $sistema->retTranslate( utf8_decode( $this->RetornaAtributo( $child, "value" ) ) ) . "\" onClick=\"$javascript\">";
            }
            return $this->getPFunk( (string)$this->getAttribute( $child, "pfunc" ) );
        }

        function getPFunk( $option )
        {
            switch($option)
            {
                case 'k3lreload':
                    return $this->printButtonk3lreload( );
                    break;
            }
        }

        function printButtonk3lreload( )
        {
            Global $sistema;
            return "<input type='button' value=\"" . $sistema->retTranslate( "RecarregarKlog" ) . "\" onClick=\"javascript:reload('yes');\">";
        }

    }
?>
