function filter( )
{
    var file = $( '#file' ).val( );
    var begin = $( '#begin' ).val( );
    var end = $( '#end' ).val( );

    $( '#refreshing' ).show( );
    jQuery.ajax(
    {
        url : GLOBALAjaxURL,
        data : "ajaxTo=logAnaliser&file=" + file + '&begin=' + begin + '&end=' + end,
        dataType : "json",
        success : function( ret )
        {
            $( '#divLogAnalyser' ).html( ret['content'] );

            $( ".ui-widget-overlay" ).click( function( )
            {
                jQuery( '#divLogAnalyser' ).dialog( 'close' );
            } );

            $( "#browser-log" ).treeview( );
            $( '#refreshing' ).hide( );
            $( '#loading' ).hide( );
        }
    } );
}

function analyseDownloadSize( type )
{
    $( '#refreshing' ).show( );
    jQuery.ajax(
    {
        url : GLOBALAjaxURL,
        data : "ajaxTo=analyseLogDownload&type=" + type,
        dataType : "text",
        success : function( size )
        {
            size = size.replace( /(\r\n|\n|\r)/gm, "" );

            $( '#refreshing' ).hide( );
            var msg = ajaxI18N( 'sizeOfLogGroup' );
            msg = msg.replace( '@@@', size );
            if( confirm( msg ) )
                zipLastLogs( type );
        }
    } );
}

function zipLastLogs( type )
{
    $( '#refreshing' ).show( );
    $( '#block' ).show( );

    jQuery.ajax(
    {
        type : "POST",
        data : "type=" + type,
        url : modulo_dir + "/lastLogs.php",
        dataType : "text",
        success : function( ret )
        {
            document.getElementById( 'lastLogZip' ).setAttribute( 'href', modulo_dir + '/downloadZip.php?file=' + ret );
            document.getElementById( 'downloadZipButton' ).click( );
            $( '#block' ).hide( );
            $( '#refreshing' ).hide( );
        }
    } );
}

function diagnosticMode( action )
{
    if( action == 'active' )
        msg = 'diagnosticModeOn';
    else
        msg = 'diagnosticModeOff';

    if( ajaxConfirm( msg ) )
    {
        $('#refreshing').show();
        reload( 'no' );
        jQuery.ajax(
        {
            data : "ajaxTo=diagnosticMode&action=" + action,
            url : GLOBALAjaxURL,
            dataType : "text",
            success : function( ret )
            {
                ret = ret.replace( /(\r\n|\n|\r)/gm, "" );
                resp = ret.split( '|' );

                if( resp[0] == 'ok' )
                    ShowNotice( resp[1], true );
                else
                    ShowNotice( resp[1], false );

                $('#refreshing').hide();
                showSettings( 'settingsMenu' );
            }
        } );
    }
}

function showSettings( nameToBold )
{
    uberUnbolder( );
    boldMe( nameToBold );
    $( '#refreshing' ).show( );
    jQuery.ajax(
    {
        type : "POST",
        data : "ajaxTo=showSettingLogs",
        url : GLOBALAjaxURL,
        dataType : "text",
        success : function( ret )
        {
            $( '#right' ).html( ret );
            $( ".collapsePara", parent.document ).each( function( i, item )
            {
                $( item ).click( function( )
                {
                    $this = $( this );
                    if( $this.next( ).is( ":visible" ) )
                        $this.next( ).slideUp( );
                    else
                        $this.next( ).slideDown( );
                } );
            } );
            $( '#refreshing' ).hide( );
        }
    } );
}

function boldMe( nameToBold )
{
    $( '#' + nameToBold ).css( 'font-weight', 'bold' );
}

function uberUnbolder( )
{
    $( '#browser li span' ).each( function( i, val )
    {
        val.style.fontWeight = 'normal';
    } );
}

function reload( apply )
{
    if(apply == 'yes')
        $( '#refreshing' ).show( );
        
    jQuery.ajax(
    {
        type : "POST",
        url : GLOBALAjaxURL,
        data : "ajaxTo=saveSettingLogs&apply=" + apply + "&data=" + JSON.stringify( getquerystring( ) ),
        dataType : "text",
        success : function( ret )
        {
            if( ret.length > 0 )
            {
                ret = ret.replace( /(\r\n|\n|\r)/gm, "" );
                resp = ret.split( '|' );
                $( '#refreshing' ).hide( );

                if( resp[0] == 'ok' )
                    ShowNotice( resp[1], true );
                else
                    ShowNotice( resp[1], false );

                showSettings( 'settingsMenu' );
            }
            if(apply == 'yes')
                $( '#refreshing' ).hide( );
        }
    } );
}

function getquerystring( )
{
    var objQueryString =
    {
    };
    $( ':radio:checked' ).each( function( i, e )
    {
        objQueryString[$( e ).attr( 'name' )] = $( e ).val( );
    } );
    return objQueryString;
}

function showDir( dir, CompToBold )
{
    $( '#refreshing' ).show( );
    jQuery.ajax(
    {
        type : "POST",
        data : "ajaxTo=showFileDir&dir=" + dir,
        url : GLOBALAjaxURL,
        dataType : "text",
        success : function( ret )
        {
            $( '#right' ).html( ret );
            $( '#refreshing' ).hide( );
        }
    } );
    uberUnbolder( );
    CompToBold.style.fontWeight = 'bold';
}


$( document ).ready( function( )
{
    var buttons = $( "#yesno button" ).click( function( e )
    {
        var yes = buttons.index( this ) === 0;
    } );

    $( "#prompt form" ).submit( function( e )
    {
        triggers.eq( 1 ).overlay( ).close( );
        var input = $( "input", this ).val( );
        triggers.eq( 1 ).html( input );
        return e.preventDefault( );
    } );

} );

$( function( )
{
    $( "ul.tabs" ).tabs( "div.panes > div" );
} );

function openLog( file )
{
    $( '#refreshing' ).show( );
    $( '#loading' ).show( );
    jQuery.ajax(
    {
        type : "POST",
        data : "ajaxTo=printLog&file=" + file,
        url : GLOBALAjaxURL,
        dataType : "json",
        success : function( ret )
        {
            $( '#divLogView' ).dialog( "destroy" );
            // $( '#divLogView' ).html( ret['content'] );
            $( '#divLogViewTopo' ).html( ret['topo'] );
            $( '#divLogViewConteudo pre' ).text( ret['content'] );
            $( '#divLogViewRodape' ).html( ret['rodape'] );

            $( '#divLogView' ).dialog(
            {
                title : ret['title'],
                modal : true,
                draggable : true,
                hide : "slow",
                show : "slow",
                width : '50%',
                height : 850,
                minHeight : 700,
                minWidth : 700
            } );

            $( ".ui-widget-overlay" ).click( function( )
            {
                jQuery( '#divLogView' ).dialog( 'close' );
            } );

            $( '#refreshing' ).hide( );
            $( '#loading' ).hide( );
        }
    } );
}

function openOverlay( file )
{
    $( '#refreshing' ).show( );
    jQuery.ajax(
    {
        url : GLOBALAjaxURL,
        data : "ajaxTo=logAnaliser&file=" + file,
        dataType : "json",
        success : function( ret )
        {
            $( '#divLogAnalyser' ).html( ret['content'] );
            $( '#divLogAnalyser' ).dialog(
            {
                title : ret['title'],
                modal : true,
                draggable : true,
                hide : "slow",
                show : "slow",
                height : 850,
                minHeight : 700,
                minWidth : 700
            } );

            $( ".ui-widget-overlay" ).click( function( )
            {
                jQuery( '#divLogAnalyser' ).dialog( 'close' );
            } );

            $( '#refreshing' ).hide( );
            $( '#loading' ).hide( );
        }
    } );
}

function showMoreLogs( file, oper )
{
    $( '#loading' ).show( );
    var paginator = $( '#paginator' ).val( );

    jQuery.ajax(
    {
        url : GLOBALAjaxURL,
        data : "ajaxTo=showMoreLogs&file=" + file + "&oper=" + oper + "&paginator=" + paginator,
        dataType : "json",
        success : function( json )
        {
            if( countElements( json['lines'] ) > 0 )
            {
                var text = '';
                for( var i = 0; i < countElements( json['lines'] ); i++ )
                    text += json['lines'][i] != 'undefined' ? json['lines'][i] : '';

                $( '#divLogViewConteudo pre' ).text( text );

                // top of the file
                if( json['first'] <= 0 )
                {
                    $( '#forward' ).css( 'background', '#339966' );
                    $( '#last' ).css( 'background', '#339966' );
                    $( '#back' ).css( 'background', 'grey' );
                    $( '#first' ).css( 'background', 'grey' );

                    $( '#back' ).attr( 'disabled', 'true' );
                    $( '#first' ).attr( 'disabled', 'true' );
                    $( '#forward' ).removeAttr( 'disabled' );
                    $( '#last' ).removeAttr( 'disabled' );
                }
                else
                {
                    //middle of file
                    if( json['last'] < json['fileSize'] && json['first'] > 0 )
                    {
                        $( '#back' ).css( 'background', '#339966' );
                        $( '#forward' ).css( 'background', '#339966' );
                        $( '#first' ).css( 'background', '#339966' );
                        $( '#last' ).css( 'background', '#339966' );

                        $( '#back' ).removeAttr( 'disabled' );
                        $( '#forward' ).removeAttr( 'disabled' );
                        $( '#first' ).removeAttr( 'disabled' );
                        $( '#last' ).removeAttr( 'disabled' );
                    }
                    //end of file
                    else
                    {
                        $( '#forward' ).css( 'background', 'grey' );
                        $( '#back' ).css( 'background', '#339966' );
                        $( '#first' ).css( 'background', '#339966' );
                        $( '#last' ).css( 'background', 'grey' );
                        $( '#forward' ).attr( 'disabled', 'true' );
                        $( '#last' ).attr( 'disabled', 'true' );
                        $( '#back' ).removeAttr( 'disabled' );
                        $( '#first' ).removeAttr( 'disabled' );
                    }
                }
            }
            $( '#loading' ).hide( );

        }
    } );
}

function countElements( obj )
{
    var prop;
    var propCount = 0;
    for( prop in obj )
    propCount++;
    return propCount;
}

function goToEnd( )
{
    var bott = document.getElementById( 'goBottom' )
    if( bott != null && bott != 'undefined' )
        bott.click( );
}

function botaefeito( comp )
{
    $( comp ).addClass( 'box-shadow' );
}

function tiraefeito( comp )
{
    $( comp ).removeClass( 'box-shadow' );
}

function showSettingsLogsAdvanced( )
{
    $( '#logSettingAdvanced' ).show( );
    $( '#showSettingsLogs' ).hide( );
    $( '#hideSettingsLogs' ).show( );
}

function hideSettingsLogsAdvanced( )
{
    $( '#logSettingAdvanced' ).hide( );
    $( '#showSettingsLogs' ).show( );
    $( '#hideSettingsLogs' ).hide( );
}

function browserTest( )
{
    var userAgent = navigator.userAgent.toLowerCase( );
    if( navigator.userAgent.toLowerCase( ).indexOf( 'chrome' ) > -1 )
        return ajaxConfirm( 'downloadFile' );
    else
        return true;
}

function zipBigFile( file )
{
    if( ajaxConfirm( 'zipAndDownloadFile' ) )
    {
        $( '#block' ).show( );
        jQuery.ajax(
        {
            type : "POST",
            data : "file=" + file + "&type=file",
            url : "zip.php",
            dataType : "text",
            success : function( ret )
            {
                if( ret != '' )
                {
                    document.getElementById( 'zipFileLink' ).setAttribute( 'href', modulo_dir + '/downloadZip.php?file=' + ret );
                    document.getElementById( 'zipFileButton' ).click( );
                    document.getElementById( 'block' ).style.display = 'none';
                }
                else
                    ajaxAlert( 'errorToZipFile' );

                $( '#block' ).hide( );
            }
        } );
    }
}

function unblock( )
{
    $( 'loading' ).hide( );
}

function unBold( alvo )
{
    var filho = alvo.firstElementChild;
    while( filho != null )
    {
        if( filho.firstElementChild != null )
            unBold( filho.firstElementChild );
        filho.style.backgroundColor = '';
        filho = filho.nextElementSibling;
    }
}

function showMessages( nameToBold )
{
    $( '#refreshing' ).show( );
    jQuery.ajax(
    {
        type : "POST",
        url : GLOBALAjaxURL,
        data : "ajaxTo=showMessage",
        dataType : "text",
        success : function( ret )
        {
            $( '#right' ).html( ret );
            $( '#refreshing' ).hide( );
            setScrollAtBottom( );
        }
    } );

    if( $( '#' + nameToBold ).lenght > 0 )
        $( '#' + nameToBold ).css( 'font-weight', 'normal' );

    uberUnbolder( );

    if( nameToBold != undefined )
        boldMe( nameToBold );
}

function setScrollAtBottom( )
{
    var objDiv = parent.document.getElementById( "showMessages" );
    objDiv.scrollTop = objDiv.scrollHeight;
}

function changeArrow( place )
{
    innerString = place.innerHTML;
    if( innerString[1] == "-" )
        place.innerHTML = innerString.replace( "-", "+" );
    else
        place.innerHTML = innerString.replace( "+", "-" );
}

// function analyseDirSize( dir )
// {
    // jQuery.ajax(
    // {
        // url : GLOBALAjaxURL,
        // data : "ajaxTo=analyseLogDir&logDir=" + dir + "&oper=sizeOf",
        // dataType : "text",
        // success : function( msg )
        // {
            // if( confirm( msg ) )
                // zipDir( dir );
        // }
    // } );
// }


// function zipDir( dir )
// {
    // $( '#block' ).show( );
    // jQuery.ajax(
    // {
        // type : "POST",
        // data : "folder=" + dir + "&type=folder",
        // url : modulo_dir + "/zip.php",
        // dataType : "text",
        // success : function( ret )
        // {
            // ret = $.trim( ret );
            // if( ret != '' )
            // {
                // document.getElementById( 'downloadZipLogDir' ).setAttribute( 'href', modulo_dir + '/downloadZip.php?file=' + ret );
                // document.getElementById( 'downloadZipButton' ).click( );
                // document.getElementById( 'block' ).style.display = 'none';
            // }
            // else
                // ajaxAlert( 'errorToZipDir' );
        // }
    // } );
// 
// }

