<?php
    // error_reporting(E_ALL);
    require_once ("populator.php");
    require_once ("querist.php");
    require_once ("monitorService.php");

    class MonitorChannel
    {
        function __construct( )
        {
            Global $sistema;
            $op = -1;
            $operational = Querist::ask( "QUERY k3l.Connected", $op );
            if( $op > 0 )
            {
                $CountDevices = 0;
                Querist::ask( "QUERY k3l.DeviceCount", $CountDevices );
                for( $i = 0; $i < $CountDevices; $i++ )
                {
                    $device = array( 'serial' => '', 'model' => '', 'board' => $i, 'links' => array( ) );
                    $device = Populator::prePopulateChannels( $device );
                    $deviceList[$i] = $device;
                }
                if( isset( $deviceList ) )
                    $_SESSION['DeviceList'] = $deviceList;
                unset( $_SESSION['errorMessage'] );
            }
            else
            {
                if( !$operational )
                {
                    unset( $_SESSION['DeviceList'] );
                    $_SESSION['errorMessage'] = $sistema->retTranslate( Querist::$last_error );
                }
                else
                    unset( $_SESSION['DeviceList'] );
            }
            if( !isset( $_SESSION['errorMessage'] ) )
                $_SESSION['errorMessage'] = MonitorService::checkMediaServerMessages( );
        }

        public static function getMessages( )
        {

            Global $sistema, $image_dir;
            $alertMessage = $sistema->retTranslate( MonitorService::getWarningMessage( ) );

            if( isset( $_SESSION['errorMessage'] ) && $_SESSION['errorMessage'] != '' )
            {
                $style1 = "display:block;";
                $style2 = "display:none;";
            }
            elseif( isset( $alertMessage ) && $alertMessage != '' )
            {
                $style2 = "display:block;";
                $style1 = "display:none;";
            }
            else
            {
                $style2 = "display:none;";
                $style1 = "display:none;";
            }

            $buff = '';

            $buff .= "<div id='divErrorMessage' class='errorMessage' style='$style1'>";
            $buff .= "<img id='errorIco' src='$image_dir/imagens/error.png' />";
            $buff .= "<div id='divErrorMessageLine'>" . $_SESSION['errorMessage'] . "</div>";
            $buff .= "</div>";

            $buff .= "<div id='divAlertMessage' class='errorMessage' style='$style2'>";
            $buff .= "<img id='errorIco' src='$image_dir/imagens/error.png' />";
            $buff .= "<div id='divAlertMessageLine'>" . $alertMessage . "</div>";
            $buff .= "</div>";
            $buff .= "<br>";

            return $buff;
        }

        public static function getDevices( )
        {
            Global $sistema;

            $buffer = '';
            $buffer .= "<input type='hidden' value='channels' id='current-monitoring' />";

            if( isset( $_SESSION['DeviceList'][0] ) && sizeof( $_SESSION['DeviceList'] > 0 ) )
            {
                $buffer .= "<fieldset id='fieldsetSubConteudo' class='fieldsetSubConteudo'>";
                $buffer .= "<legend style='font-size: 12px;'>" . $sistema->retTranslate( "selectDevice" ) . "</legend>";
                $buffer .= "<div id='devices'>";

                $deviceList = $_SESSION['DeviceList'];
                $buffer .= "<div id=\"listDevices\">";
                if( count( $deviceList ) > 0 )
                {
                    for( $i = 0; $i < count( $deviceList ); $i++ )
                    {
                        $serial = $deviceList[$i]['serial'];
                        $board_num = $deviceList[$i]['board'];
                        $links_count = 0;
                        $query_link_count = sprintf( "QUERY k3l.Config.Device.%s.LinkCount", $serial );
                        Querist::ask( $query_link_count, $links_count );

                        $query_type = sprintf( 'QUERY k3l.DeviceType.%s', $serial );
                        Querist::ask( $query_type, $type );

                        //NOT MODULAR
                        if( $type != 22 )
                        {
                            if( $links_count > 0 )
                            {
                                $buttonName = $sistema->retTranslate( $deviceList[$i]['model'] ) . ' - ' . $serial;
                                $buffer .= "<input type='button' id=\"span-board-" . $i . "\" onclick=\"showLinksGC(" . $serial . ',' . $i . ");\" value=\"$buttonName\" />";
                            }
                            elseif( $serial == 99 )
                            {
                                $buttonName = $sistema->retTranslate( $deviceList[$i]['model'] ) . ' - ' . $serial;
                                $buffer .= "<input type='button' id=\"span-board-" . $i . "\" onclick=\"showLinksGC(99," . $board_num . ");\" value=\"$buttonName\" />";
                            }
                            else
                            {
                                $buttonName = $sistema->retTranslate( $deviceList[$i]['model'] ) . ' - ' . $serial;
                                $buffer .= "<input type='button' id=\"span-board-" . $i . "\" onclick=\"exibicao(99," . $board_num . ");\" value=\"$buttonName\" />";
                            }
                        }
                        else
                        {

                            $buttonName = $deviceList[$i]['model'] . ' - ' . $serial;
                            if( $links_count > 0 )
                            {
                                $buffer .= "<input type='button' id=\"span-board-" . $i . "\" onclick=\"showModular($board_num, $serial);\" value=\"$buttonName\" />";
                            }
                            else
                            {
                                $query_ch = sprintf( 'QUERY k3l.Config.Device.%s.ChannelCount', $serial );
                                Querist::ask( $query_ch, $chCount );
                                $buffer .= "<input type='button' id=\"span-board-" . $i . "\" onclick=\"showModularChannels($board_num, $serial, 99, 0, $chCount);\" value=\"$buttonName\" />";
                            }
                        }
                    }
                }
                else
                {
                    $buffer .= $sistema->retTranslate( "noDevice" );
                }
                $buffer .= "</div>";
                $buffer .= "</div></br><div id='div-links'></div>";
                $buffer .= "</fieldset>";
            }
            else
                $buffer .= $sistema->retTranslate( "noChannels" );

            return $buffer;
        }

    }
?>