<?php
    // error_reporting(E_ALL);
    require_once ("populator.php");
    require_once ("monitorService.php");
    require_once ("querist.php");

    class MonitorDevice
    {
        function __construct( )
        {
            Global $sistema;
            $op = -1;
            $operational = Querist::ask( "QUERY k3l.Connected", $op );
            if( $op > 0 )
            {
                Querist::ask( "QUERY k3l.DeviceCount", $CountDevices );
                $deviceList = null;
                for( $i = 0; $i < (int)$CountDevices; $i++ )
                {
                    $device = array( 'model' => '', 'board' => $i, 'serial' => '', 'status' => '', 'links' => array( ) );
                    $device = Populator::populateDevice( $device );
                    $deviceList[$i] = $device;
                }
                $_SESSION['DeviceList'] = $deviceList;
                unset( $_SESSION['errorMessage'] );
            }
            else
            {
                if( !$operational )
                {
                    unset( $_SESSION['DeviceList'] );
                    $_SESSION['errorMessage'] = $sistema->retTranslate( Querist::$last_error );
                }
                else
                    unset( $_SESSION['DeviceList'] );
            }
            if( !isset( $_SESSION['errorMessage'] ) )
                $_SESSION['errorMessage'] = MonitorService::checkMediaServerMessages( );

        }

        public static function showDevices( )
        {
            Global $sistema, $image_dir;

            $alertMessage = $sistema->retTranslate( MonitorService::getWarningMessage( ) );

            if( isset( $_SESSION['errorMessage'] ) && $_SESSION['errorMessage'] != '' )
            {
                $style1 = "display:block;";
                $style2 = "display:none;";
            }
            elseif( isset( $alertMessage ) && $alertMessage != '' )
            {
                $style2 = "display:block;";
                $style1 = "display:none;";
            }
            else
            {
                $style1 = "display:none;";
                $style2 = "display:none;";
            }

            $buffer = '';

            $buffer .= "<div id='divErrorMessage' class='errorMessage' style=\"$style1\">";
            $buffer .= "<img id='errorIco' src='$image_dir/imagens/error.png' />";
            $buffer .= "<div id='divErrorMessageLine'>" . $_SESSION['errorMessage'] . "</div>";
            $buffer .= "</div>";

            $buffer .= "<div id='divAlertMessage' class='errorMessage' style=\"$style2\">";
            $buffer .= "<img id='errorIco' src='$image_dir/imagens/error.png' />";
            $buffer .= "<div id='divAlertMessageLine'>" . $alertMessage . "</div>";
            $buffer .= "</div>";

            $buffer .= "<br>";
            $buffer .= "<input type='hidden' value='devices' id='current-monitoring' />";

            if( isset( $_SESSION['DeviceList'][0] ) && sizeof( $_SESSION['DeviceList'] > 0 ) )
            {
                $deviceList = $_SESSION['DeviceList'];

                $buffer .= "<div id='devices'>";
                $buffer .= "<table id='devicesTable' border=1 class='tabelaDevice'>";
                $buffer .= "<tr>";
                $buffer .= "<th rowspan='2' class='board' scope='col'><b>" . $sistema->retTranslate( "board" ) . "</b></th>";
                $buffer .= "<th rowspan='2' class='serial' scope='col'><b>" . $sistema->retTranslate( "serial" ) . "</b></th>";
                $buffer .= "<th rowspan='2' class='model' scope='col'><b>" . $sistema->retTranslate( "model" ) . "</b></th>";
                $buffer .= "<th rowspan='2' class='status' scope='col'><b>" . $sistema->retTranslate( "status" ) . "</b></th>";
                $buffer .= "<th colspan='3' class='channel' scope='col'><b>" . $sistema->retTranslate( "channel" ) . "</b></th>";
                $buffer .= "<th rowspan='2' class='links' scope='col'><b>" . $sistema->retTranslate( "links" ) . "</b></th>";
                $buffer .= "</tr>";

                $buffer .= "<tr>";
                $buffer .= "<th scope='col'>" . $sistema->retTranslate( "fail" ) . "</th>";
                $buffer .= "<th scope='col'>" . $sistema->retTranslate( "idle" ) . "</th>";
                $buffer .= "<th scope='col'>" . $sistema->retTranslate( "call" ) . "</th>";
                $buffer .= "</tr>";

                for( $i = 0; $i < count( $deviceList ); $i++ )
                {
                    if( ($i % 2) == 0 )
                        $buffer .= "<tr style='background: none repeat scroll 0 0 #FFFFFF;' >";
                    else
                        $buffer .= "<tr style='background: none repeat scroll 0 0 #F5F5F5;' >";

                    $serial = $deviceList[$i]["serial"];
                    $buffer .= "<td id=\"board-" . $serial . "\" >";
                    $buffer .= $deviceList[$i]["board"];
                    $buffer .= "</td>";

                    $buffer .= "<td id=\"serial-" . $serial . "\" >";
                    $buffer .= $deviceList[$i]["serial"];
                    $buffer .= "</td>";

                    $buffer .= "<td id=\"modelo-" . $serial . "\">";
                    $buffer .= $sistema->retTranslate( $deviceList[$i]["model"] );
                    $buffer .= "</td>";

                    $status = $deviceList[$i]["status"];
                    $buffer .= "<td id=\"status-" . $serial . "\">";
                    $buffer .= "<b>" . $status . "</b>";
                    $buffer .= "</td>";

                    $buffer .= "<td id=\"channels-" . $serial . "-fail" . "\">";
                    if( count( $deviceList[$i]["channels"] ) == 0 )
                        $buffer .= '-';
                    else
                    {
                        $fail = $deviceList[$i]["channels"]["fail"];
                        $buffer .= "<span id=\"channels-" . $serial . "-" . "fail" . "\" >";
                        $buffer .= "<b>" . $fail . "</b>";
                        $buffer .= "</span>";
                        $buffer .= "</br>";
                    }
                    $buffer .= "</td>";
                    $buffer .= "<td id=\"channels-" . $serial . "-idle" . "\">";
                    if( count( $deviceList[$i]["channels"] ) == 0 )
                        $buffer .= '-';
                    else
                    {
                        $idle = $deviceList[$i]["channels"]["idle"];
                        $buffer .= "<span id=\"channels-" . $serial . "-" . "idle" . "\" >";
                        $buffer .= "<b>" . $idle . "</b>";
                        $buffer .= "</span>";
                        $buffer .= "</br>";
                    }
                    $buffer .= "</td>";

                    $buffer .= "<td id=\"channels-" . $serial . "-call" . "\">";
                    if( count( $deviceList[$i]["channels"] ) == 0 )
                        $buffer .= '-';
                    else
                    {
                        $call = $deviceList[$i]["channels"]["call"];
                        $buffer .= "<span id=\"channels-" . $serial . "-" . "call" . "\" >";
                        $buffer .= "<b>" . $call . "</b>";
                        $buffer .= "</span>";
                        $buffer .= "</br>";
                    }
                    $buffer .= "</td>";

                    $buffer .= "<td id=\"links-" . $serial . "\">";
                    if( count( $deviceList[$i]["links"] ) == 0 )
                        $buffer .= " - ";
                    else
                    {
                        foreach( $deviceList[$i]["links"] as $key => $value )
                        {
                            $buffer .= "<span id=\"links-" . $serial . "-link-" . $key . "\">";
                            $lnk = $deviceList[$i]['type'] != 24 ? "Link " . $key . " : " : 'Link ' . MonitorDevice::getRX( $key ) . ' : ';
                            $buffer .= $lnk;
                            $buffer .= "<b>" . $value['status'] . "</b>";
                            $buffer .= "</br>";
                            $buffer .= "</span>";
                        }
                    }
                    $buffer .= "</tr>";
                }
                $buffer .= "</table>";
                $buffer .= "</div>";
                $buffer .= "</br>";
            }
            else
            {
                $buffer .= $sistema->retTranslate( "noDevice" );
            }

            return $buffer;
        }

        public static function getRX( $pos )
        {

            switch($pos)
            {
                case 0:
                    return '0 Rx0 ';
                case 1:
                    return '0 Rx1 ';
                case 2:
                    return '1 Rx0 ';
                case 3:
                    return '1 Rx1 ';
            }
        }

    }
?>